2009-02-23  Thiago Macieira  <thiago.macieira@nokia.com>

        Reviewed by Simon Hausmann.

        Fix the Copyright notices in a few files

        * platform/qt/RenderThemeQt.h:

2008-12-13  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by NOBODY (OOPS!).

        The Qt API exposes a global history patch CSSStyleSelector to make API consumers work again

        https://bugs.webkit.org/show_bug.cgi?id=20952

        The QtWebKit port made the mistake of exposing a global history. This broke
        with the addition of PageGroup and LinkHash. This needs to be repaired
        for Qt4.5.

        Add a function to LinkHash.cpp that is resolving a URL. Use this
        function from within CSSStyleSelector to forward the url to the
        QWebHistoryInterface API.

        It is sad that there is a path within visitedLinkHash which is now
        doing a memcpy, it is sad to add a PLATFORM(QT) define to CSSStyleSelector
        and using QtWebKit types within WebCore is a layering violation as well.

        PageGroup::setShouldTrackVisitedLinks is currently not enabled. For
        Qt4.6 a second version of the QWebHistoryInterface is going to be
        added which will fix things up.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::SelectorChecker::checkPseudoState):
        * platform/LinkHash.cpp:
        (WebCore::visitedURL):
        (WebCore::visitedLinkHash):
        * platform/LinkHash.h:

2009-02-13  Prasanth Ullattil  <pullatti@trolltech.com>

        Reviewed by Simon Hausmann.

        Fixes crash in the Qt port on Windows with comboboxes

        The focusWidget in the input context is not reset properly.
        The QApplication::setFocusWidget() wont reset the IC if the reason is
        PopupFocusReason, this is not ideal. For the time being we are going
        to do this from webkit itself.

        * platform/qt/QWebPopup.cpp:
        (WebCore::QWebPopup::hidePopup):

2009-02-07  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        For the Qt port implement Image::drawPattern via
        BitmapImage::drawPatterns' implementation and implement
        Gradient::fill.

        This partially fixes rendering of generated gradient content.

        * platform/graphics/BitmapImage.h: Remove the drawPattern
        implementation for the Qt port in BitmapImage, it's been moved to
        Image::drawPattern.
        * platform/graphics/qt/GradientQt.cpp:
        (WebCore::Gradient::fill): Implement using a simple fillRect.
        * platform/graphics/qt/ImageQt.cpp:
        (WebCore::Image::drawPattern): Moved implementation from
        BitmapImage::drawPattern.

2009-02-06  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Added support for different ownership models for wrapped QObjects in
        the JavaScript environment.

        * bindings/js/ScriptControllerQt.cpp:
        (WebCore::ScriptController::createScriptInstanceForWidget): Specify
        QtOwnership for scriptable widgets.
        * bridge/npruntime_internal.h: Add "NormalState" to the list of
        undef'ed macros as an included Qt header uses "NormalState" as value
        in an enum.
        * bridge/qt/qt_instance.cpp:
        (JSC::Bindings::QtInstance::QtInstance): Save and initialize ownership
        member.
        (JSC::Bindings::QtInstance::~QtInstance): Respect
        QScriptEngine::ValueOwnership policy with regards to wrapped m_object.
        (JSC::Bindings::QtInstance::getQtInstance): Pass the ownership down to
        the instance.
        * bridge/qt/qt_instance.h:
        (JSC::Bindings::QtInstance::create): Ditto.
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertQVariantToValue): Use QtOwnership for
        automatically wrapped QObjects.
        (JSC::Bindings::QtConnectionObject::execute): Ditto.

2009-02-04  Trenton Schulz <trenton.schulz@nokia.com>

        Reviewed by Simon Hausmann.

        Fix implementation of PluginViewMac::invalidateRect to update only the
        specified rect, not the entire browser window.

        * plugins/mac/PluginViewMac.cpp:
        (WebCore::PluginView::invalidateRect):

2009-02-03  Adam Treat  <adam.treat@torchmobile.com>

        Fix the Qt build after r40536.

        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertQVariantToValue):

2009-02-03  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Fix conversion of QByteArray to JavaScript and back. Instead of
        converting it to a String (data loss!) we now map it to JSByteArray.

        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::):
        (JSC::Bindings::valueRealType): Added JSByteArray as converstion type.
        (JSC::Bindings::convertValueToQVariant): Convert from JSByteArray to
        QVariant(QByteArray).
        (JSC::Bindings::convertQVariantToValue): Convert from
        QVariant::ByteArray to jsByteArray.

2009-01-30  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Simon Hausmann.

        Bug 23580: GNU mode RVCT compilation support
        <https://bugs.webkit.org/show_bug.cgi?id=23580>

        * html/PreloadScanner.cpp: Use COMPILER(GCC) instead of __GNUC__.

2009-01-28  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon Hausmann.

        [Qt] Speed-up clipping: avoid calling expensive QPainter::clipRegion().
        Beside, the check is not necessary since QPainter::setClipRect() will
        work just fine if there is no clip region yet.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::clip):

2009-01-27  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Rubber-stamped by Simon Hausmann.

        http://www.qtsoftware.com/developer/task-tracker/index_html?id=238662&method=entry

        [Qt] Map function keys F1 to F24.

        * platform/qt/PlatformKeyboardEventQt.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):

2009-01-23  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by Holger Hans Peter Freyther.

        Redo previous patch http://trac.webkit.org/changeset/34260 which fixes a
        huge memory leak by ensuring that the timer is fired one last time on
        application tear down thus triggering the GCController thereby freeing
        JavaScript objects as well as triggering other timer based tear down methods.

        * platform/qt/SharedTimerQt.cpp:
        (WebCore::SharedTimerQt::~SharedTimerQt):

2009-01-09  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        [QT] Make SharedTimer use QBasicTimer

        Kill the SharedTimerQt.h and the usage of signal and slots
        by using QBasicTimer.

        * WebCore.pro:
        * platform/qt/SharedTimerQt.cpp:
        (WebCore::SharedTimerQt::SharedTimerQt):
        (WebCore::SharedTimerQt::inst):
        (WebCore::SharedTimerQt::start):
        (WebCore::SharedTimerQt::stop):
        (WebCore::SharedTimerQt::timerEvent):
        (WebCore::setSharedTimerFiredFunction):
        (WebCore::setSharedTimerFireTime):
        (WebCore::stopSharedTimer):
        * platform/qt/SharedTimerQt.h: Removed.

2009-01-25  Thiago Macieira  <thiago.macieira@nokia.com>

        Reviewed by Simon Hausmann.

        Fix gcc compiler warning (deprecated conversion from constant string to char*)

        "" cannot be stored in a char*

        * plugins/PluginStream.cpp:
        (WebCore::PluginStream::destroyStream):

2009-01-23  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon Hausmann.

        Bug 23475: fast/text/find-backwards.html fails with ICU disabled SearchBuffer
        https://bugs.webkit.org/show_bug.cgi?id=23475

        * editing/TextIterator.cpp:
        (WebCore::SearchBuffer::search): Set the character start flag to false to
        ensure we won't ever return the same result twice. There are other ways we
        could accomplish this, mentioned in the comment, but this one was the smallest
        and cleanest I could think of.

2009-01-23  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        [Qt] Simplify the assertion.

        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::getWindowsContext):
        (WebCore::GraphicsContext::releaseWindowsContext):

2009-01-19  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        [Qt] Build fix after r39971.

        * platform/qt/LoggingQt.cpp:
        (WebCore::InitializeLoggingChannelsIfNecessary):

2009-01-19  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Simon Hausmann.

        http://www.qtsoftware.com/developer/task-tracker/index_html?id=211228&method=entry

        [Qt] Show focus rect when a button gets the focus for the first time.
        This is important at least for Windows style.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::applyTheme):

2009-01-16  Dan Bernstein  <mitz@apple.com>

        Reviewed by Kevin Decker and Adam Roben.

        - fix a regression that resulted in a crash when plug-ins were
          disabled.

        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::updateWidget): Added a null check.

2009-01-16  Thiago Macieira  <thiago.macieira@nokia.com>

        Reviewed by Simon Hausmann.

        [Qt] Fixes QString and 8-bit mix fixes.

        Details:  Make sure we use QLatin1String where appropriate (and don't
        use QString when not necessary)

        * platform/graphics/qt/ImageDecoderQt.cpp:
        (WebCore::ImageDecoderQt::create):
        * platform/graphics/qt/SimpleFontDataQt.cpp:
        (WebCore::SimpleFontData::platformInit):
        * platform/qt/FileSystemQt.cpp:
        (WebCore::openTemporaryFile):
        * platform/qt/LoggingQt.cpp:
        (WebCore::InitializeLoggingChannelsIfNecessary):
        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::extraMediaControlsStyleSheet):
        * plugins/qt/PluginDataQt.cpp:
        (WebCore::PluginData::initPlugins):

2009-01-16  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=22452

        When plugins are disabled, plugin data should not be available for
        the page. This ensures that navigator.plugins would not see the
        additional MIME types supported by the plugins.

        * page/Page.cpp:
        (WebCore::Page::pluginData):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::shouldUsePlugin):
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::updateWidget):

2009-01-09  Darin Adler  <darin@apple.com>

        Reviewed by Jon Honeycutt.

        Bug 22913: REGRESSION: Space bar doesn't scroll on windows
        https://bugs.webkit.org/show_bug.cgi?id=22913
        rdar://problem/6479834

        * page/EventHandler.cpp:
        (WebCore::EventHandler::defaultKeyboardEventHandler): Added code to call
        defaultSpaceEventHandler.
        (WebCore::EventHandler::defaultSpaceEventHandler): Added. Scrolls down or up based
        on the shift key.
        * page/EventHandler.h: Added defaultSpaceEventHandler.

        * platform/mac/ScrollViewMac.mm:
        (WebCore::ScrollView::platformScroll): Return false, because this function does
        not scroll. In an earlier version of this patch, I used this to prevent the
        patch from affecting the Mac, but I decided to use #if instead.

2009-01-14  Alexey Proskuryakov  <ap@webkit.org>

        Release build fix.

        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::storeUpdatedType): Use ASSERT_UNUSED.

2009-01-13  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Anders Carlsson.

        Test: http/tests/appcache/xhr-foreign-resource.html

        https://bugs.webkit.org/show_bug.cgi?id=23256
        Implement application cache foreign entries

        * loader/DocumentLoader.cpp: (WebCore::DocumentLoader::shouldLoadResourceFromApplicationCache):
        Removed a misplaced check for foreign resources that prevented them from being loaded altogether.

        * loader/appcache/ApplicationCacheGroup.cpp: (WebCore::ApplicationCacheGroup::selectCache):
        If a document that was loaded from appcache should be associated with a different cache,
        mark the resource as foreign in the original cache and start over.

        * loader/appcache/ApplicationCacheResource.cpp: (WebCore::ApplicationCacheResource::addType):
        This function can now be called after a cache is stored, so it no longer asserts the opposite.

        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::cacheGroupForURL): Fix database pass to correctly ignore
        in-memory caches that were already rejected.
        (WebCore::ApplicationCacheStorage::fallbackCacheGroupForURL): Ditto.
        (WebCore::ApplicationCacheStorage::storeUpdatedType): Added a function that updates type of
        an already stored cached resource.

        * loader/appcache/ApplicationCacheStorage.h: Added storeUpdatedType().

2009-01-13  Eric Seidel  <eric@webkit.org>

        Reviewed by Mark Rowe.

        Speculative fix for an Uninitialized Memory Read (UMR)
        seen by purify in chormium's equivalent V8 file.

        * bindings/js/JSSVGPODTypeWrapper.h:
        (WebCore::PODTypeWrapperCacheInfo::PODTypeWrapperCacheInfo):

2009-01-13  Christian Dywan  <christian@twotoasts.de>

        Build fix, StorageEvent is only defined if we have DOM_STORAGE

        * dom/Document.cpp:
        (WebCore::Document::createEvent): Conditionalize StorageEvent

2009-01-13  Darin Adler  <darin@apple.com>

        Reviewed by Adele Peterson.

        Bug 23277: space bar scrolls the page when typed in any text field
        https://bugs.webkit.org/show_bug.cgi?id=23277
        rdar://problem/6490249

        There's already a regression test for this, since bug 16421 was the same problem, but on
        Mac. The regression test is fast/events/space-scroll-event.html, so I won't write a new one.

        This bug doesn't affect Mac because the canEdit check in -[WebHTMLView insertText:] prevents
        a text input event from being generated at all. That difference may in itself be a bug, but
        the only symptom is that you get text input events in more cases on platforms other than Mac.

        * page/EventHandler.cpp:
        (WebCore::EventHandler::handleTextInputEvent): Return whether the event's default was
        handled, not the result of the dispatchEvent function, which indicates only whether the
        default behavior was prevented, not if the default behavior did some insertion. This fix
        makes it so the keyboard event handler can detect that no space was inserted and know that
        the space bar keypress event can be treated as a scrolling command.
        (WebCore::EventHandler::defaultKeyboardEventHandler): Handle the keypress event, not the
        keydown event. Without the change above, making this change would have restored the old
        behavior, reintroducing bug 22913 where the space bar doesn't scroll at all on Windows.

2009-01-12  Robert Blaut  <webkit@blaut.biz>

        Reviewed by Darin Adler

        Fix for <https://bugs.webkit.org/show_bug.cgi?id=22096>
        Bug 22096: REGRESSION (r35879) scrolldelay is counted in seconds 
        instead of miliseconds

        Test: fast/css/webkit-marquee-speed-unit-in-quirksmode.html

        * css/CSSParser.cpp:
        (WebCore::CSSParser::validUnit): treat unitless values in quirks mode 
        as miliseconds instead of seconds.

2009-01-13  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Fix crash in the Qt port when deleting a popup from within a
        JavaScript onchange handler.

        * platform/qt/QWebPopup.cpp:
        (WebCore::QWebPopup::QWebPopup): Perform the activation of the
        combobox item (i.e. the call to the JS handler) from a different
        call stack by using a queued connection.

2009-01-13  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        [Qt] Make sure media elements dispatch the 'loaded' event
        
        We assume that when Phonon goes into paused state that we have the
        complete media file. Once we do media loading ourselves we can
        distinguish between loading the first frame and the complete media.

        * platform/graphics/qt/MediaPlayerPrivatePhonon.cpp:
        (WebCore::MediaPlayerPrivate::updateStates):

2009-01-13  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        [Qt] Add more verbose error output when loading NPAPI plugins

        * plugins/qt/PluginPackageQt.cpp:
        (WebCore::PluginPackage::load):

2009-01-13  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        Change how themes adjust mediaControls.css to match html4/quicks.css
        
        Instead of providing the full style sheet, the themes provide extra
        overrides to the default style defined in UserAgentStyleSheetsData.
        
        https://bugs.webkit.org/show_bug.cgi?id=23210
        
        Also, merge WebKitResources.qrc and WebCoreResources.qrc to speed up
        build time for the Qt port.

        * Resources/WebKitResources.qrc: Removed. Merged into WebCore.qrc
        * WebCore.pro:
        * WebCore.qrc: Added.
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::styleForElement):
        * css/qt/mediaControls-extras.css: Rename from html4-adjustments-qt.css
        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::extraMediaControlsStyleSheet):
        * platform/qt/RenderThemeQt.h:
        * platform/qt/WebCoreResources.qrc: Removed.
        * platform/qt/html4-adjustments-qt.css: Rename to mediaControls-extras.css
        * rendering/RenderTheme.cpp:
        * rendering/RenderTheme.h:
        (WebCore::RenderTheme::extraMediaControlsStyleSheet):

2009-01-10  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=23210
        Make it easier for ports to define custom UI for media controls

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::styleForElement): call theme()->styleSheetForMediaControls to
        get the media controller style sheet 

        * rendering/MediaControlElements.cpp:
        (WebCore::MediaControlInputElement::hitTest): Added
        * rendering/MediaControlElements.h: Updated

        * rendering/RenderMedia.cpp:
        (WebCore::RenderMedia::forwardEvent): Call element hitTest() method instead of local function
        so control elements don't necessarily have to be rectangular

        * rendering/RenderTheme.cpp:
        (WebCore::RenderTheme::styleSheetForMediaControls):  Added
        (WebCore::RenderTheme::hitTestMediaControlPart):  Added
        * rendering/RenderTheme.h: Updated

2009-01-12  Kevin Ollivier  <kevino@theolliviers.com>

        !ENABLE(SVG_FONTS) build fix. Move defaultUnitsPerEm into a non-SVG header
        so it can be used by all builds.
        
        * platform/graphics/Font.h:
        * platform/graphics/SimpleFontData.cpp:
        * svg/SVGFontFaceElement.cpp:
        * svg/SVGFontFaceElement.h:

2008-01-12  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22936
        Fix uninitialized memory read error, reported by Purify.

        * platform/graphics/SimpleFontData.cpp:
        (WebCore::SimpleFontData::SimpleFontData): Added initializer for
            m_unitsPerEm using cDefaultUnitsPerEm constant.
        * svg/SVGFontFaceElement.cpp:
        (WebCore::SVGFontFaceElement::unitsPerEm): Replaced literal value with
            the constant.
        * svg/SVGFontFaceElement.h: Added cDefaultUnitsPerEm constant.

2009-01-12  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by George Staikos.

        Do not set fixedLayoutSize for anything other than the mainframe during
        the transition as this is a page level state like the viewportSize.

        * loader/FrameLoaderClient.cpp:
        (WebCore::FrameLoaderClient::transitionToCommittedForNewPage):

2009-01-09  Simon Hausmann  <simon.hausmann@nokia.com>

        Rubber-stamped by Tor Arne Vestbø.

        Swap the .h and the .cpp output in the Qt build for the
        UserAgentStyleSheetData files, to put the definition in the .cpp file
        and the declaration in the header file.

        * WebCore.pro:

2009-01-09  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        Prevent qmake from generating duplicate rules for embedded stylesheets
        
        The STYLESHEETS_EMBED variable used to contain only one file name, but
        now that it is a list of files we need to change it to be a dependency
        for the stylesheet generator instead of the input.

        * WebCore.pro:

2009-01-09  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Fix qmake warning about missing test function, a contains() call was
        missing.

        * WebCore.pro:

2009-01-09  Simon Hausmann  <simon.hausmann@nokia.com>

        Rubber-stamped by Tor Arne Vestbø.

        Add the Qt API headers to HEADERS, too, for improved completion in IDEs.

        * WebCore.pro:

2009-01-09  David Levin  <levin@chromium.org>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=23199

        Fix deref's of string happening on two different threads.

        No observable change in behavior, so no test.  However, there are asserts
        being added for https://bugs.webkit.org/show_bug.cgi?id=23175 which
        will detect this issue while running the normal worker tests.

        * dom/WorkerThread.cpp:
        (WebCore::WorkerThreadStartupData::create):
        (WebCore::WorkerThreadStartupData::WorkerThreadStartupData):
        (WebCore::WorkerThread::WorkerThread):
        (WebCore::WorkerThread::workerThread):
        * dom/WorkerThread.h:

2009-01-08  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adam Roben.

        - use native glyph support in Core Graphics when available

        * platform/graphics/win/FontCGWin.cpp:
        (WebCore::Font::drawGlyphs): Changed to use drawGDIGlyphs() only if
        native glyph support is not available or stroking is required. Changed
        to pass the font's useGDI() flag to wkSetCGContextFontRenderingStyle to
        request the use of native glyphs.
        * platform/graphics/win/FontCustomPlatformData.cpp:
        (WebCore::FontCustomPlatformData::fontPlatformData): Added a call to
        wkSetFontPlatformInfo to attach the LOGFONT to the CGFont.
        * platform/graphics/win/FontPlatformDataCGWin.cpp:
        (WebCore::FontPlatformData::platformDataInit): Ditto.

2009-01-08  Peter Kasting  <pkasting@google.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=22929
        Fix memory regression when decoding large animated GIFs.

        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::clear):

2009-01-08  Scott Violet  <sky@chromium.org>

        Reviewed by Eric Seidel (and Adam Barth).

        Fix Images to return their file extension
        http://code.google.com/p/chromium/issues/detail?id=5827

        * platform/graphics/skia/ImageSourceSkia.cpp:
        (WebCore::ImageSource::filenameExtension):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add PathSkia and PatternSkia implementations to WebCore
        https://bugs.webkit.org/show_bug.cgi?id=23200

        * platform/graphics/skia/PathSkia.cpp: Added.
        (WebCore::Path::Path):
        (WebCore::Path::~Path):
        (WebCore::Path::operator=):
        (WebCore::Path::isEmpty):
        (WebCore::Path::contains):
        (WebCore::Path::translate):
        (WebCore::Path::boundingRect):
        (WebCore::Path::moveTo):
        (WebCore::Path::addLineTo):
        (WebCore::Path::addQuadCurveTo):
        (WebCore::Path::addBezierCurveTo):
        (WebCore::Path::addArcTo):
        (WebCore::Path::closeSubpath):
        (WebCore::Path::addArc):
        (WebCore::Path::addRect):
        (WebCore::Path::addEllipse):
        (WebCore::Path::clear):
        (WebCore::convertPathPoints):
        (WebCore::Path::apply):
        (WebCore::Path::transform):
        (WebCore::Path::debugString):
        (WebCore::boundingBoxForCurrentStroke):
        (WebCore::Path::strokeBoundingRect):
        * platform/graphics/skia/PatternSkia.cpp: Added.
        (WebCore::shaderRule):
        (WebCore::Pattern::createPlatformPattern):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add ImageSourceSkia to platform/graphics/skia
        https://bugs.webkit.org/show_bug.cgi?id=23200
        
        ImageSourceSkia is mostly a hack to support our
        ICO decoder model.  See ImageSourceSkia.h for more
        explanation.  Eventually we'd like to make our ICO
        decoder lazy.

        * platform/graphics/ImageSource.h: mark m_decoder as protected
        * platform/graphics/skia/ImageSourceSkia.cpp: Added.
        (WebCore::createDecoder):
        (WebCore::ImageSource::ImageSource):
        (WebCore::ImageSource::~ImageSource):
        (WebCore::ImageSource::clear):
        (WebCore::ImageSource::initialized):
        (WebCore::ImageSource::setData):
        (WebCore::ImageSource::isSizeAvailable):
        (WebCore::ImageSource::size):
        (WebCore::ImageSource::frameSizeAtIndex):
        (WebCore::ImageSource::repetitionCount):
        (WebCore::ImageSource::frameCount):
        (WebCore::ImageSource::createFrameAtIndex):
        (WebCore::ImageSource::frameIsCompleteAtIndex):
        (WebCore::ImageSource::frameDurationAtIndex):
        (WebCore::ImageSource::frameHasAlphaAtIndex):
        (WebCore::ImageSourceSkia::setData):
        (WebCore::ImageSource::filenameExtension):
        * platform/graphics/skia/ImageSourceSkia.h: Added.

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add NativeImageSkia (PlatformImagePtr) to platform/graphics/skia
        https://bugs.webkit.org/show_bug.cgi?id=23200

        * platform/graphics/skia/NativeImageSkia.cpp: Added.
        (NativeImageSkia::NativeImageSkia):
        (NativeImageSkia::decodedSize):
        (NativeImageSkia::hasResizedBitmap):
        (NativeImageSkia::resizedBitmap):
        (NativeImageSkia::shouldCacheResampling):
        * platform/graphics/skia/NativeImageSkia.h: Added.
        (NativeImageSkia::setDataComplete):
        (NativeImageSkia::isDataComplete):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add ImageBufferSkia and ImageSkia files.
        https://bugs.webkit.org/show_bug.cgi?id=23200
        For now we've left BitmapImage and BitmapImageSingleFrameSkia
        implementations in the ImageSkia file (like ImageCG has), but
        we intend to break them out into their own files.

        * platform/graphics/skia/ImageBufferSkia.cpp: Added.
        (WebCore::ImageBufferData::ImageBufferData):
        (WebCore::ImageBuffer::ImageBuffer):
        (WebCore::ImageBuffer::~ImageBuffer):
        (WebCore::ImageBuffer::context):
        (WebCore::ImageBuffer::image):
        (WebCore::ImageBuffer::getImageData):
        (WebCore::ImageBuffer::putImageData):
        (WebCore::ImageBuffer::toDataURL):
        * platform/graphics/skia/ImageSkia.cpp: Added.
        (WebCore::):
        (WebCore::FrameData::clear):
        (WebCore::Image::loadPlatformResource):
        (WebCore::Image::drawPattern):
        (WebCore::BitmapImage::initPlatformData):
        (WebCore::BitmapImage::invalidatePlatformData):
        (WebCore::BitmapImage::checkForSolidColor):
        (WebCore::BitmapImage::draw):
        (WebCore::BitmapImageSingleFrameSkia::draw):
        (WebCore::BitmapImageSingleFrameSkia::create):

2009-01-08  James Robinson  <jamesr@google.com>

        Reviewed by Mark Rowe.
        Landed by Pamela Greene.

        WebCore::Event::timeStamp() is a simple accessor and should be const

        https://bugs.webkit.org/show_bug.cgi?id=23176

        * dom/Event.h:
        (WebCore::Event::timeStamp):

2009-01-08  Antti Koivisto  <antti@apple.com>

        Reviewed by Oliver Hunt.

        Fix <rdar://problem/6467206> 
        Resources loaded from the memory cache do not get correctly inserted into the DocLoader resource map (22994)
        
        Use CachedResourceHandle in document resource map so resources get updated correctly when using
        using cache validation conditionals.

        * loader/Cache.cpp:
        (WebCore::Cache::evict):
        * loader/DocLoader.cpp:
        (WebCore::DocLoader::~DocLoader):
        (WebCore::DocLoader::requestResource):
        (WebCore::DocLoader::setAutoLoadImages):
        (WebCore::DocLoader::removeCachedResource):
        * loader/DocLoader.h:
        (WebCore::DocLoader::cachedResource):
        (WebCore::DocLoader::allCachedResources):
        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::getSubresources):
        * loader/ImageLoader.cpp:
        (WebCore::ImageLoader::updateFromElement):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add a cleaned-up GraphicsContextSkia implementation to WebKit.
        https://bugs.webkit.org/show_bug.cgi?id=23191

        * platform/graphics/skia/GraphicsContextSkia.cpp: Added.
        (WebCore::):
        (WebCore::GraphicsContext::GraphicsContext):
        (WebCore::GraphicsContext::~GraphicsContext):
        (WebCore::GraphicsContext::platformContext):
        (WebCore::GraphicsContext::savePlatformState):
        (WebCore::GraphicsContext::restorePlatformState):
        (WebCore::GraphicsContext::beginTransparencyLayer):
        (WebCore::GraphicsContext::endTransparencyLayer):
        (WebCore::GraphicsContext::addInnerRoundedRectClip):
        (WebCore::GraphicsContext::addPath):
        (WebCore::GraphicsContext::beginPath):
        (WebCore::GraphicsContext::clearPlatformShadow):
        (WebCore::GraphicsContext::clearRect):
        (WebCore::GraphicsContext::clip):
        (WebCore::GraphicsContext::clipOut):
        (WebCore::GraphicsContext::clipOutEllipseInRect):
        (WebCore::GraphicsContext::clipPath):
        (WebCore::GraphicsContext::clipToImageBuffer):
        (WebCore::GraphicsContext::concatCTM):
        (WebCore::GraphicsContext::drawConvexPolygon):
        (WebCore::GraphicsContext::drawEllipse):
        (WebCore::GraphicsContext::drawFocusRing):
        (WebCore::GraphicsContext::drawLine):
        (WebCore::GraphicsContext::drawLineForMisspellingOrBadGrammar):
        (WebCore::GraphicsContext::drawLineForText):
        (WebCore::GraphicsContext::drawRect):
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::fillRect):
        (WebCore::GraphicsContext::fillRoundedRect):
        (WebCore::GraphicsContext::getCTM):
        (WebCore::GraphicsContext::roundToDevicePixels):
        (WebCore::GraphicsContext::scale):
        (WebCore::GraphicsContext::setAlpha):
        (WebCore::GraphicsContext::setCompositeOperation):
        (WebCore::GraphicsContext::setImageInterpolationQuality):
        (WebCore::GraphicsContext::setLineCap):
        (WebCore::GraphicsContext::setLineDash):
        (WebCore::GraphicsContext::setLineJoin):
        (WebCore::GraphicsContext::setMiterLimit):
        (WebCore::GraphicsContext::setPlatformFillColor):
        (WebCore::GraphicsContext::setPlatformShadow):
        (WebCore::GraphicsContext::setPlatformStrokeColor):
        (WebCore::GraphicsContext::setPlatformStrokeStyle):
        (WebCore::GraphicsContext::setPlatformStrokeThickness):
        (WebCore::GraphicsContext::setPlatformTextDrawingMode):
        (WebCore::GraphicsContext::setURLForRect):
        (WebCore::GraphicsContext::setUseAntialiasing):
        (WebCore::GraphicsContext::strokeArc):
        (WebCore::GraphicsContext::strokePath):
        (WebCore::GraphicsContext::strokeRect):
        (WebCore::GraphicsContext::rotate):
        (WebCore::GraphicsContext::translate):

2009-01-08  David Hyatt  <hyatt@apple.com>

        Fix for <rdar://problem/6465682> REGRESSION: In Mail, can't force a message to auto scroll.

        Make scrollRectIntoViewRecursively call out to the HostWindow to continue the recursive scroll for
        any scrollable views that may contain a WebView.  Does nothing on platforms other than the Mac, but
        might eventually be of interest to other platforms.

        Reviewed by Oliver Hunt

        * WebCore.base.exp:
        * page/Chrome.cpp:
        (WebCore::Chrome::scrollRectIntoView):
        * page/Chrome.h:
        * page/ChromeClient.h:
        (WebCore::ChromeClient::scrollRectIntoView):
        * platform/HostWindow.h:
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::scrollRectIntoViewRecursively):

2009-01-08  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by David Hyatt.

        No need to make this part of HostWindow and moreover HostWindow should
        not have any reference to non-platform parts of WebCore.

        * page/Chrome.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::setContentsSize):
        * platform/HostWindow.h:

2009-01-08  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Adele Peterson.

        Simplify Mac interfaces for drawing media controller elements

        <rdar://problem/6293969>

        * WebCore.base.exp: update for changed WebKitSystemInterface media controller functions

        * platform/mac/WebCoreSystemInterface.h: Ditto
        * platform/mac/WebCoreSystemInterface.mm: Ditto

        * rendering/MediaControlElements.h:
        (WebCore::): Add MediaControlElements enum

        * rendering/RenderThemeMac.mm:
        (WebCore::RenderThemeMac::paintMediaFullscreenButton):  update for changed WebKitSystemInterface
        media controller functions
        (WebCore::RenderThemeMac::paintMediaMuteButton): Ditto
        (WebCore::RenderThemeMac::paintMediaPlayButton): Ditto
        (WebCore::RenderThemeMac::paintMediaSeekBackButton): Ditto
        (WebCore::RenderThemeMac::paintMediaSeekForwardButton): Ditto
        (WebCore::RenderThemeMac::paintMediaSliderTrack): Ditto
        (WebCore::RenderThemeMac::paintMediaSliderThumb): Ditto

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add two more files for platform/graphics/skia.
        https://bugs.webkit.org/show_bug.cgi?id=23191

        * platform/graphics/skia/GradientSkia.cpp: Added.
        (WebCore::Gradient::platformDestroy):
        (WebCore::F2B):
        (WebCore::makeSkColor):
        (WebCore::totalStopsNeeded):
        (WebCore::fillStops):
        (WebCore::compareStops):
        (WebCore::Gradient::platformGradient):
        (WebCore::Gradient::fill):
        * platform/graphics/skia/GraphicsContextPlatformPrivate.h: Copied from WebCore/bindings/js/ScriptValue.h.
        (WebCore::GraphicsContextPlatformPrivate::GraphicsContextPlatformPrivate):
        (WebCore::GraphicsContextPlatformPrivate::context):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Commit the right files this time!  (Instead of the ugly unfixed ones.)
        https://bugs.webkit.org/show_bug.cgi?id=23191

        * platform/graphics/skia/BitmapImageSingleFrameSkia.h:
        * platform/graphics/skia/FloatPointSkia.cpp:
        * platform/graphics/skia/FloatRectSkia.cpp:
        * platform/graphics/skia/IntPointSkia.cpp:
        * platform/graphics/skia/IntRectSkia.cpp:
        (WebCore::IntRect::operator SkRect):
        * platform/graphics/skia/SkiaUtils.cpp:
        (WebCore::):
        (WebCore::WebCoreCompositeToSkiaComposite):
        (WebCore::SkPMColorToWebCoreColor):
        (WebCore::IntersectRectAndRegion):
        (WebCore::ClipRectToCanvas):
        (WebCore::SkPathContainsPoint):
        (WebCore::scratchContext):
        * platform/graphics/skia/SkiaUtils.h:
        (WebCore::WebCoreFloatToSkScalar):
        (WebCore::WebCoreDoubleToSkScalar):

2009-01-08  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Eric Seidel.

        Add the first few files from platform/graphics/skia
        https://bugs.webkit.org/show_bug.cgi?id=23191

        These are all pretty simple.
        Eventually BitmapImageSingleFrameSkia might grow a .cpp file, for now it's just a header.
        SkiaUtils needs to die, but that can come later, no need to block up-streaming now.

        * platform/graphics/skia/BitmapImageSingleFrameSkia.h: Added.
        (WebCore::BitmapImageSingleFrameSkia::isBitmapImage):
        (WebCore::BitmapImageSingleFrameSkia::size):
        (WebCore::BitmapImageSingleFrameSkia::destroyDecodedData):
        (WebCore::BitmapImageSingleFrameSkia::decodedSize):
        (WebCore::BitmapImageSingleFrameSkia::nativeImageForCurrentFrame):
        (WebCore::BitmapImageSingleFrameSkia::BitmapImageSingleFrameSkia):
        * platform/graphics/skia/FloatPointSkia.cpp: Copied from WebCore/platform/graphics/mac/FloatPointMac.mm.
        (WebCore::FloatPoint::FloatPoint):
        (WebCore::FloatPoint::operator SkPoint):
        * platform/graphics/skia/FloatRectSkia.cpp: Copied from WebCore/platform/graphics/qt/IntRectQt.cpp.
        (WebCore::FloatRect::FloatRect):
        (WebCore::FloatRect::operator SkRect):
        * platform/graphics/skia/IntPointSkia.cpp: Copied from WebCore/platform/graphics/win/IntPointWin.cpp.
        (WebCore::IntPoint::IntPoint):
        (WebCore::IntPoint::operator SkIPoint):
        (WebCore::IntPoint::operator SkPoint):
        * platform/graphics/skia/IntRectSkia.cpp: Copied from WebCore/platform/graphics/qt/IntRectQt.cpp.
        (WebCore::IntRect::operator SkIRect):
        (WebCore::IntRect::operator SkRect):
        (WebCore::IntRect::IntRect):
        * platform/graphics/skia/SkiaUtils.cpp: Added.
        (WebCore::WebCorePointToSkiaPoint):
        (WebCore::WebCoreRectToSkiaRect):
        (WebCore::):
        (WebCore::WebCoreCompositeToSkiaComposite):
        (WebCore::InvScaleByte):
        (WebCore::SkPMColorToColor):
        (WebCore::SkPMColorToWebCoreColor):
        (WebCore::IntersectRectAndRegion):
        (WebCore::ClipRectToCanvas):
        (WebCore::SkPathContainsPoint):
        (WebCore::scratchContext):
        * platform/graphics/skia/SkiaUtils.h: Added.
        (WebCore::WebCoreFloatToSkScalar):
        (WebCore::WebCoreDoubleToSkScalar):

2009-01-08  Pierre-Olivier Latour  <pol@apple.com>

        Reviewed by Dan Bernstein.

        Fixed CSS Transitions with zero-duration but non-zero-delay not starting or ending properly.

        Also updated AnimationController::numberOfActiveAnimations() which now returns the number of "active" animations,
        instead of simply the "running" ones.

        https://bugs.webkit.org/show_bug.cgi?id=23177

        Tests: transitions/zero-duration-with-non-zero-delay-end.html
               transitions/zero-duration-with-non-zero-delay-start.html

        * page/animation/AnimationBase.cpp:
        (WebCore::AnimationBase::fireAnimationEventsIfNeeded):
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationControllerPrivate::animationTimerFired):
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimationPrivate::numberOfActiveAnimations):

2009-01-08  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver Hunt.

        <rdar://problem/6477501> Repro crash loading HTML5 AppCache manifest directly

        The crash happened whenever a cached resource was downloaded, as opposed to used directly.

        No test, as downloading cannot be tested automatically.

        * loader/MainResourceLoader.cpp: (WebCore::MainResourceLoader::continueAfterContentPolicy):
        Cancel downloads that do not have an associated ResourceHandle, such as downloads from the
        application cache. Activity window shows "The URL can't be shown", and the frame remains empty.

2009-01-08  Justin McPherson <justin.mcpherson@nokia.com>

        Reviewed by Simon Hausmann.

        Fix the Qt build on older X11 systems with special X paths.

        * WebCore.pro: Use the x11 qmake config to pull in extra paths
        needed for NPAPI.

2009-01-08  Adam Roben  <aroben@apple.com>

        Windows build fix after r39699

        * DerivedSources.cpp: Added JSDOMStringList.cpp.

2009-01-08  Kent Hansen  <khansen@trolltech.com>

        Reviewed by Simon Hausmann.

        Fix copy & paste of images in the Qt port.

        Store the QPixmap itself in the mimedata, not a QPixmap* converted to bool.

        * platform/qt/ClipboardQt.cpp:
        (WebCore::ClipboardQt::declareAndWriteDragImage):

2009-01-08  Hiroyuki Ikezoe  <poincare@ikezoe.net>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=23127

        Invoke pango_coverage_get with each Unicode character.

        * platform/graphics/gtk/SimpleFontDataPango.cpp:
        (WebCore::SimpleFontData::containsCharacters):

2009-01-07  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        Part one of 
        https://bugs.webkit.org/show_bug.cgi?id=23165
        Add support for application cache dynamic entries

        Test: http/tests/appcache/dynamic-entries-no-cache.html

        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        Added new files.

        * bindings/js/JSDOMApplicationCacheCustom.cpp: (WebCore::JSDOMApplicationCache::hasItem):
        Added binding for hasItem(). Like other DOMApplicationCache methods, it needs to be custom
        to resolve relative URLs correctly.

        * bindings/js/JSDOMStringListCustom.cpp: Added.
        * dom/DOMStringList.cpp: Added.
        * dom/DOMStringList.h: Added.
        * dom/DOMStringList.idl: Added.
        Added an implementation of DOM 3 Core DOMStringList interface, which is returned by
        DOMApplicationCache items attribute.

        * dom/StaticStringList.cpp: Added.
        * dom/StaticStringList.h: Added.
        An implementation of DOMStringList that makes a snapshot (for DOMApplicationCache, this
        matches Firefox, as the spec doesn't say whether the returned list should be live or not).

        * loader/appcache/ApplicationCache.h: Added a list of pending dynamic entry actions, to be
        used in the near future.

        * loader/appcache/DOMApplicationCache.idl: Updated for spec changes. Instead of length 
        attribute and item(), we now have an items attribute that returns a DOMStringList, and a
        hasItem convenience method.

        * loader/appcache/DOMApplicationCache.cpp:
        (WebCore::DOMApplicationCache::items):
        (WebCore::DOMApplicationCache::hasItem):
        * loader/appcache/DOMApplicationCache.h:
        Added implementations of items attribute and hasItem() (note that underlying ApplicationCache
        methods are still unimplemented though).

        * page/DOMWindow.idl: Expose a DOMStringList global constructor.

2009-01-07  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Eric Seidel.

        https://bugs.webkit.org/show_bug.cgi?id=23122

        This completes the removal of dependencies on WebKit from the platform code

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::getDelayValue):
        (WebCore::getDurationValue):
        (WebCore::getTimingFunctionValue):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSHelper.h:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::mapAnimationDelay):
        (WebCore::CSSStyleSelector::mapAnimationDirection):
        (WebCore::CSSStyleSelector::mapAnimationDuration):
        (WebCore::CSSStyleSelector::mapAnimationIterationCount):
        (WebCore::CSSStyleSelector::mapAnimationName):
        (WebCore::CSSStyleSelector::mapAnimationPlayState):
        (WebCore::CSSStyleSelector::mapAnimationProperty):
        (WebCore::CSSStyleSelector::mapAnimationTimingFunction):
        * platform/animation/Animation.cpp:
        (WebCore::Animation::Animation):
        * platform/animation/Animation.h:
        (WebCore::Animation::initialAnimationDelay):
        (WebCore::Animation::initialAnimationDirection):
        (WebCore::Animation::initialAnimationDuration):
        (WebCore::Animation::initialAnimationIterationCount):
        (WebCore::Animation::initialAnimationName):
        (WebCore::Animation::initialAnimationPlayState):
        (WebCore::Animation::initialAnimationProperty):
        (WebCore::Animation::initialAnimationTimingFunction):
        * rendering/style/RenderStyle.h:

2008-01-07  Peter Kasting  <pkasting@google.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=22929

        Fix errors while decoding GIFs by not calling setData() repeatedly
        when it's not necessary.  Pushes the responsibility for calling
        setData() after clear() into the ImageSource which presumably knows
        better than BitmapImage what needs to be done.

        NOTE: The above bug is mainly about a memory regression, which this
        patch does not fix.

        * platform/graphics/BitmapImage.cpp:
        (WebCore::BitmapImage::destroyDecodedData):
        * platform/graphics/ImageSource.h:
        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::ImageSource::clear):
        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::clear):
        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::ImageSource::~ImageSource):
        (WebCore::ImageSource::clear):
        * platform/graphics/wx/ImageSourceWx.cpp:
        (WebCore::ImageSource::~ImageSource):
        (WebCore::ImageSource::clear):

2009-01-07  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Darin Adler.

        <rdar://problem/6355786> Find fails for queries that contain a line break

        * editing/TextIterator.cpp:
        (WebCore::findPlainText): Allow find with queries that contain newlines.

2009-01-07  Dean Jackson  <dino@apple.com>

        Reviewed by Dan Bernstein.

        Allow removal of inline shorthand properties for
        animation, transition and transform origin. Also
        add getter for shorthand animation property.

        https://bugs.webkit.org/show_bug.cgi?id=22605

        Test: fast/css/transform-inline-style-remove.html

        * css/CSSMutableStyleDeclaration.cpp:
        (WebCore::CSSMutableStyleDeclaration::getPropertyValue):
            Getter for animation property shorthand
        (WebCore::initShorthandMap):
            Adds initialisation for transform-origin, animation and transition

2009-01-07  Benjamin Otte  <otte@gnome.org>

        Reviewed by Holger Freyther.

        * platform/network/ResourceHandleInternal.h:
        (WebCore::ResourceHandleInternal::ResourceHandleInternal):
        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandleInternal::~ResourceHandleInternal):
        (WebCore::parseDataUrl):
        (WebCore::ResourceHandle::startData): keep track of the idle handler
        we add and remove it in the destructor

2009-01-07  Dean Jackson  <dino@apple.com>

        Reviewed by Darin Adler.

        Finish renaming of AffineTransform to TransformationMatrix, this
        time ensuring that the platform implementations get the correct
        name. Also, clean up some whitespace cruft in old content.

        https://bugs.webkit.org/show_bug.cgi?id=23151

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/cairo/AffineTransformCairo.cpp: Removed.
        * platform/graphics/cairo/TransformationMatrixCairo.cpp: Copied from WebCore/platform/graphics/cairo/AffineTransformCairo.cpp.
        * platform/graphics/cg/AffineTransformCG.cpp: Removed.
        * platform/graphics/cg/TransformationMatrixCG.cpp: Copied from WebCore/platform/graphics/cg/AffineTransformCG.cpp.
        * platform/graphics/qt/AffineTransformQt.cpp: Removed.
        * platform/graphics/qt/TransformationMatrixQt.cpp: Copied from WebCore/platform/graphics/qt/AffineTransformQt.cpp.
        * platform/graphics/transforms/TransformationMatrix.cpp:
        * platform/graphics/transforms/TransformationMatrix.h:
        * platform/graphics/wx/AffineTransformWx.cpp: Removed.
        * platform/graphics/wx/TransformationMatrixWx.cpp: Copied from WebCore/platform/graphics/wx/AffineTransformWx.cpp.
        * webcore-wx.bkl:

2009-01-07  Anders Carlsson  <andersca@apple.com>

        Another build fix.
        
        * WebCore.LP64.exp:

2008-12-16  David Hyatt  <hyatt@apple.com>

        Make Safari RSS behave nicely with full page zoom.  Need to add a new value to enable resetting of zoom
        back to the document-level default.

        Reviewed by Darin Adler

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * css/CSSValueKeywords.in:

2009-01-07  Darin Adler  <darin@apple.com>

        Reviewed by Oliver Hunt.

        Bug 23160: add setMemoryCacheClientCallsEnabled SPI so Safari can be faster with activity window closed
        https://bugs.webkit.org/show_bug.cgi?id=23160

        * WebCore.base.exp: Added Page::setMemoryCacheClientCallsEnabled.

        * inspector/InspectorController.cpp:
        (WebCore::InspectorController::didLoadResourceFromMemoryCache): Updated to take a CachedResource
        so that there's no extra work the caller has to do when the inspector is disabled.
        * inspector/InspectorController.h: Ditto.

        * loader/DocumentLoader.h: Added recordMemoryCacheLoadForFutureClientNotification,
        takeMemoryCacheLoadsForClientNotification, and m_resourcesLoadedFromMemoryCacheForClientNotification.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadedResourceFromMemoryCache): Streamlined code so less work is done when
        there's no inspector or client call needed. Added code to check areMemoryCacheClientCallsEnabled
        and if it's false, use recordMemoryCacheLoadForFutureClientNotification.
        (WebCore::FrameLoader::tellClientAboutPastMemoryCacheLoads): Added.
        * loader/FrameLoader.h: Ditto.

        * page/Page.cpp:
        (WebCore::Page::Page): Initialize m_areMemoryCacheClientCallsEnabled to be compatible with old behavior.
        (WebCore::Page::setMemoryCacheClientCallsEnabled): Added.
        * page/Page.h: Added setMemoryCacheClientCallsEnabled, areMemoryCacheClientCallsEnabled,
        and m_areMemoryCacheClientCallsEnabled.

2009-01-07  Ariya Hidayat  <ariya.hidayat@trolltech.com>

        Rubber-stamped by Simon Hausmann.

        Qt build fix after r39670.

        * bridge/qt/qt_class.cpp:
        (JSC::Bindings::QtClass::fallbackObject):
        * bridge/qt/qt_class.h:
        * bridge/qt/qt_instance.cpp:
        (JSC::Bindings::QtInstance::mark):
        (JSC::Bindings::QtInstance::invokeMethod):
        (JSC::Bindings::QtInstance::defaultValue):
        (JSC::Bindings::QtInstance::stringValue):
        (JSC::Bindings::QtInstance::numberValue):
        (JSC::Bindings::QtInstance::booleanValue):
        (JSC::Bindings::QtInstance::valueOf):
        (JSC::Bindings::QtField::valueFromInstance):
        (JSC::Bindings::QtField::setValueToInstance):
        * bridge/qt/qt_instance.h:
        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::valueRealType):
        (JSC::Bindings::convertValueToQVariant):
        (JSC::Bindings::convertQVariantToValue):
        (JSC::Bindings::findMethodIndex):
        (JSC::Bindings::QtRuntimeMetaMethod::call):
        (JSC::Bindings::QtRuntimeMetaMethod::lengthGetter):
        (JSC::Bindings::QtRuntimeMetaMethod::connectGetter):
        (JSC::Bindings::QtRuntimeMetaMethod::disconnectGetter):
        (JSC::Bindings::QtRuntimeConnectionMethod::call):
        (JSC::Bindings::QtRuntimeConnectionMethod::lengthGetter):
        (JSC::Bindings::::setValueAt):
        (JSC::Bindings::::valueAt):
        * bridge/qt/qt_runtime.h:
        (JSC::Bindings::QtRuntimeMethod::createStructure):

2009-01-06  Justin Garcia  <justin.garcia@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/6391734> SnowLeopard: Crash doing Copy Image from context menu
        
        Can't create an automated test case for specific contextual menu items yet and
        a normal Copy doesn't cause a crash.

        * platform/mac/PasteboardMac.mm:
        (WebCore::fileWrapperForImage): The SharedBuffer may not have platform data.  It may,
        for example, have a purgeable or regular buffer.

2009-01-06  Mark Rowe  <mrowe@apple.com>

        Reviewed by Geoff Garen.

        Fix <https://bugs.webkit.org/show_bug.cgi?id=23157>.
        Bug 23157: Crashes on Acid 3

        * dom/Document.cpp:
        (WebCore::Document::recalcStyle): Null-check the frame.

2009-01-05  Gavin Barraclough  <baraclough@apple.com>

        Rubber Stamped by Oliver Hunt.

        Replace all uses of JSValue* with new wrapper class, JSValuePtr.
        See JavaScriptCore/ChangeLog for more detailed description.

        * bindings/js/JSAttrCustom.cpp:
        (WebCore::JSAttr::setValue):
        * bindings/js/JSCSSRuleCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSCSSStyleDeclarationCustom.cpp:
        (WebCore::JSCSSStyleDeclaration::nameGetter):
        (WebCore::JSCSSStyleDeclaration::customPut):
        * bindings/js/JSCSSValueCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSCanvasPixelArrayCustom.h:
        (WebCore::JSCanvasPixelArray::getByIndex):
        (WebCore::JSCanvasPixelArray::indexSetter):
        * bindings/js/JSCanvasRenderingContext2DCustom.cpp:
        (WebCore::toJS):
        (WebCore::toHTMLCanvasStyle):
        (WebCore::JSCanvasRenderingContext2D::strokeStyle):
        (WebCore::JSCanvasRenderingContext2D::setStrokeStyle):
        (WebCore::JSCanvasRenderingContext2D::fillStyle):
        (WebCore::JSCanvasRenderingContext2D::setFillStyle):
        (WebCore::JSCanvasRenderingContext2D::setFillColor):
        (WebCore::JSCanvasRenderingContext2D::setStrokeColor):
        (WebCore::JSCanvasRenderingContext2D::strokeRect):
        (WebCore::JSCanvasRenderingContext2D::drawImage):
        (WebCore::JSCanvasRenderingContext2D::drawImageFromRect):
        (WebCore::JSCanvasRenderingContext2D::setShadow):
        (WebCore::JSCanvasRenderingContext2D::createPattern):
        (WebCore::JSCanvasRenderingContext2D::putImageData):
        (WebCore::JSCanvasRenderingContext2D::fillText):
        (WebCore::JSCanvasRenderingContext2D::strokeText):
        * bindings/js/JSClipboardCustom.cpp:
        (WebCore::JSClipboard::types):
        (WebCore::JSClipboard::clearData):
        (WebCore::JSClipboard::getData):
        (WebCore::JSClipboard::setData):
        (WebCore::JSClipboard::setDragImage):
        * bindings/js/JSConsoleCustom.cpp:
        (WebCore::JSConsole::profiles):
        * bindings/js/JSCustomPositionCallback.cpp:
        (WebCore::JSCustomPositionCallback::handleEvent):
        * bindings/js/JSCustomPositionErrorCallback.cpp:
        (WebCore::JSCustomPositionErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLStatementCallback.cpp:
        (WebCore::JSCustomSQLStatementCallback::handleEvent):
        * bindings/js/JSCustomSQLStatementErrorCallback.cpp:
        (WebCore::JSCustomSQLStatementErrorCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionCallback.cpp:
        (WebCore::JSCustomSQLTransactionCallback::handleEvent):
        * bindings/js/JSCustomSQLTransactionErrorCallback.cpp:
        (WebCore::JSCustomSQLTransactionErrorCallback::handleEvent):
        * bindings/js/JSCustomVoidCallback.cpp:
        (WebCore::JSCustomVoidCallback::handleEvent):
        (WebCore::toVoidCallback):
        * bindings/js/JSCustomVoidCallback.h:
        * bindings/js/JSCustomXPathNSResolver.cpp:
        (WebCore::JSCustomXPathNSResolver::create):
        (WebCore::JSCustomXPathNSResolver::lookupNamespaceURI):
        * bindings/js/JSCustomXPathNSResolver.h:
        * bindings/js/JSDOMApplicationCacheCustom.cpp:
        (WebCore::JSDOMApplicationCache::add):
        (WebCore::JSDOMApplicationCache::remove):
        (WebCore::JSDOMApplicationCache::addEventListener):
        (WebCore::JSDOMApplicationCache::removeEventListener):
        * bindings/js/JSDOMBinding.cpp:
        (WebCore::jsStringOrNull):
        (WebCore::jsOwnedStringOrNull):
        (WebCore::jsStringOrUndefined):
        (WebCore::jsStringOrFalse):
        (WebCore::valueToStringWithNullCheck):
        (WebCore::valueToStringWithUndefinedOrNullCheck):
        (WebCore::reportException):
        (WebCore::reportCurrentException):
        (WebCore::setDOMException):
        (WebCore::objectToStringFunctionGetter):
        * bindings/js/JSDOMBinding.h:
        (WebCore::getDOMObjectWrapper):
        (WebCore::getDOMNodeWrapper):
        (WebCore::toJS):
        * bindings/js/JSDOMGlobalObject.cpp:
        (WebCore::JSDOMGlobalObject::findJSEventListener):
        (WebCore::JSDOMGlobalObject::findOrCreateJSEventListener):
        (WebCore::JSDOMGlobalObject::findJSUnprotectedEventListener):
        (WebCore::JSDOMGlobalObject::findOrCreateJSUnprotectedEventListener):
        * bindings/js/JSDOMGlobalObject.h:
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::createWindow):
        (WebCore::showModalDialog):
        (jsDOMWindowBaseCrypto):
        (jsDOMWindowBaseEvent):
        (jsDOMWindowBaseImage):
        (jsDOMWindowBaseMessageChannel):
        (jsDOMWindowBaseOption):
        (jsDOMWindowBaseXMLHttpRequest):
        (jsDOMWindowBaseAudio):
        (jsDOMWindowBaseWorker):
        (jsDOMWindowBaseXSLTProcessor):
        (setJSDOMWindowBaseEvent):
        (setJSDOMWindowBaseAudio):
        (setJSDOMWindowBaseImage):
        (setJSDOMWindowBaseMessageChannel):
        (setJSDOMWindowBaseOption):
        (setJSDOMWindowBaseWorker):
        (setJSDOMWindowBaseXMLHttpRequest):
        (setJSDOMWindowBaseXSLTProcessor):
        (WebCore::JSDOMWindowBase::childFrameGetter):
        (WebCore::JSDOMWindowBase::indexGetter):
        (WebCore::JSDOMWindowBase::namedItemGetter):
        (WebCore::JSDOMWindowBase::getOwnPropertySlot):
        (WebCore::JSDOMWindowBase::put):
        (WebCore::JSDOMWindowBase::clear):
        (windowProtoFuncOpen):
        (windowProtoFuncShowModalDialog):
        (windowProtoFuncNotImplemented):
        (WebCore::JSDOMWindowBase::setReturnValueSlot):
        (WebCore::JSDOMWindowBase::installTimeout):
        (WebCore::toJS):
        (WebCore::toJSDOMWindow):
        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/JSDOMWindowCustom.cpp:
        (WebCore::JSDOMWindow::lookupGetter):
        (WebCore::JSDOMWindow::lookupSetter):
        (WebCore::JSDOMWindow::setLocation):
        (WebCore::JSDOMWindow::postMessage):
        (WebCore::setTimeoutOrInterval):
        (WebCore::JSDOMWindow::setTimeout):
        (WebCore::JSDOMWindow::clearTimeout):
        (WebCore::JSDOMWindow::setInterval):
        (WebCore::JSDOMWindow::clearInterval):
        (WebCore::JSDOMWindow::atob):
        (WebCore::JSDOMWindow::btoa):
        (WebCore::JSDOMWindow::addEventListener):
        (WebCore::JSDOMWindow::removeEventListener):
        (WebCore::toDOMWindow):
        (WebCore::nonCachingStaticCloseFunctionGetter):
        (WebCore::nonCachingStaticBlurFunctionGetter):
        (WebCore::nonCachingStaticFocusFunctionGetter):
        (WebCore::nonCachingStaticPostMessageFunctionGetter):
        * bindings/js/JSDOMWindowCustom.h:
        (WebCore::JSDOMWindow::customPut):
        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::put):
        (WebCore::JSDOMWindowShell::putWithAttributes):
        (WebCore::JSDOMWindowShell::lookupGetter):
        (WebCore::JSDOMWindowShell::lookupSetter):
        (WebCore::toJS):
        * bindings/js/JSDOMWindowShell.h:
        (WebCore::JSDOMWindowShell::createStructure):
        * bindings/js/JSDatabaseCustom.cpp:
        (WebCore::JSDatabase::changeVersion):
        (WebCore::JSDatabase::transaction):
        * bindings/js/JSDocumentCustom.cpp:
        (WebCore::JSDocument::location):
        (WebCore::JSDocument::setLocation):
        (WebCore::toJS):
        * bindings/js/JSElementCustom.cpp:
        (WebCore::JSElement::setAttribute):
        (WebCore::JSElement::setAttributeNode):
        (WebCore::JSElement::setAttributeNS):
        (WebCore::JSElement::setAttributeNodeNS):
        (WebCore::toJSNewlyCreated):
        * bindings/js/JSEventCustom.cpp:
        (WebCore::JSEvent::clipboardData):
        (WebCore::toJS):
        * bindings/js/JSEventListener.cpp:
        (WebCore::JSAbstractEventListener::handleEvent):
        (WebCore::eventParameterName):
        (WebCore::JSLazyEventListener::parseCode):
        * bindings/js/JSEventTarget.cpp:
        (WebCore::toJS):
        * bindings/js/JSEventTarget.h:
        * bindings/js/JSEventTargetBase.h:
        * bindings/js/JSEventTargetNodeCustom.cpp:
        (WebCore::JSEventTargetNode::addEventListener):
        (WebCore::JSEventTargetNode::removeEventListener):
        * bindings/js/JSGeolocationCustom.cpp:
        (WebCore::createPositionOptions):
        (WebCore::JSGeolocation::getCurrentPosition):
        (WebCore::JSGeolocation::watchPosition):
        * bindings/js/JSHTMLAllCollection.h:
        (WebCore::JSHTMLAllCollection::createStructure):
        * bindings/js/JSHTMLAppletElementCustom.cpp:
        (WebCore::JSHTMLAppletElement::customPut):
        (WebCore::JSHTMLAppletElement::nameGetter):
        * bindings/js/JSHTMLCollectionCustom.cpp:
        (WebCore::getNamedItems):
        (WebCore::callHTMLCollection):
        (WebCore::JSHTMLCollection::nameGetter):
        (WebCore::JSHTMLCollection::item):
        (WebCore::JSHTMLCollection::namedItem):
        (WebCore::toJS):
        * bindings/js/JSHTMLDocumentCustom.cpp:
        (WebCore::JSHTMLDocument::nameGetter):
        (WebCore::JSHTMLDocument::all):
        (WebCore::JSHTMLDocument::setAll):
        (WebCore::JSHTMLDocument::open):
        (WebCore::JSHTMLDocument::write):
        (WebCore::JSHTMLDocument::writeln):
        * bindings/js/JSHTMLEmbedElementCustom.cpp:
        (WebCore::JSHTMLEmbedElement::customPut):
        (WebCore::JSHTMLEmbedElement::nameGetter):
        * bindings/js/JSHTMLFormElementCustom.cpp:
        (WebCore::JSHTMLFormElement::nameGetter):
        * bindings/js/JSHTMLFrameElementCustom.cpp:
        (WebCore::JSHTMLFrameElement::setSrc):
        (WebCore::JSHTMLFrameElement::setLocation):
        * bindings/js/JSHTMLFrameSetElementCustom.cpp:
        (WebCore::JSHTMLFrameSetElement::nameGetter):
        * bindings/js/JSHTMLIFrameElementCustom.cpp:
        (WebCore::JSHTMLIFrameElement::setSrc):
        * bindings/js/JSHTMLInputElementCustom.cpp:
        (WebCore::JSHTMLInputElement::selectionStart):
        (WebCore::JSHTMLInputElement::selectionEnd):
        * bindings/js/JSHTMLObjectElementCustom.cpp:
        (WebCore::JSHTMLObjectElement::customPut):
        (WebCore::JSHTMLObjectElement::nameGetter):
        * bindings/js/JSHTMLOptionsCollectionCustom.cpp:
        (WebCore::JSHTMLOptionsCollection::length):
        (WebCore::JSHTMLOptionsCollection::setLength):
        (WebCore::JSHTMLOptionsCollection::indexSetter):
        (WebCore::JSHTMLOptionsCollection::add):
        (WebCore::JSHTMLOptionsCollection::remove):
        * bindings/js/JSHTMLSelectElementCustom.cpp:
        (WebCore::JSHTMLSelectElement::remove):
        (WebCore::selectIndexSetter):
        (WebCore::JSHTMLSelectElement::indexSetter):
        * bindings/js/JSHTMLSelectElementCustom.h:
        * bindings/js/JSHistoryCustom.cpp:
        (WebCore::nonCachingStaticBackFunctionGetter):
        (WebCore::nonCachingStaticForwardFunctionGetter):
        (WebCore::nonCachingStaticGoFunctionGetter):
        (WebCore::JSHistory::customPut):
        * bindings/js/JSImageDataCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSInspectedObjectWrapper.cpp:
        (WebCore::JSInspectedObjectWrapper::wrap):
        (WebCore::JSInspectedObjectWrapper::prepareIncomingValue):
        * bindings/js/JSInspectedObjectWrapper.h:
        (WebCore::JSInspectedObjectWrapper::wrapOutgoingValue):
        * bindings/js/JSInspectorCallbackWrapper.cpp:
        (WebCore::JSInspectorCallbackWrapper::wrap):
        (WebCore::JSInspectorCallbackWrapper::prepareIncomingValue):
        * bindings/js/JSInspectorCallbackWrapper.h:
        (WebCore::JSInspectorCallbackWrapper::wrapOutgoingValue):
        * bindings/js/JSJavaScriptCallFrameCustom.cpp:
        (WebCore::JSJavaScriptCallFrame::evaluate):
        (WebCore::JSJavaScriptCallFrame::thisObject):
        (WebCore::JSJavaScriptCallFrame::type):
        (WebCore::JSJavaScriptCallFrame::scopeChain):
        * bindings/js/JSLocationCustom.cpp:
        (WebCore::nonCachingStaticReplaceFunctionGetter):
        (WebCore::nonCachingStaticReloadFunctionGetter):
        (WebCore::nonCachingStaticAssignFunctionGetter):
        (WebCore::JSLocation::customPut):
        (WebCore::JSLocation::setHref):
        (WebCore::JSLocation::setProtocol):
        (WebCore::JSLocation::setHost):
        (WebCore::JSLocation::setHostname):
        (WebCore::JSLocation::setPort):
        (WebCore::JSLocation::setPathname):
        (WebCore::JSLocation::setSearch):
        (WebCore::JSLocation::setHash):
        (WebCore::JSLocation::replace):
        (WebCore::JSLocation::reload):
        (WebCore::JSLocation::assign):
        (WebCore::JSLocation::toString):
        * bindings/js/JSMessageChannelConstructor.h:
        * bindings/js/JSMessagePortCustom.cpp:
        (WebCore::JSMessagePort::startConversation):
        (WebCore::JSMessagePort::addEventListener):
        (WebCore::JSMessagePort::removeEventListener):
        * bindings/js/JSMimeTypeArrayCustom.cpp:
        (WebCore::JSMimeTypeArray::nameGetter):
        * bindings/js/JSNamedNodeMapCustom.cpp:
        (WebCore::JSNamedNodeMap::nameGetter):
        * bindings/js/JSNamedNodesCollection.cpp:
        (WebCore::JSNamedNodesCollection::lengthGetter):
        (WebCore::JSNamedNodesCollection::indexGetter):
        * bindings/js/JSNamedNodesCollection.h:
        (WebCore::JSNamedNodesCollection::createStructure):
        * bindings/js/JSNavigatorCustom.cpp:
        (WebCore::needsYouTubeQuirk):
        (WebCore::JSNavigator::appVersion):
        * bindings/js/JSNodeCustom.cpp:
        (WebCore::JSNode::insertBefore):
        (WebCore::JSNode::replaceChild):
        (WebCore::JSNode::removeChild):
        (WebCore::JSNode::appendChild):
        (WebCore::createWrapper):
        (WebCore::toJSNewlyCreated):
        (WebCore::toJS):
        * bindings/js/JSNodeFilterCondition.cpp:
        (WebCore::JSNodeFilterCondition::JSNodeFilterCondition):
        (WebCore::JSNodeFilterCondition::acceptNode):
        * bindings/js/JSNodeFilterCondition.h:
        (WebCore::JSNodeFilterCondition::create):
        * bindings/js/JSNodeFilterCustom.cpp:
        (WebCore::JSNodeFilter::acceptNode):
        (WebCore::toNodeFilter):
        * bindings/js/JSNodeIteratorCustom.cpp:
        (WebCore::JSNodeIterator::nextNode):
        (WebCore::JSNodeIterator::previousNode):
        * bindings/js/JSNodeListCustom.cpp:
        (WebCore::callNodeList):
        (WebCore::JSNodeList::nameGetter):
        * bindings/js/JSPluginArrayCustom.cpp:
        (WebCore::JSPluginArray::nameGetter):
        * bindings/js/JSPluginCustom.cpp:
        (WebCore::JSPlugin::nameGetter):
        * bindings/js/JSPluginElementFunctions.cpp:
        (WebCore::runtimeObjectGetter):
        (WebCore::runtimeObjectPropertyGetter):
        (WebCore::runtimeObjectCustomPut):
        (WebCore::callPlugin):
        * bindings/js/JSPluginElementFunctions.h:
        * bindings/js/JSQuarantinedObjectWrapper.cpp:
        (WebCore::JSQuarantinedObjectWrapper::asWrapper):
        (WebCore::JSQuarantinedObjectWrapper::cachedValueGetter):
        (WebCore::JSQuarantinedObjectWrapper::getOwnPropertySlot):
        (WebCore::JSQuarantinedObjectWrapper::put):
        (WebCore::JSQuarantinedObjectWrapper::construct):
        (WebCore::JSQuarantinedObjectWrapper::hasInstance):
        (WebCore::JSQuarantinedObjectWrapper::call):
        * bindings/js/JSQuarantinedObjectWrapper.h:
        (WebCore::JSQuarantinedObjectWrapper::createStructure):
        * bindings/js/JSRGBColor.cpp:
        (WebCore::getJSRGBColor):
        (jsRGBColorRed):
        (jsRGBColorGreen):
        (jsRGBColorBlue):
        * bindings/js/JSRGBColor.h:
        (WebCore::JSRGBColor::createStructure):
        * bindings/js/JSSQLResultSetRowListCustom.cpp:
        (WebCore::JSSQLResultSetRowList::item):
        * bindings/js/JSSQLTransactionCustom.cpp:
        (WebCore::JSSQLTransaction::executeSql):
        * bindings/js/JSSVGElementInstanceCustom.cpp:
        (WebCore::JSSVGElementInstance::addEventListener):
        (WebCore::JSSVGElementInstance::removeEventListener):
        * bindings/js/JSSVGLengthCustom.cpp:
        (WebCore::JSSVGLength::value):
        (WebCore::JSSVGLength::convertToSpecifiedUnits):
        * bindings/js/JSSVGMatrixCustom.cpp:
        (WebCore::JSSVGMatrix::multiply):
        (WebCore::JSSVGMatrix::inverse):
        (WebCore::JSSVGMatrix::translate):
        (WebCore::JSSVGMatrix::scale):
        (WebCore::JSSVGMatrix::scaleNonUniform):
        (WebCore::JSSVGMatrix::rotate):
        (WebCore::JSSVGMatrix::rotateFromVector):
        (WebCore::JSSVGMatrix::flipX):
        (WebCore::JSSVGMatrix::flipY):
        (WebCore::JSSVGMatrix::skewX):
        (WebCore::JSSVGMatrix::skewY):
        * bindings/js/JSSVGPathSegCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSSVGPathSegListCustom.cpp:
        (WebCore::JSSVGPathSegList::clear):
        (WebCore::JSSVGPathSegList::initialize):
        (WebCore::JSSVGPathSegList::getItem):
        (WebCore::JSSVGPathSegList::insertItemBefore):
        (WebCore::JSSVGPathSegList::replaceItem):
        (WebCore::JSSVGPathSegList::removeItem):
        (WebCore::JSSVGPathSegList::appendItem):
        * bindings/js/JSSVGPointListCustom.cpp:
        (WebCore::finishGetter):
        (WebCore::finishSetter):
        (WebCore::finishSetterReadOnlyResult):
        (WebCore::JSSVGPointList::clear):
        (WebCore::JSSVGPointList::initialize):
        (WebCore::JSSVGPointList::getItem):
        (WebCore::JSSVGPointList::insertItemBefore):
        (WebCore::JSSVGPointList::replaceItem):
        (WebCore::JSSVGPointList::removeItem):
        (WebCore::JSSVGPointList::appendItem):
        * bindings/js/JSSVGTransformListCustom.cpp:
        (WebCore::finishGetter):
        (WebCore::finishSetter):
        (WebCore::finishSetterReadOnlyResult):
        (WebCore::JSSVGTransformList::clear):
        (WebCore::JSSVGTransformList::initialize):
        (WebCore::JSSVGTransformList::getItem):
        (WebCore::JSSVGTransformList::insertItemBefore):
        (WebCore::JSSVGTransformList::replaceItem):
        (WebCore::JSSVGTransformList::removeItem):
        (WebCore::JSSVGTransformList::appendItem):
        * bindings/js/JSStorageCustom.cpp:
        (WebCore::JSStorage::nameGetter):
        (WebCore::JSStorage::deleteProperty):
        (WebCore::JSStorage::customPut):
        * bindings/js/JSStyleSheetCustom.cpp:
        (WebCore::toJS):
        * bindings/js/JSStyleSheetListCustom.cpp:
        (WebCore::JSStyleSheetList::nameGetter):
        * bindings/js/JSTextCustom.cpp:
        (WebCore::toJSNewlyCreated):
        * bindings/js/JSTreeWalkerCustom.cpp:
        (WebCore::JSTreeWalker::parentNode):
        (WebCore::JSTreeWalker::firstChild):
        (WebCore::JSTreeWalker::lastChild):
        (WebCore::JSTreeWalker::nextSibling):
        (WebCore::JSTreeWalker::previousSibling):
        (WebCore::JSTreeWalker::previousNode):
        (WebCore::JSTreeWalker::nextNode):
        * bindings/js/JSWorkerContextBase.cpp:
        (WebCore::JSWorkerContextBase::put):
        * bindings/js/JSWorkerContextBase.h:
        * bindings/js/JSWorkerContextCustom.cpp:
        (WebCore::JSWorkerContext::self):
        (WebCore::JSWorkerContext::setSelf):
        (WebCore::JSWorkerContext::addEventListener):
        (WebCore::JSWorkerContext::removeEventListener):
        * bindings/js/JSWorkerCustom.cpp:
        (WebCore::JSWorker::addEventListener):
        (WebCore::JSWorker::removeEventListener):
        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::open):
        (WebCore::JSXMLHttpRequest::setRequestHeader):
        (WebCore::JSXMLHttpRequest::send):
        (WebCore::JSXMLHttpRequest::getResponseHeader):
        (WebCore::JSXMLHttpRequest::overrideMimeType):
        (WebCore::JSXMLHttpRequest::addEventListener):
        (WebCore::JSXMLHttpRequest::removeEventListener):
        (WebCore::JSXMLHttpRequest::responseText):
        * bindings/js/JSXMLHttpRequestUploadCustom.cpp:
        (WebCore::JSXMLHttpRequestUpload::addEventListener):
        (WebCore::JSXMLHttpRequestUpload::removeEventListener):
        * bindings/js/JSXSLTProcessorCustom.cpp:
        (WebCore::JSXSLTProcessor::importStylesheet):
        (WebCore::JSXSLTProcessor::transformToFragment):
        (WebCore::JSXSLTProcessor::transformToDocument):
        (WebCore::JSXSLTProcessor::setParameter):
        (WebCore::JSXSLTProcessor::getParameter):
        (WebCore::JSXSLTProcessor::removeParameter):
        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::ScheduledAction):
        (WebCore::ScheduledAction::execute):
        * bindings/js/ScheduledAction.h:
        * bindings/js/ScriptCallStack.cpp:
        (WebCore::ScriptCallStack::ScriptCallStack):
        (WebCore::ScriptCallStack::initialize):
        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::createScriptObjectForPluginElement):
        * bindings/js/ScriptValue.cpp:
        (WebCore::ScriptValue::getString):
        (WebCore::ScriptValue::isNull):
        (WebCore::ScriptValue::isUndefined):
        * bindings/js/ScriptValue.h:
        (WebCore::ScriptValue::ScriptValue):
        (WebCore::ScriptValue::jsValue):
        * bindings/objc/WebScriptObject.mm:
        (-[WebScriptObject callWebScriptMethod:withArguments:]):
        (-[WebScriptObject evaluateWebScript:]):
        (-[WebScriptObject valueForKey:]):
        (-[WebScriptObject webScriptValueAtIndex:]):
        (+[WebScriptObject _convertValueToObjcValue:originRootObject:rootObject:]):
        * bindings/objc/WebScriptObjectPrivate.h:
        * bindings/scripts/CodeGeneratorJS.pm:
        * bridge/NP_jsobject.cpp:
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_GetProperty):
        (_NPN_HasMethod):
        (_NPN_Construct):
        * bridge/c/c_instance.cpp:
        (JSC::Bindings::CInstance::invokeMethod):
        (JSC::Bindings::CInstance::invokeDefaultMethod):
        (JSC::Bindings::CInstance::invokeConstruct):
        (JSC::Bindings::CInstance::defaultValue):
        (JSC::Bindings::CInstance::stringValue):
        (JSC::Bindings::CInstance::numberValue):
        (JSC::Bindings::CInstance::booleanValue):
        (JSC::Bindings::CInstance::valueOf):
        * bridge/c/c_instance.h:
        * bridge/c/c_runtime.cpp:
        (JSC::Bindings::CField::valueFromInstance):
        (JSC::Bindings::CField::setValueToInstance):
        * bridge/c/c_runtime.h:
        * bridge/c/c_utility.cpp:
        (JSC::Bindings::convertValueToNPVariant):
        (JSC::Bindings::convertNPVariantToValue):
        * bridge/c/c_utility.h:
        * bridge/jni/jni_instance.cpp:
        (JavaInstance::stringValue):
        (JavaInstance::numberValue):
        (JavaInstance::booleanValue):
        (JavaInstance::invokeMethod):
        (JavaInstance::defaultValue):
        (JavaInstance::valueOf):
        * bridge/jni/jni_instance.h:
        * bridge/jni/jni_jsobject.h:
        * bridge/jni/jni_jsobject.mm:
        (JavaJSObject::call):
        (JavaJSObject::eval):
        (JavaJSObject::getMember):
        (JavaJSObject::getSlot):
        (JavaJSObject::convertValueToJObject):
        (JavaJSObject::convertJObjectToValue):
        * bridge/jni/jni_objc.mm:
        (JSC::Bindings::dispatchJNICall):
        * bridge/jni/jni_runtime.cpp:
        (JavaArray::convertJObjectToArray):
        (JavaField::dispatchValueFromInstance):
        (JavaField::valueFromInstance):
        (JavaField::dispatchSetValueToInstance):
        (JavaField::setValueToInstance):
        (JavaArray::setValueAt):
        (JavaArray::valueAt):
        * bridge/jni/jni_runtime.h:
        * bridge/jni/jni_utility.cpp:
        (JSC::Bindings::convertArrayInstanceToJavaArray):
        (JSC::Bindings::convertValueToJValue):
        * bridge/jni/jni_utility.h:
        * bridge/objc/WebScriptObject.h:
        * bridge/objc/objc_class.h:
        * bridge/objc/objc_class.mm:
        (JSC::Bindings::ObjcClass::fallbackObject):
        * bridge/objc/objc_instance.h:
        * bridge/objc/objc_instance.mm:
        (ObjcInstance::invokeMethod):
        (ObjcInstance::invokeDefaultMethod):
        (ObjcInstance::setValueOfUndefinedField):
        (ObjcInstance::getValueOfUndefinedField):
        (ObjcInstance::defaultValue):
        (ObjcInstance::stringValue):
        (ObjcInstance::numberValue):
        (ObjcInstance::booleanValue):
        (ObjcInstance::valueOf):
        * bridge/objc/objc_runtime.h:
        (JSC::Bindings::ObjcFallbackObjectImp::createStructure):
        * bridge/objc/objc_runtime.mm:
        (JSC::Bindings::ObjcField::valueFromInstance):
        (JSC::Bindings::convertValueToObjcObject):
        (JSC::Bindings::ObjcField::setValueToInstance):
        (JSC::Bindings::ObjcArray::setValueAt):
        (JSC::Bindings::ObjcArray::valueAt):
        (JSC::Bindings::ObjcFallbackObjectImp::put):
        (JSC::Bindings::callObjCFallbackObject):
        (JSC::Bindings::ObjcFallbackObjectImp::defaultValue):
        * bridge/objc/objc_utility.h:
        * bridge/objc/objc_utility.mm:
        (JSC::Bindings::convertValueToObjcValue):
        (JSC::Bindings::convertNSStringToString):
        (JSC::Bindings::convertObjcValueToValue):
        * bridge/runtime.cpp:
        (JSC::Bindings::Instance::getValueOfField):
        (JSC::Bindings::Instance::setValueOfField):
        * bridge/runtime.h:
        (JSC::Bindings::Class::fallbackObject):
        (JSC::Bindings::Instance::getValueOfUndefinedField):
        (JSC::Bindings::Instance::setValueOfUndefinedField):
        (JSC::Bindings::Instance::invokeDefaultMethod):
        (JSC::Bindings::Instance::invokeConstruct):
        (JSC::Bindings::Instance::valueOf):
        * bridge/runtime_array.cpp:
        (JSC::RuntimeArray::lengthGetter):
        (JSC::RuntimeArray::indexGetter):
        (JSC::RuntimeArray::put):
        * bridge/runtime_array.h:
        (JSC::RuntimeArray::createStructure):
        * bridge/runtime_method.cpp:
        (JSC::RuntimeMethod::lengthGetter):
        (JSC::callRuntimeMethod):
        * bridge/runtime_method.h:
        (JSC::RuntimeMethod::createStructure):
        * bridge/runtime_object.cpp:
        (JSC::RuntimeObjectImp::fallbackObjectGetter):
        (JSC::RuntimeObjectImp::fieldGetter):
        (JSC::RuntimeObjectImp::methodGetter):
        (JSC::RuntimeObjectImp::put):
        (JSC::RuntimeObjectImp::defaultValue):
        (JSC::callRuntimeObject):
        (JSC::callRuntimeConstructor):
        * bridge/runtime_object.h:
        (JSC::RuntimeObjectImp::createStructure):
        * inspector/InspectorController.cpp:
        * inspector/JavaScriptCallFrame.cpp:
        (WebCore::JavaScriptCallFrame::evaluate):
        * inspector/JavaScriptCallFrame.h:
        * inspector/JavaScriptProfile.cpp:
        (WebCore::toJS):
        * inspector/JavaScriptProfile.h:
        * inspector/JavaScriptProfileNode.cpp:
        (WebCore::toJS):
        * inspector/JavaScriptProfileNode.h:
        * xml/XMLHttpRequest.cpp:
        (WebCore::XMLHttpRequest::dropProtection):

2009-01-06  Pierre-Olivier Latour  <pol@apple.com>

        Reviewed by Darin Adler.

        Added new API on AnimationController::numberOfActiveAnimations() to be used by DRT.

        https://bugs.webkit.org/show_bug.cgi?id=23126

        Test: animations/animation-controller-drt-api.html

        * WebCore.base.exp:
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationControllerPrivate::numberOfActiveAnimations):
        (WebCore::AnimationController::numberOfActiveAnimations):
        * page/animation/AnimationController.h:
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimationPrivate::numberOfActiveAnimations):
        (WebCore::CompositeAnimation::numberOfActiveAnimations):
        * page/animation/CompositeAnimation.h:

2009-01-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Gavin Barraclough.

        Upstream 3 more files to get the WebCore-Chromium build a bit further.

        * WebCore.scons:
        * page/chromium/AccessibilityObjectChromium.cpp: Added.
        (WebCore::AccessibilityObject::accessibilityIgnoreAttachment):
        * page/chromium/AccessibilityObjectWrapper.h: Added.
        (WebCore::AccessibilityObjectWrapper::~AccessibilityObjectWrapper):
        (WebCore::AccessibilityObjectWrapper::attached):
        (WebCore::AccessibilityObjectWrapper::accessibilityObject):
        (WebCore::AccessibilityObjectWrapper::AccessibilityObjectWrapper):
        * platform/chromium/PasteboardPrivate.h: Added.
        (WebCore::PasteboardPrivate::):

2009-01-06  Chris Marrin  <cmarrin@apple.com>

        Reviewed by David Hyatt.

        Tests: animations/simultaneous-start-left.html
               animations/simultaneous-start-transform.html

        Fixed https://bugs.webkit.org/show_bug.cgi?id=22870
 
        I added calls beginAnimationUpdate() and endAnimationUpdate() calls
        to AnimationController. These are called by Document at the start
        and end of the recalcStyle cycle. Right now, I'm just using the 
        beginAnimationUpdate() method to reset an animation time value.
        The first time the animation time is accessed after this reset I set
        it to the currentTime. So all animations in that cycle get the same
        start time. 

        The test cases checked in test this, but in the case of the 'left'
        test it actually doesn't make any difference in most cases. This is
        because values are clamped to whole pixels, so the start times would 
        have to be pretty far off for the test to fail using the old
        currentTime() model. Still, under really heavy load, it's possible for
        the test to fail without these changes.

        The 'transform' test is another story. It animates to the full resolution
        of a floating point number, so the test fails miserably without this
        fix.

        * dom/Document.cpp:
        (WebCore::Document::recalcStyle):
        * page/animation/AnimationBase.cpp:
        (WebCore::AnimationBase::updateStateMachine):
        (WebCore::AnimationBase::fireAnimationEventsIfNeeded):
        (WebCore::AnimationBase::willNeedService):
        (WebCore::AnimationBase::progress):
        (WebCore::AnimationBase::goIntoEndingOrLoopingState):
        (WebCore::AnimationBase::beginAnimationUpdateTime):
        * page/animation/AnimationBase.h:
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationControllerPrivate::beginAnimationUpdateTime):
        (WebCore::AnimationControllerPrivate::setBeginAnimationUpdateTime):
        (WebCore::AnimationControllerPrivate::AnimationControllerPrivate):
        (WebCore::AnimationController::updateAnimations):
        (WebCore::AnimationController::beginAnimationUpdateTime):
        (WebCore::AnimationController::beginAnimationUpdate):
        (WebCore::AnimationController::endAnimationUpdate):
        * page/animation/AnimationController.h:
        * page/animation/KeyframeAnimation.cpp:
        (WebCore::KeyframeAnimation::animate):

2009-01-06  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Nikolas Zimmermann.

        Bug 22858: Simplify make_names.pl code for avoiding multiple definitions or inclusions
        https://bugs.webkit.org/show_bug.cgi?id=22858

        I had introduced an awkward situation using hasCustomJSWrapper and
        sometimes boolean parameter in order to ensure JS wrapper generated once
        or header included once.

        Simplified the code by using a %seenTag hash to detect multiple definitions
        or inclusions and skipping it.

        Also cleaned up a bit make_names.pl by using more explicit names and moving
        code to where it belongs.

        * dom/make_names.pl:
        * html/HTMLTagNames.in: Necessary changes that were not detected by
        the previous syntax but will be required for autogenerating HTMLElementFactory.

2009-01-06  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Add a way for frame loader clients to always create a PluginDocument, regardless of 
        the real document MIME type.
        
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::begin):
        (WebCore::FrameLoader::shouldUsePlugin):
        * loader/FrameLoaderClient.h:
        (WebCore::FrameLoaderClient::shouldUsePluginDocument):

2009-01-06  Dean Jackson  <dino@apple.com>

        Reviewed by Dave Hyatt.

        Extend Media Queries to cover transitions,
        animations, transform-2d and transform-3d
        http://webkit.org/specs/MediaQueriesExtensions.html
        Note that the implementation uses -webkit- prefixes
        even though the spec doesn't have them.
        https://bugs.webkit.org/show_bug.cgi?id=22494

        Tests: fast/media/mq-animation.html
               fast/media/mq-transform-01.html
               fast/media/mq-transform-02.html
               fast/media/mq-transform-03.html
               fast/media/mq-transform-04.html
               fast/media/mq-transition.html

        * css/MediaFeatureNames.h:
        * css/MediaQueryEvaluator.cpp:
        (WebCore::animationMediaFeatureEval):
        (WebCore::transitionMediaFeatureEval):
        (WebCore::transform_2dMediaFeatureEval):
        (WebCore::transform_3dMediaFeatureEval):

2009-01-06  Eric Seidel  <eric@webkit.org>

        Reviewed by Oliver Hunt.

        Bring the Chromium-WebCore build closer to building
        by upstreaming PlatformWidget.h add adding the JSC
        plugin bridge files to the build.

        * WebCore.scons:
        * platform/chromium/PlatformWidget.h: Added.

2009-01-06  Eric Seidel  <eric@webkit.org>

        Build fix only, no review.

        Bring the Chromium-WebCore build back closer to building
        by adding files from recent commits.

        * WebCore.scons:

2009-01-06  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/6474973> REGRESSION: PLT ~2% slower due to 39465 (consolidate thread data)

        I could not reproduce the slowdown on my PowerPC test machine, but the change should bring
        performance back.

        * platform/ThreadGlobalData.cpp: (WebCore::threadGlobalData): Don't use AtomicallyInitializedStatic.
        Prior to r39465, it was only used for cached converters, which was necessary because the
        first access to ICU or TEC one could happen on a secondary thread, but now they are all
        initialized from ThreadGlobalData constructor.

2009-01-06  David Smith  <catfish.man@gmail.com>

        Reviewed by Darin Adler.
        
        https://bugs.webkit.org/show_bug.cgi?id=23129
        Devirtualize Node::childNodes().

2009-01-06  Simon Hausmann  <simon.hausmann@nokia.com>

        Unreviewed build fix.

        Fix the Qt build with Qt 4.4.x, the HTTP-only cookie support was
        added in Qt 4.5.

        * platform/qt/CookieJarQt.cpp:
        (WebCore::setCookies):
        (WebCore::cookies):

2009-01-06  Zalan Bujtas  <zbujtas@gmail.com>

        Reviewed by David Kilzer.

        https://bugs.webkit.org/show_bug.cgi?id=23133
        Fix SVG disabled build. Move 'pointer-events' from SVGCSSPropertyNames.in to
        CSSPropertyNames.in and move PointerEvents functions out of #if ENABLE(SVG)

        NOTE: Property name fixes landed as part of r39648.

        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        (WebCore::CSSPrimitiveValue::operator EPointerEvents):
        * css/CSSPropertyNames.in:
        * css/SVGCSSPropertyNames.in:

2009-01-06  David Kilzer  <ddkilzer@apple.com>

        BUILD FIX (r39634): Fix build for non-SVG builds (Wx)

        * css/CSSPropertyNames.in: Added 'pointer-events'.
        * css/SVGCSSPropertyNames.in: Commented out pointer-events
        since it's now a plain CSS property.

2009-01-06  Simon Hausmann  <simon.hausmann@nokia.com>

        Reviewed by Lars Knoll.

        Added support for HTTP-only cookies to the Qt build.

        * platform/qt/CookieJarQt.cpp:
        (WebCore::setCookies): Don't set HTTP-only cookies through the DOM.
        (WebCore::cookies): Don't return HTTP-only cookies to the DOM.

2009-01-05  David Smith  <catfish.man@gmail.com>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=23084
        Avoid redundant AtomicString conversions

        * dom/Node.cpp: Create an AtomicString early to avoid converting twice
        (WebCore::Node::getElementsByTagNameNS):
        * dom/QualifiedName.h: Use the appropriate AtomicString constructor instead of converting from a String

2009-01-05  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        https://bugs.webkit.org/show_bug.cgi?id=22985
        
        Add an assertion that clip rects are being used when painting with the same
        rootLayer that they were computed with.
        
        Fix two issues detected by the assertion:

        RenderLayer::updateClipRects() should not unconditionally update the clip rects
        on its parent, but stop when reaching rootLayer (just like calculateClipRects()).
        
        We need to pass the temporaryClipRects flag down through reflection painting
        to handle the case of nested reflections.
        
        Also use temporary clip rects in RenderTreeAsText, since that code does not
        reset the painting root for transformed layers, so cached clip rects will not
        match those used for painting.

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::RenderLayer):
        (WebCore::RenderLayer::paintLayer):
        (WebCore::RenderLayer::updateClipRects):
        (WebCore::RenderLayer::clearClipRects):
        * rendering/RenderLayer.h:
        * rendering/RenderTreeAsText.cpp:
        (WebCore::writeLayers):

2009-01-05  Adam Treat  <adam.treat@torchmobile.com>

        Fix the Qt build

        * platform/graphics/qt/AffineTransformQt.cpp:
        (WebCore::TransformationMatrix::TransformationMatrix):

2009-01-05  Mark Rowe  <mrowe@apple.com>

        Fix the build some more.

        * platform/graphics/cairo/AffineTransformCairo.cpp:
        (WebCore::TransformationMatrix::TransformationMatrix):

2009-01-05  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (Build fix).

        Fix Cairo/Gtk build

        * platform/graphics/cairo/ImageBufferCairo.cpp:
        (WebCore::ImageBuffer::putImageData):

2009-01-05  Dean Jackson  <dino@apple.com>

        Reviewed by Darin Adler.

        Rename AffineTransform to TransformationMatrix in
        preparation for future enhancements (non-affine matrices)

        https://bugs.webkit.org/show_bug.cgi?id=22943

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * platform/graphics/transforms/AffineTransform.cpp: Removed.
        * platform/graphics/transforms/AffineTransform.h: Removed.
        * platform/graphics/transforms/TransformationMatrix.cpp: Copied from WebCore/platform/graphics/transforms/AffineTransform.cpp.
        * platform/graphics/transforms/TransformationMatrix.h: Copied from WebCore/platform/graphics/transforms/AffineTransform.h.
        * lots of other files with s/AffineTransform/TransformationMatrix/g

2008-01-05  Dean Jackson  <dino@apple.com>

        Reviewed by David Hyatt.

        Implement 'pointer-events' for HTML content. This involved
        adding a new value 'auto' which behaves as 'visiblePainted'
        in SVG content. 
        
        Moved the property out of the SVG CSS code and into
        the general CSS (both parsing and RenderStyle). 
        
        Changes to the hit testing functionality of the Render tree,
        specifically the nodeAtPoint methods. Where they used to 
        test for visibility, they now use a helper function defined
        on base classes (RenderObject and InlineBox) that checks both
        visibility and pointer-events.
        
        https://bugs.webkit.org/show_bug.cgi?id=11395

        Tests: fast/events/pointer-events-2.html
               fast/events/pointer-events.html

        * css/CSSComputedStyleDeclaration.cpp:
        (WebCore::):
        (WebCore::CSSComputedStyleDeclaration::getPropertyCSSValue):
        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue):
        * css/CSSPrimitiveValueMappings.h:
        (WebCore::CSSPrimitiveValue::CSSPrimitiveValue):
        (WebCore::CSSPrimitiveValue::operator EPointerEvents):
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applyProperty):
        * css/SVGCSSComputedStyleDeclaration.cpp:
        (WebCore::CSSComputedStyleDeclaration::getSVGPropertyCSSValue):
        * css/SVGCSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::applySVGProperty):
        * manual-tests/pointer-events.html: Added.
        * rendering/EllipsisBox.cpp:
        (WebCore::EllipsisBox::nodeAtPoint):
        * rendering/InlineBox.h:
        (WebCore::InlineBox::visibleToHitTesting):
        * rendering/InlineFlowBox.cpp:
        (WebCore::InlineFlowBox::nodeAtPoint):
        * rendering/InlineTextBox.cpp:
        (WebCore::InlineTextBox::nodeAtPoint):
        * rendering/PointerEventsHitRules.cpp:
        (WebCore::PointerEventsHitRules::PointerEventsHitRules):
        * rendering/PointerEventsHitRules.h:
        (WebCore::PointerEventsHitRules::):
        * rendering/RenderBlock.cpp:
        (WebCore::RenderBlock::nodeAtPoint):
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::nodeAtPoint):
        * rendering/RenderObject.h:
        (WebCore::RenderObject::visibleToHitTesting):
        * rendering/RenderPath.cpp:
        (WebCore::RenderPath::nodeAtPoint):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::nodeAtPoint):
        * rendering/RenderSVGText.cpp:
        (WebCore::RenderSVGText::nodeAtPoint):
        * rendering/RootInlineBox.cpp:
        (WebCore::RootInlineBox::nodeAtPoint):
        * rendering/TextControlInnerElements.cpp:
        (WebCore::SearchFieldCancelButtonElement::defaultEventHandler):
        * rendering/style/RenderStyle.h:
        (WebCore::):
        (WebCore::InheritedFlags::setBitDefaults):
        (WebCore::InheritedFlags::pointerEvents):
        (WebCore::InheritedFlags::setPointerEvents):
        (WebCore::InheritedFlags::initialPointerEvents):
        * rendering/style/RenderStyleConstants.h:
        (WebCore::):
        * rendering/style/SVGRenderStyle.h:
        (WebCore::SVGRenderStyle::InheritedFlags::operator==):
        (WebCore::SVGRenderStyle::setBitDefaults):
        * rendering/style/SVGRenderStyleDefs.h:
        * css/CSSValueKeywords.in:
        * css/SVGCSSValueKeywords.in:

2009-01-05  Oliver Hunt  <oliver@apple.com>

        Reviewed by NOBODY (Build fix).

        Fix Cairo/Gtk build

        * platform/graphics/cairo/ImageBufferCairo.cpp:
        (WebCore::ImageBuffer::getImageData):

2009-01-05  Oliver Hunt  <oliver@apple.com>

        Reviewed by Gavin Barraclough.

        CanvasPixelArray performance is too slow 
        <https://bugs.webkit.org/show_bug.cgi?id=23123>

        Remove the WebCore CanvasPixelArray implementation and replace
        CPA usage with JSC::ByteArray.  Replace the JSCanvasPixelArray
        wrapper with an explicitly instantiated JSByteArray put on the
        JSImageData object as an ordinary ReadOnly, DontDelete property.

        * DerivedSources.make:
        * ForwardingHeaders/runtime/ByteArray.h: Added.
        * ForwardingHeaders/runtime/JSByteArray.h: Added.
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSCanvasPixelArrayCustom.h: Removed.
        * bindings/js/JSImageDataCustom.cpp:
        (WebCore::toJS):
        * html/CanvasPixelArray.cpp: Removed.
        * html/CanvasPixelArray.h: Removed.
        * html/CanvasPixelArray.idl: Removed.
        * html/CanvasRenderingContext2D.cpp:
        (WebCore::createEmptyImageData):
        * html/ImageData.cpp:
        (WebCore::ImageData::ImageData):
        * html/ImageData.h:
        (WebCore::ImageData::data):
        * html/ImageData.idl:
        * platform/graphics/cg/ImageBufferCG.cpp:
        (WebCore::ImageBuffer::getImageData):
        (WebCore::ImageBuffer::putImageData):

2009-01-05  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by George Staikos.

        Add notification for contentsSizeChanged which the Qt API will
        introduce.

        * loader/EmptyClients.h:
        (WebCore::EmptyChromeClient::contentsSizeChanged):
        * page/Chrome.cpp:
        (WebCore::Chrome::contentsSizeChanged):
        * page/Chrome.h:
        * page/ChromeClient.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::setContentsSize):
        * page/FrameView.h:
        * platform/HostWindow.h:
        * platform/ScrollView.h:

2009-01-05  Anders Carlsson  <andersca@apple.com>

        Build fix.
        
        * plugins/PluginView.h:
        (WebCore::PluginManualLoader::~PluginManualLoader):

2009-01-05  Anders Carlsson  <andersca@apple.com>

        Reviewed by Kevin Decker.
        
        Add an abstract PluginManualLoader class and make PluginView inherit from it. 
        
        Add some error checking that currently exists in WebKit (but not for long!)
        
        * plugins/PluginView.cpp:
        (WebCore::PluginView::didReceiveResponse):
        (WebCore::PluginView::didReceiveData):
        (WebCore::PluginView::didFinishLoading):
        (WebCore::PluginView::didFail):
        * plugins/PluginView.h:

2009-01-05  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by George Staikos.

        Fixes FrameView to respect the state of scrollbarmode when it is explicitly
        set programatically via a webkit API.

        * loader/FrameLoaderClient.cpp:
        (WebCore::FrameLoaderClient::transitionToCommittedForNewPage):
        * loader/FrameLoaderClient.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::initScrollbars):
        (WebCore::FrameView::updateDefaultScrollbarState):
        * page/FrameView.h:

2009-01-05  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Bug 23109: REGRESSION: Backwards search in a long document matches incorrectly
        https://bugs.webkit.org/show_bug.cgi?id=23109

        Test: fast/text/find-backwards.html

        * editing/TextIterator.cpp:
        (WebCore::SearchBuffer::append): Fix incorrect size passed to memcpy.
        (WebCore::SearchBuffer::search): Handle case where we have an empty buffer but
        we're at a break; must not try to search because ICU will give us an error.
        Fix incorrect size passed to memcpy and memmove.
        (WebCore::findPlainText): Fix case where we found a match and need to search
        again because we want to find the last match. We need to try again without
        adding any more text or handling the break before moving on.

2009-01-05  Adam Treat  <adam.treat@torchmobile.com>

        Fix the Qt build

        * bridge/runtime_object.cpp:
        (JSC::RuntimeObjectImp::put):

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        Fix platforms that don't have Workers enabled.

        * platform/ThreadGlobalData.cpp: (WebCore::threadGlobalData): Create ThreadGlobalData in
        two stages, so that EventNames constructor can access the just-created atomic string table.
        This matches what happens in ThreadSpecific case.

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Suggested by Dave Levin.

        Mac release build fix.

        * WebCore.base.exp: Remove ThreadGlobalData::eventNames(), which is now inline.

2009-01-05  Darin Adler  <darin@apple.com>

        * dom/Document.cpp: Fix build. Oops again.

2009-01-05  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        Fix hang whenever following an anchor.

        * dom/Document.cpp:
        (WebCore::Document::findAnchor): Oops!

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23073
        <rdar://problem/6471129> Workers crash on Windows Release builds

        * platform/ThreadGlobalData.cpp: (WebCore::ThreadGlobalData::ThreadGlobalData):
        * platform/ThreadGlobalData.h: (WebCore::ThreadGlobalData::eventNames):
        Now that ThreadSpecific sets up the pointer before invoking data constructor, we can
        initialize EventNames right away.

2009-01-05  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        Bug 23106: HTMLFormCollection::namedItem ignores caseSensitive argument
        https://bugs.webkit.org/show_bug.cgi?id=23106

        This led me to a bunch of dead code. It turns out that HTML collections
        were carrying the case-insensitive code just so they could be used to
        find anchors, something we can do more simply and efficiently without
        creating a DOM HTMLCollection object.

        No behavior change. Just adding a new function findAnchor function and
        removing some dead code.

        * dom/Document.cpp:
        (WebCore::Document::findAnchor): Added.
        * dom/Document.h: Ditto.

        * html/HTMLAnchorElement.cpp:
        (WebCore::HTMLAnchorElement::accessKey): Take and return AtomicString
        references for better efficiency.
        (WebCore::HTMLAnchorElement::setAccessKey): Ditto.
        (WebCore::HTMLAnchorElement::charset): Ditto.
        (WebCore::HTMLAnchorElement::setCharset): Ditto.
        (WebCore::HTMLAnchorElement::coords): Ditto.
        (WebCore::HTMLAnchorElement::setCoords): Ditto.
        (WebCore::HTMLAnchorElement::setHref): Ditto.
        (WebCore::HTMLAnchorElement::hreflang): Ditto.
        (WebCore::HTMLAnchorElement::setHreflang): Ditto.
        (WebCore::HTMLAnchorElement::name): Ditto.
        (WebCore::HTMLAnchorElement::setName): Ditto.
        (WebCore::HTMLAnchorElement::rel): Ditto.
        (WebCore::HTMLAnchorElement::setRel): Ditto.
        (WebCore::HTMLAnchorElement::rev): Ditto.
        (WebCore::HTMLAnchorElement::setRev): Ditto.
        (WebCore::HTMLAnchorElement::shape): Ditto.
        (WebCore::HTMLAnchorElement::setShape): Ditto.
        (WebCore::HTMLAnchorElement::setTarget): Ditto.
        (WebCore::HTMLAnchorElement::type): Ditto.
        (WebCore::HTMLAnchorElement::setType): Ditto.
        * html/HTMLAnchorElement.h: Ditto.

        * html/HTMLCollection.cpp:
        (WebCore::HTMLCollection::checkForNameMatch): Changed argument to an
        AtomicString and removed the caseSensitive boolean, since we're now always
        case sensitive.
        (WebCore::HTMLCollection::namedItem): Ditto.
        (WebCore::HTMLCollection::nextNamedItem): Ditto.
        * html/HTMLCollection.h: Ditto.
        * html/HTMLFormCollection.cpp:
        (WebCore::HTMLFormCollection::getNamedItem): Ditto.
        (WebCore::HTMLFormCollection::getNamedFormItem): Ditto.
        (WebCore::HTMLFormCollection::nextNamedItemInternal): Ditto.
        (WebCore::HTMLFormCollection::namedItem): Ditto.
        (WebCore::HTMLFormCollection::nextNamedItem): Ditto.
        * html/HTMLFormCollection.h: Ditto.
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::namedItem): Ditto.
        * html/HTMLSelectElement.h: Ditto.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::gotoAnchor): Use the new findAnchor function.
        * page/AccessibilityRenderObject.cpp:
        (WebCore::AccessibilityRenderObject::internalLinkElement): Ditto.

2009-01-05  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        Bug 23104: minor mistakes in init functions for animation and transition events
        https://bugs.webkit.org/show_bug.cgi?id=23104

        Test: fast/events/init-events.html

        Also fixed two StorageEvent problems the test case uncovered:

            Made document.createEvent("StorageEvent") work.
            Allow null values for StorageEvent.oldValue and StorageEvent.newValue.

        * dom/Document.cpp:
        (WebCore::Document::createEvent): Sorted alphabetically by the name of the event
        class. Added StorageEvent.

        * dom/UIEvent.idl: Fixed typo in a comment.

        * dom/WebKitAnimationEvent.cpp:
        (WebCore::WebKitAnimationEvent::initWebKitAnimationEvent): Use all the arguments.
        * dom/WebKitTransitionEvent.cpp:
        (WebCore::WebKitTransitionEvent::initWebKitTransitionEvent): Ditto.

        * storage/StorageEvent.idl: Use the ConvertNullToNullString keyword on the
        arguments to initStorageEvent so it can create events with null values for the
        oldValue and newValue, just like the real storage events. Note that the properties
        already had ConvertNullStringTo=Null, so this is just the other half of that.

2009-01-05  Darin Adler  <darin@apple.com>

        Reviewed by Alexey Proskuryakov.

        Bug 23102: turn on unused parameter warnings in WebCore
        https://bugs.webkit.org/show_bug.cgi?id=23102

        First step: Fix the simple cases where we can just remove an argument name.
        Also made a few more things protected and private.

        * many files

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23115
        Create a version of ASSERT for use with otherwise unused variables

        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::verifySchemaVersion): Use the new ASSERT_UNUSED macro.

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Non-Mac build fix.

        * loader/appcache/ApplicationCacheStorage.cpp: Include wtf/StringExtras.h for snprintf.

2009-01-05  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by George Staikos.

        Remove unnecessary methods from EmptyFrameLoaderClient

        * loader/EmptyClients.h:

2009-01-05  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23077
        Make application cache use SQLite built-in user_version

        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::verifySchemaVersion): Changed to track versions with
        PRAGMA user_version.

        * loader/appcache/ApplicationCacheResource.h: (WebCore::ApplicationCacheResource::):
        Used the occasion to get rid of the hole in bitmask that was a leftover from opportunistic
        cache entries.

2009-01-04  David Smith  <catfish.man@gmail.com>

        Reviewed by Oliver Hunt.

        https://bugs.webkit.org/show_bug.cgi?id=23084
        Avoid redundant AtomicString conversions

        * dom/Node.cpp:
        (WebCore::Node::getElementsByTagName): Pass starAtom instead of "*"
        (WebCore::Node::getElementsByTagNameNS): Take an AtomicString for the namespace URI
        (WebCore::Node::isDefaultNamespace): Ditto
        (WebCore::Node::lookupPrefix): Ditto
        (WebCore::Node::lookupNamespacePrefix): Ditto
        * dom/Node.h: Ditto

2009-01-04  Darin Adler  <darin@apple.com>

        Reviewed by Oliver Hunt.

        Bug 23105: canvas setFillColor function ignores alpha argument
        https://bugs.webkit.org/show_bug.cgi?id=23105

        Test: fast/canvas/set-colors.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setFillColor): Pass alpha value through instead
        of ignoring it and always passing 1.

        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor): Fix spelling of transparent in comments.
        (WebCore::CanvasStyle::applyFillColor): Ditto.

2009-01-04  Darin Adler  <darin@apple.com>

        Bug 23086: REGRESSION(r39540/r39541): Windows build fails due to ICU errors
        https://bugs.webkit.org/show_bug.cgi?id=23086

        * editing/TextIterator.cpp: Check UCONFIG_NO_COLLATION and don't compile
        in the new search path if it's 0.

2009-01-04  David Kilzer  <ddkilzer@apple.com>

        Don't install *.idl and *.in files as resources

        Reviewed by Oliver Hunt.

        Don't install these files as resources in the WebCore framework:
        - WMLAttributeNames.in
        - WMLTagNames.in
        - WorkerContext.idl
        - WorkerLocation.idl
        - WorkerNavigator.idl

        * WebCore.xcodeproj/project.pbxproj: Removed resources.

2009-01-04  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=23090
        
        If an object gets a Layout hint, and the style change will result in
        the creation of a RenderLayer, then we need to repaint the old position
        of the object. This was done for transform, but we have to test opacity too.

        Test: fast/repaint/create-layer-repaint.html

        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):

2009-01-04  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Bug 23103: Safari's auto-fill no longer works for <select> elements
        https://bugs.webkit.org/show_bug.cgi?id=23103
        rdar://problem/6472061

        * bindings/objc/DOMHTML.mm:
        (-[DOMHTMLSelectElement _activateItemAtIndex:]): Implemented this.

2009-01-04  Adam Treat  <adam.treat@torchmobile.com>

        Reviewed by George Staikos.

        Add fixedLayoutSize feature to ScrollView to allow for controlling the
        layout beyond the constraint of the current viewports dynamic size

        * css/MediaQueryEvaluator.cpp:
        (WebCore::heightMediaFeatureEval):
        (WebCore::widthMediaFeatureEval):
        * dom/Element.cpp:
        (WebCore::Element::clientWidth):
        (WebCore::Element::clientHeight):
        * loader/FrameLoaderClient.cpp:
        (WebCore::FrameLoaderClient::transitionToCommittedForNewPage):
        * loader/FrameLoaderClient.h:
        * page/FrameView.cpp:
        (WebCore::FrameView::layout):
        * platform/ScrollView.cpp:
        (WebCore::ScrollView::ScrollView):
        (WebCore::ScrollView::layoutWidth):
        (WebCore::ScrollView::layoutHeight):
        (WebCore::ScrollView::fixedLayoutSize):
        (WebCore::ScrollView::setFixedLayoutSize):
        (WebCore::ScrollView::useFixedLayout):
        (WebCore::ScrollView::setUseFixedLayout):
        * platform/ScrollView.h:
        * rendering/RenderView.cpp:
        (WebCore::RenderView::viewHeight):
        (WebCore::RenderView::viewWidth):
        * rendering/RenderView.h:

2009-01-03  Rob Buis  <rwlbuis@gmail.com>

        Reviewed by Darin.

        https://bugs.webkit.org/show_bug.cgi?id=22660
        SVG elements that are moved are nor fully invalidated/earsed

        Mark the SVG root as needing a layout when its position changes.

        Tests: svg/custom/circle-move-invalidation.svg

        * rendering/RenderSVGRoot.cpp:
        (WebCore::RenderSVGRoot::position):
        * rendering/RenderSVGRoot.h:

2009-01-03  Steve Falkenburg  <sfalken@apple.com>

        Build fix.

        * loader/FrameLoader.h:

2009-01-02  Cary Clark  <caryclark@google.com>

        Reviewed and landed by Darin Adler.

        Bug 22963: write icons before reading them
        https://bugs.webkit.org/show_bug.cgi?id=22963

        Reverse the order in the icon database main thread loop to
        write the pending icons to the database before trying
        to read any requested icons. This ensures that a requested icon 
        has the correct data when read.
        
        * loader/icon/IconDatabase.cpp:
        (WebCore::IconDatabase::syncThreadMainLoop):

2009-01-02  Darin Adler  <darin@apple.com>

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadItem): One small thing I forgot in my last check-in.
        This cuts down on the number of hash table operations during loading.

2009-01-02  Dmitry Titov  <dimich@chromium.org>

        Reviewed and landed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23025
        DOMTimer lifetime cleanup: timeoutMap methods on Document now do not delete the timer.
        Instead, all 3 places that delete timers do it directly calling 'delete' and then timer's dtor removes the ID from the timeoutMap.
        Note that in case the context is destroyed and timers are deleted at once, the check in ~DOMTimer() prevents 
        unnecessary HashMap remove in case the Document is being destroyed.

        * bindings/js/DOMTimer.cpp:
        (WebCore::DOMTimer::~DOMTimer): removes the id from the timeoutMap.
        (WebCore::DOMTimer::install):
        (WebCore::DOMTimer::removeById): simply uses 'delete this'.
        (WebCore::DOMTimer::fired): same.
        (WebCore::DOMTimer::contextDestroyed): same.
        * dom/Document.cpp:
        (WebCore::Document::removeTimeout): now it only removes the id from the map, does not delete the timer.

2009-01-02  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        Bug 23072: REGRESSION (r37371): In the Dictionary application, scroll bar appears
        inside its web view when resizing its window
        https://bugs.webkit.org/show_bug.cgi?id=23072
        rdar://problem/6368028

        The first attempt at fixing this did not work.
        This time I was able to reproduce the bug and test the fix.

        Bug 11212: REGRESSION: Activity window doesn't always list all files until refresh
        https://bugs.webkit.org/show_bug.cgi?id=11212
        rdar://problem/4959702

        I had to fix this second bug because otherwise the WebKit code to trigger the first
        fix didn't run.

        Also fixes memory use that kept growing as we maintained a set of all URLs loaded in
        a particular frame. Bad idea! It's bad enough that we do it for each document, but
        the old version kept the set around forever as you moved from one document to the next.

        * html/HTMLFrameElementBase.cpp:
        (WebCore::HTMLFrameElementBase::parseMappedAttribute): Change this so that we allow
        turning off scrolling when the quirk is enabled. We just don't allow turning it on.
        This fixes one of the two problems with the initial patch; the other fix is in WebKit.

        * loader/DocumentLoader.h: Moved didTellClientAboutLoad and haveToldClientAboutLoad
        here from FrameLoader. The old way meant that a given frame would forever remember
        the URL of any resources loaded in that frame and never send any "loaded from cache"
        client calls about those URLs.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadResourceSynchronously): Removed call to didTellCientAboutLoad.
        This is now handled by dispatchWillSendRequest, which is safer since that's the actual
        function that tells the client about the load.
        (WebCore::FrameLoader::loadedResourceFromMemoryCache): Changed calls to
        haveToldClientAboutLoad and didTellClientAboutLoad to call the document loader.
        Also removed the call in the case where we don't load from the cache, since
        dispatchWillSendRequest now takes care of it.
        (WebCore::FrameLoader::dispatchWillSendRequest): Put calls to didTellClientAboutLoad
        here. Call it both on the URL we pass in and the URL the client returns; we won't
        tell the client about either if it's loaded from the memory cache.

        * loader/FrameLoader.h: Removed didTellClientAboutLoad, haveToldClientAboutLoad, and
        m_urlsClientKnowsAbout.

        * loader/SubresourceLoader.cpp: Removed unneeded load function that called
        didTellClientAboutLoad. That's now taken care of in dispatchWillSendRequest.

        * loader/SubresourceLoader.h: Removed load function. Also made all members private
        except for create and clearClient.

2009-01-02  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=23082
        
        Fix GIF animation by ensuring that the signature of
        startAnimation() in the base class matches the method in BitmapImage.
        
        Test: fast/backgrounds/animated-gif-as-background.html

        * platform/graphics/Image.h:
        (WebCore::Image::startAnimation):

2009-01-02  David Smith  <catfish.man@gmail.com>

        Reviewed by Darin Adler.
        
        https://bugs.webkit.org/show_bug.cgi?id=22699
        Enable NodeList caching for getElementsByTagName
        
        test: fast/dom/getelementsbytagnamens-mixed-namespaces.html

        * dom/Document.cpp:
        (WebCore::FormElementKeyHash::hash): Use WTF::stringHashingStartValue
        * dom/Node.cpp:
        (WebCore::Node::getElementsByTagNameNS): Ensure rare data and add a node list cache
        (WebCore::NodeListsNodeData::invalidateCaches): Invalidate the tag name node list cache as well as the others
        (WebCore::NodeListsNodeData::isEmpty): Check the tag name node list cache as well as the others
        * dom/NodeRareData.h: Add m_tagNodeListCaches
        * dom/QualifiedName.cpp:
        * dom/QualifiedName.h: Move QNameHash to the header, make it work on QualifiedNames, and rename to QualifiedNameHash
        * dom/StyledElement.cpp:
        (WebCore::MappedAttributeHash::hash): Use WTF::stringHashingStartValue
        * dom/TagNodeList.cpp:
        (WebCore::TagNodeList::TagNodeList): Add a NodeList cache argument
        * dom/TagNodeList.h: 
        (WebCore::TagNodeList::create): Add a NodeList cache argument
        * platform/text/StringHash.h:
        (WebCore::CaseFoldingHash::hash): Use WTF::stringHashingStartValue
        * platform/text/TextEncodingRegistry.cpp:
        (WebCore::TextEncodingNameHash::hash): Use WTF::stringHashingStartValue

2009-01-02  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Darin Adler

        Fix for https://bugs.webkit.org/show_bug.cgi?id=23066 & <rdar://problem/6028417> 
        Full Page Zoom: a <video> element that doesn't include width/height attribute does not scale

        * rendering/RenderVideo.cpp:
        (WebCore::RenderVideo::calcReplacedWidth): Multiply aspect ratio width by style()->effectiveZoom()
        (WebCore::RenderVideo::calcReplacedHeight): Multiply aspect ratio height by style()->effectiveZoom()

2009-01-02  David Kilzer  <ddkilzer@apple.com>

        BUILD FIX (r39552): Add mediaControls.css to other build files

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:

2009-01-02  David Kilzer  <ddkilzer@apple.com>

        Try to fix Wx build after r39427

        * platform/graphics/wx/PathWx.cpp:
        (WebCore::Path::strokeBoundingRect): Added stub.

2009-01-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Adele Peterson.

        <rdar://problem/6471356> Failed assertion on quit

        * platform/ThreadGlobalData.cpp: (WebCore::ThreadGlobalData::~ThreadGlobalData):
        Only assert that empty string are all removed on secondary threads.

2009-01-02  David Kilzer  <ddkilzer@apple.com>

        Bug 23081: These files are no longer part of the KDE libraries

        <https://bugs.webkit.org/show_bug.cgi?id=23081>

        Reviewed by Darin Adler.

        Removed "This file is part of the KDE libraries" comment from
        source files.  Added or updated Apple copyrights as well.

        No tests since there are only changes to comments.

        * bridge/testbindings.cpp:
        * html/HTMLEntityNames.gperf:
        * loader/Cache.h:
        * loader/CachedCSSStyleSheet.h:
        * loader/CachedResourceClient.h:
        * loader/CachedResourceClientWalker.cpp:
        * loader/CachedResourceClientWalker.h:
        * loader/CachedScript.cpp:
        * loader/CachedScript.h:
        * loader/CachedXBLDocument.cpp:
        * loader/CachedXBLDocument.h:
        * loader/CachedXSLStyleSheet.cpp:
        * loader/CachedXSLStyleSheet.h:
        * rendering/GapRects.h:
        * xml/XMLSerializer.cpp:

2009-01-02  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        Use an OwnPtr for m_chromeClient.
        
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::~SVGImage):
        (WebCore::SVGImage::dataChanged):
        * svg/graphics/SVGImage.h:

2009-01-02  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=22981

        Repaints inside of an SVGImage were thrown on the floor,
        which broke incremental painting due to loading, or SVG animation.
        Fix this by assigning the SVGImage a ChromeClient subclass that passes
        along repaints via a new method on ImageObserver, which also takes
        a rect parameter for the changed rect, allowing incremental repaints.
        Fix RenderImage::imageChanged to take advantage of this changedRect to
        only repaint the changed parts of the image.
        
        This also enables incremental painting for canvas-as-image, so
        add tests for that too.

        Tests: fast/backgrounds/animated-svg-as-background.html
               fast/backgrounds/animated-svg-as-mask.html
               fast/canvas/canvas-as-image-incremental-repaint.html
               fast/canvas/canvas-as-image.html
               fast/images/animated-svg-as-image.html

        * css/CSSCanvasValue.cpp:
        (WebCore::CSSCanvasValue::canvasChanged):
        * loader/CachedImage.cpp:
        (WebCore::CachedImage::notifyObservers):
        (WebCore::CachedImage::data):
        (WebCore::CachedImage::changedInRect):
        * loader/CachedImage.h:
        * loader/CachedResourceClient.h:
        (WebCore::CachedResourceClient::imageChanged):
        * platform/graphics/ImageObserver.h:
        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::imageChanged):
        * rendering/RenderBox.h:
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::imageChanged):
        * rendering/RenderImage.h:
        * rendering/RenderListMarker.cpp:
        (WebCore::RenderListMarker::imageChanged):
        * rendering/RenderListMarker.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::imageChanged):
        * rendering/RenderObject.h:
        (WebCore::RenderObject::imageChanged):
        * rendering/RenderSVGImage.cpp:
        (WebCore::RenderSVGImage::imageChanged):
        * rendering/RenderSVGImage.h:
        * rendering/RenderScrollbarPart.cpp:
        (WebCore::RenderScrollbarPart::imageChanged):
        * rendering/RenderScrollbarPart.h:
        * rendering/RenderTableCol.cpp:
        (WebCore::RenderTableCol::imageChanged):
        * rendering/RenderTableCol.h:
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::imageChanged):
        * rendering/RenderTableRow.h:
        * rendering/RenderTableSection.cpp:
        (WebCore::RenderTableSection::imageChanged):
        * rendering/RenderTableSection.h:
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImageChromeClient::SVGImageChromeClient):
        (WebCore::SVGImageChromeClient::image):
        (WebCore::SVGImageChromeClient::chromeDestroyed):
        (WebCore::SVGImageChromeClient::repaint):
        (WebCore::SVGImage::SVGImage):
        (WebCore::SVGImage::~SVGImage):
        (WebCore::SVGImage::dataChanged):
        * svg/graphics/SVGImage.h:

2009-01-02  Eric Carlson  <eric.carlson@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=23043

        Pull media controls css out of html4.css into separate file. Don't generate
        wml, svg, or media css globals unless the feature is enabled.

        * DerivedSources.make:
            Don't include css for unused features.

        * WebCore.xcodeproj/project.pbxproj:
            include mediaControls.css

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::styleForElement):
            don't parse or add media css unless VIDEO feature is enabled and the target
            element is video or audio

        * css/html4.css:
            moved media controls css to mediaControls.css

        * css/mediaControls.css: Added.

2009-01-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23022
        Fix multiple issues with appcache online whitelist handling

        Test: http/tests/appcache/online-whitelist.html

        * loader/appcache/ApplicationCache.cpp:
        (WebCore::ApplicationCache::isURLInOnlineWhitelist): Test whitelist entries as prefixes,
        making it possible to use them for CGI invocation (as required by HTML5).

        * loader/DocumentLoader.cpp: (WebCore::DocumentLoader::shouldLoadResourceFromApplicationCache):
        Re-ordered checks, so that resources that are cached, but are also listed in online whitelist
        are loaded from the cache. This is required by HTML5, although Firefox doesn't match.

        * loader/appcache/ManifestParser.cpp:
        (WebCore::parseManifest):
        * loader/appcache/ManifestParser.h:
        * loader/appcache/ApplicationCache.h:
        (WebCore::ApplicationCache::onlineWhitelist):
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::store):
        (WebCore::ApplicationCacheStorage::loadCache):
        Changed online whitelist to be a vector of URLs, which is better suited for the new algorithm.

2009-01-02  Darin Adler  <darin@apple.com>

        Reviewed by Oliver Hunt.

        Bug 23072: REGRESSION (r37371): In the Dictionary application, scroll bar appears inside its web view when resizing its window
        https://bugs.webkit.org/show_bug.cgi?id=23072
        rdar://problem/6368028

        * WebCore.base.exp: Updated.
        * WebCore.xcodeproj/project.pbxproj: Mark HTMLHeadElement.h Private so it can be used in WebKit.

        * dom/Document.cpp:
        (WebCore::Document::Document): Initialize m_frameElementsShouldIgnoreScrolling to false.
        * dom/Document.h: Added setFrameElementsShouldIgnoreScrolling, frameElementsShouldIgnoreScrolling,
        and m_frameElementsShouldIgnoreScrolling.

        * html/HTMLFrameElementBase.cpp:
        (WebCore::HTMLFrameElementBase::parseMappedAttribute): Don't allow changes to the scrolling attribute
        to affect the scrolling mode if frameElementsShouldIgnoreScrolling() returns true. This is only
        triggered on Mac OS X when running the Dictionary application.

2009-01-02  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23036
        <rdar://problem/6451666> Implement AppCache fallback entries (23036)

        Test: http/tests/appcache/fallback.html

        * loader/FrameLoader.cpp: (WebCore::FrameLoader::loadResourceSynchronously): Use fallback
        entries if normal loading fails.

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::shouldLoadResourceFromApplicationCache): Do not prevent normal
        loading for resources that match fallback namespaces - they are only loaded from the cache
        if that fails.
        (WebCore::DocumentLoader::getApplicationCacheFallbackResource): Get a fallback entry for
        resource from associated appcache, or from passed in one, if any.
        (WebCore::DocumentLoader::scheduleLoadFallbackResourceFromApplicationCache): If a fallback
        entry for resourse exists, add it to pending substitute loads.

        * loader/DocumentLoader.h: Added new functions for loading fallback data for resources.

        * loader/ResourceLoader.h:
        * loader/ResourceLoader.cpp:
        (WebCore::ResourceLoader::scheduleLoadFallbackResourceFromApplicationCache): This function
        is called when normal loading fails (which includes network failures, 4xx and 5xx responses,
        and cross-origin redirects) to load appcache fallback data instead. It can use either the
        cache that is associated with the browsing context, or a custom one if association is yet
        to take place.
        (WebCore::ResourceLoader::willSendRequest): Try using fallback data.
        (WebCore::ResourceLoader::didReceiveResponse): Ditto.
        (WebCore::ResourceLoader::didFail): Ditto.

        * loader/MainResourceLoader.cpp:
        (WebCore::MainResourceLoader::didReceiveResponse): Locate an appropriate cache and load
        fallback data from it if loading fails. The browsing context may still be associated with
        its previous document here, so the cache to load from must be passed explicitly.
        (WebCore::MainResourceLoader::didFail): Ditto.
        (WebCore::MainResourceLoader::load): Remove unnecessary check and FIXME.

        * loader/appcache/ApplicationCache.cpp:
        (WebCore::ApplicationCache::setFallbackURLs):
        (WebCore::ApplicationCache::urlMatchesFallbackNamespace):
        * loader/appcache/ApplicationCache.h:
        (WebCore::ApplicationCache::fallbackURLs):
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::ApplicationCacheStorage::cacheGroupForURL):
        (WebCore::ApplicationCacheStorage::fallbackCacheGroupForURL):
        (WebCore::ApplicationCacheStorage::store):
        (WebCore::ApplicationCacheStorage::loadCache):
        (WebCore::ApplicationCacheStorage::storeCopyOfCache):
        * loader/appcache/ApplicationCacheStorage.h:
        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::fallbackCacheForMainRequest):
        (WebCore::ApplicationCacheGroup::didFinishLoadingManifest):
        * loader/appcache/ApplicationCacheGroup.h:
        Implement fallback map saving and loading, pass it to the cache.

        * loader/appcache/ManifestParser.h: Use a correct data structure for fallback map - keys
        are matched by prefix, so HAshMap cannot be used.

        * loader/appcache/ManifestParser.cpp: (WebCore::parseManifest): Fix bugs in fallback section
        parsing.

2009-01-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6450530> WebCore::FontPlatformData should not leak

        Whoops, previous patch should also have fixed the font referencing in
        the constructor.

        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/mac/FontPlatformDataMac.mm:
        (WebCore::FontPlatformData::FontPlatformData):

2009-01-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Dan Bernstein.

        <rdar://problem/6450530> WebCore::FontPlatformData should not leak

        Make sure we only adopt the new font, rather than re-referencing (and so leaking).

        * platform/graphics/mac/FontPlatformDataMac.mm:
        (WebCore::FontPlatformData::setFont):

2009-01-01  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Bug 23071: REGRESSION (r39536): New test failures after committing patch in bug 23051 (ICU search)
        https://bugs.webkit.org/show_bug.cgi?id=23071

        Also fix some things that Dan suggested during review of the ICU search patch that I forgot
        the first time around.

        * editing/TextIterator.cpp: Use ICU search on all platforms that use ICU, now that
        we've double checked it works everywhere, removing HAVE_ICU_SEARCH entirely.
        Removed unused m_atBreak data member from the non-ICU code path.
        (WebCore::TextIterator::TextIterator): Move null check up.
        (WebCore::TextIterator::handleTextBox): Fix mistake that made the iterator include
        collapsed whitespace. This was left over from an earlier version of the patch.
        (WebCore::SimplifiedBackwardsTextIterator::SimplifiedBackwardsTextIterator):
        Move null check up.

2009-01-01  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler, Oliver Hunt

        https://bugs.webkit.org/show_bug.cgi?id=23065
        
        Enable incremental painting of canvas. This turns incremental painting
        back on, and fixes issues with stroke width and miters, calling willDraw()
        for strokeText and fillText, and taking shadows into account.
        
        Test: fast/canvas/canvas-incremental-repaint.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasStrokeStyleApplier::CanvasStrokeStyleApplier):
        (WebCore::CanvasStrokeStyleApplier::strokeStyle):
        (WebCore::CanvasRenderingContext2D::stroke):
        (WebCore::CanvasRenderingContext2D::willDraw):
        (WebCore::CanvasRenderingContext2D::putImageData):
        (WebCore::CanvasRenderingContext2D::drawTextInternal):
        * html/CanvasRenderingContext2D.h:
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::willDraw):
        * platform/graphics/FloatRect.h:
        (WebCore::mapRect): new method to map a rect contained
        in one rect to an equivalent rect inside another rect.

2008-12-29  Konstantin Käfer  <kkaefer@gmail.com>

        Reviewed by Tim Hatcher.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=17229
        <rdar://problem/5732829> Inspector should show properties of all JS objects in Console

        Prints objects not as plain text but makes them expandable so that
        they can be inspected.

        * inspector/front-end/Console.js:
        (): added a parameter "inline" to the WebInspector.Console._format function which indicates
            whether the object is printed in the context of another string (with console.log()) or
            as sole element.
        (.): objects and DOM nodes are now printed in an expandable form when they are printed alone
            (i.e. not in the context of a console.log() string) so that they can be inspected.
        * inspector/front-end/PropertiesSection.js:
        (WebInspector.PropertiesSection.prototype.set title): Allow DOM Nodes as title instead of strings
            in that case, the Node is inserted into the title instead of the string value of the passed
            object. This is used for displaying linkified titles, for example when inspecting DOM nodes,
            the syntax highlighted HTML representation is shown instead of the plain source code.
        * inspector/front-end/inspector.css: correct the offsetParent for the expandable object inspector.

2009-01-01  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        Bug 23051: web page searching should use ICU's search so it can ignore diacritical differences
        https://bugs.webkit.org/show_bug.cgi?id=23051
        rdar://problem/3574497

        Test: editing/execCommand/findString-diacriticals.html

        * editing/TextIterator.cpp: Changed the CircularSearchBuffer class to have a new
        name, since it doesn't always use a circular buffer any more. Changed the interface
        so it can work well in the new chunky comparison mode for ICU search, and also
        added private data members for both the ICU-search and non-ICU-search code paths.
        (WebCore::TextIterator::TextIterator): Use the versions of the Range functions
        that don't take an exception code.
        (WebCore::TextIterator::handleTextBox): Added a special case to handle the position
        of a collapsed-away space better. This is not needed for search mechanism, but was
        helpful in an earlier version of this patch, and is still an improvement.
        (WebCore::SimplifiedBackwardsTextIterator::SimplifiedBackwardsTextIterator): Use the
        versions of the Range functions that don't take an exception code.
        (WebCore::CharacterIterator::range): Ditto.
        (WebCore::characterSubrange): Added. Helper function used in both places below where
        we want to convert a range and character offsets into a subrange.
        (WebCore::WordAwareIterator::advance): Use the versions of the Range functions that
        don't take an exception code.
        (WebCore::createSearcher): Added.
        (WebCore::searcher): Added.
        (WebCore::lockSearcher): Added.
        (WebCore::unlockSearcher): Added.
        (WebCore::SearchBuffer::SearchBuffer): Added.
        (WebCore::SearchBuffer::~SearchBuffer): Added.
        (WebCore::SearchBuffer::append): Added.
        (WebCore::SearchBuffer::atBreak): Added.
        (WebCore::SearchBuffer::reachedBreak): Added.
        (WebCore::SearchBuffer::search): Added.
        (WebCore::SearchBuffer::length): Added.
        (WebCore::TextIterator::subrange): Changed to call the characterSubrange
        function above.
        (WebCore::TextIterator::rangeFromLocationAndLength): Use the versions of the
        Range functions that don't take an exception code. Also tweak some other details
        of the code.
        (WebCore::isAllCollapsibleWhitespace): Added.
        (WebCore::collapsedToBoundary): Added.
        (WebCore::findPlainText): Rewrote to use new interface and streamline the
        logic a bit.

        Add the relevant files in the icu directory. As icu/README says, the "icu"
        directory is really just for Mac OS X, where we have the ICU library but not
        the headers installed. It should be moved inside platform/mac at some point
        to make this more clear (and the copy in JavaScriptCore should be moved
        somewhere similar for the same reason).

        * icu/unicode/ucoleitr.h: Added.
        * icu/unicode/usearch.h: Added.

2009-01-01  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        CrashTracer: [REGRESSION] 1090 crashes in Safari at com.apple.JavaScriptCore: KJS::JSGlobalObject::stopTimeoutCheck + 0
        <rdar://problem/5821130>

        This was caused by a plugin instance calling into JS code that removed the plugin
        object.  This fix is to cache the global object locally in a ProtectedPtr so we don't
        need to rely on the continued existence of the plugin instance.

        * bridge/NP_jsobject.cpp:
        (_NPN_InvokeDefault):
        (_NPN_Invoke):
        (_NPN_Evaluate):
        (_NPN_Construct):

2008-12-31  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Holger Freyther.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22964

        MinGW build failure.

        * platform/graphics/qt/SimpleFontDataQt.cpp:
        (WebCore::SimpleFontData::containsCharacters):

2008-12-31  Alexander V. Butenko  <alex@digiqube.com>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=22750
        [gtk] webkit up to r39121 crash on image urls like
        http:///sitename.com

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::ResourceHandle::start):

2008-12-31  Hiroyuki Ikezoe  <poincare@ikezoe.net>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=18310

        * platform/graphics/gtk/SimpleFontDataPango.cpp:
        (WebCore::SimpleFontData::determinePitch): Do not invoke
        isFixedPitch() when the font is a custom font.

2008-12-31  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        More work on Bug 3781: Animation via canvas could be faster
        <https://bugs.webkit.org/show_bug.cgi?id=3781>

        Make use of the fast path parsing of color strings that Color
        uses.  This improves performance of '#rgb', '#rrggbb', etc and
        named (eg. 'green') colors.

        Improves frame rate of test by around 40%

        * html/CanvasStyle.cpp:
        (WebCore::CanvasStyle::applyStrokeColor):
        (WebCore::CanvasStyle::applyFillColor):

2008-12-30  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=23042
        
        Rather than doing a repaint() inside of computeAbsoluteRepaintRect()
        when there is a reflection, compute the location of the rect inside
        the reflection and take the union of the unreflected and reflected rects.
        
        Test: fast/repaint/reflection-redraw.html

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::computeAbsoluteRepaintRect):
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::reflectedRect):
        * rendering/RenderObject.h:

2008-12-30  Dan Bernstein  <mitz@apple.com>

        Reviewed by Adele Peterson.

        - fix <rdar://problem/6469944> REGRESSION(3.2.1-ToT): Repro crash in WebCore::HTMLInputElement::updatePlaceholderVisibility opening http://billshrink.com

        Test: fast/forms/placeholder-non-textfield.html

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::parseMappedAttribute): Only call
        updatePlaceholderVisibility() when the placeholder attribute changes if
        the element is a text field.

2008-12-30  Oliver Hunt  <oliver@apple.com>

        Reviewed by Antti Koivisto.

        First step of Bug 3781: Animation via canvas could be faster

        Amortise the cost of calling repaint by coalescing repaint rects
        while the canvas is drawn to.  In a later step we'll stop calling
        repaint() directly, and instead have all dirty canvases repaint
        at the end of JS execution.

        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::willDraw):
        (WebCore::HTMLCanvasElement::paint):
        * html/HTMLCanvasElement.h:

2008-12-30  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Antti Koivisto.

        Bug 22931: Using the inspector with purgeable resources leads to assertion failures
        <https://bugs.webkit.org/show_bug.cgi?id=22931>

        Change InspectorResource::sourceString() so that it doesn't attempt to
        unsafely get the data of a purgeable CachedResource.

        * inspector/InspectorController.cpp:
        (WebCore::InspectorResource::sourceString): Attempt to make a purgeable
        resource unpurgeable, and if this not possible, return an empty string.
        * loader/CachedResource.h: Make InspectorResource a friend of CachedResource.

2008-12-29  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=23023
        Remove incomplete support for opportunistic appcache entries

        No change in behavior, thus no test.

        * loader/appcache/ApplicationCacheResource.h:
        (WebCore::ApplicationCacheResource::Type): Removed Opportunistic bit, will re-use when schema
        version changes.

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::scheduleApplicationCacheLoad):
        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::didFinishLoadingManifest):
        * loader/appcache/ApplicationCacheResource.cpp:
        (WebCore::ApplicationCacheResource::dumpType):

2008-12-29  Dirk Schulze  <krit@webkit.org>

        Reviewed by Oliver Hunt.

        Add arcTo support for Cairo. This is needed by Canvas.
        Cairo has no native support for arcTo. We have to make our
        own implementation.

        [Canvas] Cairo needs arcTo
        https://bugs.webkit.org/show_bug.cgi?id=23003

        * platform/graphics/cairo/PathCairo.cpp:
        (WebCore::Path::addArcTo):

2008-12-29  Oliver Hunt  <oliver@apple.com>

        Reviewed by Cameron Zwarich.

        Bug 23030: Cannot setTransform with a non-invertible ctm

        Removed a series of unnecessary and incorrect checks for an invertible
        transform.

        Test: fast/canvas/canvas-set-properties-with-non-invertible-ctm.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setStrokeStyle):
        (WebCore::CanvasRenderingContext2D::setFillStyle):
            These properties are not effected by the current CTM, so there
            is no need to prevent them from being assigned.

        (WebCore::CanvasRenderingContext2D::setTransform):
            The whole point of tracking whether the current CTM was expected to be
            non-invertible was to allow setTransform to be used when the CTM had become
            non-invertible.

        (WebCore::CanvasRenderingContext2D::beginPath):
        (WebCore::CanvasRenderingContext2D::closePath):
            beginPath and closePath change the state of the path, but not any of
            its coordinates so there is no need prevent them from being called.

2008-12-29  Josh Roesslein  <jroesslein@gmail.com>

        Reviewed by Oliver Hunt.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22968

        Context menu rendering error when full page zoomed

        * page/ContextMenuController.cpp:
        (WebCore::ContextMenuController::handleContextMenuEvent):

2008-12-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Add some basic memory statistic logging for Node.

        * dom/Node.cpp:
        (WebCore::Node::dumpStatistics):
        (WebCore::Node::Node):
        (WebCore::Node::~Node):
        (WebCore::Node::setDocument):
        * dom/Node.h:

2008-12-29  Sam Weinig  <sam@webkit.org>

        Reviewed by Anders Carlsson.

        Remove one use of DeprecatedPtrList.

        * css/CSSRuleList.cpp:
        (WebCore::CSSRuleList::~CSSRuleList):
        (WebCore::CSSRuleList::length):
        (WebCore::CSSRuleList::item):
        (WebCore::CSSRuleList::deleteRule):
        (WebCore::CSSRuleList::append):
        (WebCore::CSSRuleList::insertRule):
        * css/CSSRuleList.h: Change m_lstCSSRules from using DeprecatedPtrList to a Vector.
        I measured no performance change and was comforted by the fact that we use a Vector
        for StyleList, which serves the exact same purpose.

2008-12-29  Adele Peterson  <adele@apple.com>

        Reviewed by Brady Eidson.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=21797
        <rdar://problem/6310682> REGRESSION: Crash in CFHTTPCookieStorageCopy beneath WebCore::cookies() when 
        running fast/dom/document-attribute-js-null.html and http/tests/security/cookies/create-document.html
        
        Return early if the document is trying to get or set a cookie with an empty cookie url.

        * dom/Document.cpp:
        (WebCore::Document::cookie):
        (WebCore::Document::setCookie):

2008-12-28  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Sam Weinig.

        Bug 23016: JavaScriptDebugServer::recompileAllJSFunctions() should not execute JS while reparsing all functions
        <https://bugs.webkit.org/show_bug.cgi?id=23016>
        <rdar://problem/6425077>

        JavaScriptDebugServer::recompileAllJSFunctions() calls sourceParsed() while
        reparsing all JS functions, which will execute JS in the inspector. Depending
        on the order in which functions are recompiled, a function could have a new
        body but other functions that have not been recompiled could have an optimized
        (in the sense of inline caching) call to it, bypassing the check of whether or
        not there is generated bytecode. This leads to a crash caused by accessing
        indices off of a null pointer.

        To fix the problem, simply delay calling sourceParsed() until after all functions
        have been reparsed. The crash isn't 100% reproducible, but on the one test case
        I have, this makes it impossible to reproduce after a large number of attempts,
        when it used to happen every few attempts.

        * inspector/JavaScriptDebugServer.cpp:
        (WebCore::JavaScriptDebugServer::recompileAllJSFunctions):

2008-12-28  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Rubber-stamped by Antti Koivisto.
        Oops, remove some last minute ASSERTS that are obviously wrong.

        * rendering/RenderTextControlMultiLine.cpp:
        (WebCore::RenderTextControlMultiLine::RenderTextControlMultiLine):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::RenderTextControlSingleLine):

2008-12-28  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Antti Koivisto.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=23015

        Don't rely on HTMLFormControlElement in RenderTextControl.

        Introduce an abstract FormControlElement class, containing the
        valueMatchesRenderer/setValueMatchesRenderer, the only HTMLFormControlElement
        specific methods that RenderTextControl relies on.

        This makes it possible for WML to reuse RenderTextControl.
        RenderTextControlSingleLine still relies on HTMLInputElement,
        this will change if WMLInputElement is introduced.

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/FormControlElement.h: Added.
        (WebCore::FormControlElement::~FormControlElement):
        (WebCore::FormControlElement::FormControlElement):
        * html/HTMLFormControlElement.h:
        (WebCore::HTMLFormControlElement::valueMatchesRenderer):
        (WebCore::HTMLFormControlElement::setValueMatchesRenderer):
        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::updateValue):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::adjustInnerTextStyle):
        (WebCore::RenderTextControl::updateFromElement):
        (WebCore::RenderTextControl::setInnerTextValue):
        (WebCore::RenderTextControl::selectionChanged):
        (WebCore::RenderTextControl::formControlElement):
        * rendering/RenderTextControl.h:
        * rendering/RenderTextControlMultiLine.cpp:
        (WebCore::RenderTextControlMultiLine::RenderTextControlMultiLine):
        (WebCore::RenderTextControlMultiLine::subtreeHasChanged):
        * rendering/RenderTextControlSingleLine.cpp:
        (WebCore::RenderTextControlSingleLine::RenderTextControlSingleLine):
        (WebCore::RenderTextControlSingleLine::updateFromElement):

2008-12-28  Cameron Zwarich  <cwzwarich@uwaterloo.ca>

        Reviewed by Darin Adler.

        Bug 23006: Many Loader::Host member functions are not safe to use reentrantly
        <https://bugs.webkit.org/show_bug.cgi?id=23006>
        <rdar://problem/6216106>

        Many Loader::Host member functions set m_processingResource to true when they
        begin processing a resource and set it to false when they are done. Thanks to
        JavaScript and the web inspector, almost anything can happen during the
        processing of a resource, including these functions being called reentrantly,
        which is unsafe due to this way of using m_processingResource.

        This can theoretically cause a Loader::Host to be used after it is freed,
        because when Loader::servedPendingRequests() is called, it will free Hosts
        that have m_processingResource set to false.

        To fix this, we replace m_processingResource with m_numResourcesProcessing,
        which is incremented and decremented using a helper object, ProcessingResource.

        There are no occurrences of crashes caused by this bug that are reproducible
        by multiple people, but this fixes the problem of m_processingResource being
        set to false while a Host is still alive.

        * loader/loader.cpp:
        (WebCore::Loader::Host::Host):
        (WebCore::Loader::Host::didFinishLoading): Change to use ProcessingResource
        instead of manually setting m_processingResource.
        (WebCore::Loader::Host::didFail): Ditto.
        (WebCore::Loader::Host::didReceiveData): Ditto.
        * loader/loader.h:
        (WebCore::Loader::Host::ProcessingResource::ProcessingResource): Added.
        (WebCore::Loader::Host::ProcessingResource::~ProcessingResource): Added.
        (WebCore::Loader::Host::processingResource): Change to use m_numResourcesProcessing
        instead of just getting m_processingResource.

2008-12-28  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23007
        REGRESSION: Timer-related crash when closing Web Inspector

        Test: fast/dom/Window/remove-timeout-crash.html

        * bindings/js/DOMTimer.cpp: (WebCore::DOMTimer::fired): Besides deleting the timer, make
        sure to remove it from a Document map.

2008-12-28  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Anders Carlsson.

        https://bugs.webkit.org/show_bug.cgi?id=23012
        Bring application cache manifest parsing up to date

        Test: http/tests/appcache/manifest-parsing.html

        * loader/appcache/ManifestParser.cpp:
        (WebCore::Mode): Added a constant for unknown sections, which are ignored when parsing. This
        is necessary for future extensions.
        (WebCore::parseManifest): Parse unknown sections correctly. Ignore trailing tokens in
        supported sections.

2008-12-28  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22996

        RenderTextControl heavily depends on HTMLInputElement & HTMLTextAreaElement.
        It handles multi & single line text control rendering in one class. Split up
        in two new classes: RenderTextControlSingleLine & RenderTextControlMultiLine.

        This has several benefits - code is more readable now, the memory usage
        for RenderTextControlMultiLine is reduced, as all stuff related to search fields
        lives in RenderTextControlSingleLine, and it's easier to introduce an
        abstraction for input/textarea-like elements for other HTML flavours like WML.

        * GNUmakefile.am:
        * WebCore.order:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::createRenderer):
        (WebCore::HTMLInputElement::defaultEventHandler):
        (WebCore::HTMLInputElement::updatePlaceholderVisibility):
        (WebCore::HTMLInputElement::addSearchResult):
        (WebCore::HTMLInputElement::onSearch):
        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::createRenderer):
        (WebCore::HTMLTextAreaElement::defaultEventHandler):
        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::RenderTextControl):
        (WebCore::RenderTextControl::~RenderTextControl):
        (WebCore::RenderTextControl::styleDidChange):
        (WebCore::RenderTextControl::adjustInnerTextStyle):
        (WebCore::RenderTextControl::createSubtreeIfNeeded):
        (WebCore::RenderTextControl::textBlockHeight):
        (WebCore::RenderTextControl::textBlockWidth):
        (WebCore::RenderTextControl::updateFromElement):
        (WebCore::RenderTextControl::setInnerTextValue):
        (WebCore::RenderTextControl::setSelectionRange):
        (WebCore::RenderTextControl::visiblePositionForIndex):
        (WebCore::RenderTextControl::indexForVisiblePosition):
        (WebCore::RenderTextControl::subtreeHasChanged):
        (WebCore::RenderTextControl::scrollbarThickness):
        (WebCore::RenderTextControl::calcHeight):
        (WebCore::RenderTextControl::hitInnerTextBlock):
        (WebCore::RenderTextControl::forwardEvent):
        (WebCore::RenderTextControl::calcPrefWidths):
        (WebCore::RenderTextControl::selectionChanged):
        (WebCore::RenderTextControl::innerTextElement):
        * rendering/RenderTextControl.h:
        (WebCore::RenderTextControl::hasControlClip):
        (WebCore::RenderTextControl::canHaveChildren):
        (WebCore::RenderTextControl::avoidsFloats):
        (WebCore::RenderTextControl::isEdited):
        (WebCore::RenderTextControl::setEdited):
        * rendering/RenderTextControlMultiLine.cpp: Added.
        (WebCore::RenderTextControlMultiLine::RenderTextControlMultiLine):
        (WebCore::RenderTextControlMultiLine::~RenderTextControlMultiLine):
        (WebCore::RenderTextControlMultiLine::subtreeHasChanged):
        (WebCore::RenderTextControlMultiLine::layout):
        (WebCore::RenderTextControlMultiLine::nodeAtPoint):
        (WebCore::RenderTextControlMultiLine::forwardEvent):
        (WebCore::RenderTextControlMultiLine::preferredContentWidth):
        (WebCore::RenderTextControlMultiLine::adjustControlHeightBasedOnLineHeight):
        (WebCore::RenderTextControlMultiLine::baselinePosition):
        (WebCore::RenderTextControlMultiLine::updateFromElement):
        (WebCore::RenderTextControlMultiLine::cacheSelection):
        (WebCore::RenderTextControlMultiLine::createInnerTextStyle):
        * rendering/RenderTextControlMultiLine.h: Added.
        (WebCore::RenderTextControlMultiLine::isTextArea):
        * rendering/RenderTextControlSingleLine.cpp: Added.
        (WebCore::RenderTextControlSingleLine::RenderTextControlSingleLine):
        (WebCore::RenderTextControlSingleLine::~RenderTextControlSingleLine):
        (WebCore::RenderTextControlSingleLine::placeholderShouldBeVisible):
        (WebCore::RenderTextControlSingleLine::updatePlaceholderVisibility):
        (WebCore::RenderTextControlSingleLine::addSearchResult):
        (WebCore::RenderTextControlSingleLine::stopSearchEventTimer):
        (WebCore::RenderTextControlSingleLine::showPopup):
        (WebCore::RenderTextControlSingleLine::hidePopup):
        (WebCore::RenderTextControlSingleLine::subtreeHasChanged):
        (WebCore::RenderTextControlSingleLine::paint):
        (WebCore::RenderTextControlSingleLine::layout):
        (WebCore::RenderTextControlSingleLine::nodeAtPoint):
        (WebCore::RenderTextControlSingleLine::forwardEvent):
        (WebCore::RenderTextControlSingleLine::styleDidChange):
        (WebCore::RenderTextControlSingleLine::capsLockStateMayHaveChanged):
        (WebCore::RenderTextControlSingleLine::textBlockWidth):
        (WebCore::RenderTextControlSingleLine::preferredContentWidth):
        (WebCore::RenderTextControlSingleLine::adjustControlHeightBasedOnLineHeight):
        (WebCore::RenderTextControlSingleLine::createSubtreeIfNeeded):
        (WebCore::RenderTextControlSingleLine::updateFromElement):
        (WebCore::RenderTextControlSingleLine::cacheSelection):
        (WebCore::RenderTextControlSingleLine::createInnerTextStyle):
        (WebCore::RenderTextControlSingleLine::createInnerBlockStyle):
        (WebCore::RenderTextControlSingleLine::createResultsButtonStyle):
        (WebCore::RenderTextControlSingleLine::createCancelButtonStyle):
        (WebCore::RenderTextControlSingleLine::updateCancelButtonVisibility):
        (WebCore::RenderTextControlSingleLine::autosaveName):
        (WebCore::RenderTextControlSingleLine::startSearchEventTimer):
        (WebCore::RenderTextControlSingleLine::searchEventTimerFired):
        (WebCore::RenderTextControlSingleLine::valueChanged):
        (WebCore::RenderTextControlSingleLine::itemText):
        (WebCore::RenderTextControlSingleLine::itemIsEnabled):
        (WebCore::RenderTextControlSingleLine::itemStyle):
        (WebCore::RenderTextControlSingleLine::menuStyle):
        (WebCore::RenderTextControlSingleLine::clientInsetLeft):
        (WebCore::RenderTextControlSingleLine::clientInsetRight):
        (WebCore::RenderTextControlSingleLine::clientPaddingLeft):
        (WebCore::RenderTextControlSingleLine::clientPaddingRight):
        (WebCore::RenderTextControlSingleLine::listSize):
        (WebCore::RenderTextControlSingleLine::selectedIndex):
        (WebCore::RenderTextControlSingleLine::itemIsSeparator):
        (WebCore::RenderTextControlSingleLine::itemIsLabel):
        (WebCore::RenderTextControlSingleLine::itemIsSelected):
        (WebCore::RenderTextControlSingleLine::setTextFromItem):
        (WebCore::RenderTextControlSingleLine::fontSelector):
        (WebCore::RenderTextControlSingleLine::hostWindow):
        (WebCore::RenderTextControlSingleLine::createScrollbar):
        * rendering/RenderTextControlSingleLine.h: Added.
        (WebCore::RenderTextControlSingleLine::hasControlClip):
        (WebCore::RenderTextControlSingleLine::isTextField):
        (WebCore::RenderTextControlSingleLine::placeholderIsVisible):
        (WebCore::RenderTextControlSingleLine::popupIsVisible):
        (WebCore::RenderTextControlSingleLine::shouldPopOver):
        (WebCore::RenderTextControlSingleLine::valueShouldChangeOnHotTrack):
        * rendering/TextControlInnerElements.cpp:
        (WebCore::RenderTextControlInnerBlock::nodeAtPoint):
        (WebCore::SearchFieldResultsButtonElement::defaultEventHandler):

2008-12-28  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22755
        Prepare to add create/remove timeout methods to JSWorkerContext by moving
        timer-specific code from JSDOMWindowBase to DOMTimer.
        Moved everything JS-related from DOMTimer to ScheduledAction.
        Now ScheduledAction is what it wanted to be all the time: a JS engine-specific 
        container for timer callback that knows how to invoke it.
        DOMTimer is not anymore JS-specific.

        This is mostly moving the code around. No intended functional changes.

        * bindings/js/DOMTimer.cpp:
        (WebCore::DOMTimer::DOMTimer):
        (WebCore::DOMTimer::~DOMTimer):
        (WebCore::DOMTimer::install):
        (WebCore::DOMTimer::removeById):
        (WebCore::DOMTimer::fired):
        (WebCore::DOMTimer::stop):
        * bindings/js/DOMTimer.h:
        * bindings/js/JSDOMWindowBase.cpp:
        (WebCore::JSDOMWindowBase::installTimeout):
        (WebCore::JSDOMWindowBase::removeTimeout):
        * bindings/js/JSDOMWindowBase.h:
        * bindings/js/ScheduledAction.cpp:
        (WebCore::ScheduledAction::execute):
        * bindings/js/ScheduledAction.h:
        * dom/Document.cpp:
        (WebCore::Document::addTimeout):

2008-12-26  Zalan Bujtas  <zbujtas@gmail.com>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22999
        Check if database thread exists.

        * storage/Database.cpp:
        (WebCore::Database::openAndVerifyVersion):
        (WebCore::Database::markAsDeletedAndClose):
        (WebCore::Database::tableNames):

2008-12-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=23001
        A call to applicationCache.update() from a cached event listener should be ignored

        Test: http/tests/appcache/idempotent-update.html

        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::checkIfLoadIsComplete): Only reset m_status after
        dispatching events.

2008-12-26  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22997
        ASSERTION FAILED: !m_resources.contains(url) in ApplicationCache::addResource()

        Tests: http/tests/appcache/top-frame-1.html
               http/tests/appcache/top-frame-2.html
               http/tests/appcache/top-frame-3.html
               http/tests/appcache/top-frame-4.html

        * loader/appcache/ApplicationCacheGroup.cpp: (WebCore::ApplicationCacheGroup::cacheForMainRequest):
        Fixed one more instance of top level frame being used for caching purposes.

2008-12-26  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22987
        Fix for broken test editing/execCommand/5763082.html

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::mergeIdenticalElements): Used local RefPtr to hold onto
        function parameter across multiple calls.

2008-12-25  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22993
        Application cache shouldn't be inherited by subframes

        <rdar://problem/6284708> AppCache crashes in ApplicationCacheResource::addType()
        This crash happened because main resource for subframe was looked up in top frame's
        appcache. If not for the spec change, it could have been fixed by preventing the load
        altogether.

        Test: http/tests/appcache/foreign-iframe-main.html
        I intend to write additional tests for the behavior change.

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::shouldLoadResourceFromApplicationCache):
        * loader/DocumentLoader.h:
        (WebCore::DocumentLoader::applicationCache):
        * loader/MainResourceLoader.cpp:
        (WebCore::MainResourceLoader::load):
        * loader/appcache/DOMApplicationCache.cpp:
        (WebCore::DOMApplicationCache::associatedCache):
        Removed DocumentLoader::topLevelApplicationCache(), and changed callers accordingly.

        * loader/appcache/ApplicationCacheGroup.cpp:
        (WebCore::ApplicationCacheGroup::selectCache):
        (WebCore::ApplicationCacheGroup::selectCacheWithoutManifestURL):
        Removed checks for the frame being top-level one, now that subframes are cached independently.

2008-12-25  Antti Koivisto  <antti@apple.com>

        Reviewed by Oliver Hunt.

        <rdar://problem/6465669> Frequent !isPurgeable() assertion in WebCore::CachedResource::addClient
        
        Disallow turning resources that are being revalidated to purgable state.
        
        No test, the condition is difficult to produce in DRT.

        * loader/CachedCSSStyleSheet.cpp:
        (WebCore::CachedCSSStyleSheet::allClientsRemoved):
        * loader/CachedImage.cpp:
        (WebCore::CachedImage::destroyDecodedData):
        * loader/CachedResource.cpp:
        (WebCore::CachedResource::isSafeToMakePurgeable):
        (WebCore::CachedResource::makePurgeable):
        * loader/CachedResource.h:
        * loader/CachedScript.cpp:
        (WebCore::CachedScript::destroyDecodedData):

2008-12-25  Alexey Proskuryakov  <ap@webkit.org>

        Qt build fix.

        * WebCore.pro: Added ThreadGlobalData.cpp.

2008-12-24  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * WebCore.base.exp:  Remove a symbol from the export file now that it is no longer generated.

2008-12-24  Holger Hans Peter Freyther  <zecke@selfish.org>

        Unreviewed build fix to find addSubresourceURL

        This is needed to compile on WebKit/Gtk+

        * css/CSSFontFaceSrcValue.cpp:

2008-12-23  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22980
        WebCore uses more thread specific keys than it really needs

        Consolidated ThreadSpecific data into a single ThreadGlobalData structure.

        * GNUmakefile.am:
        * WebCore.base.exp:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * dom/EventNames.cpp:
        * dom/EventNames.h:
        (WebCore::eventNames):
        * page/Frame.cpp:
        (WebCore::Frame::Frame):
        * platform/ThreadGlobalData.cpp: Added.
        (WebCore::threadGlobalData):
        (WebCore::ThreadGlobalData::ThreadGlobalData):
        (WebCore::ThreadGlobalData::~ThreadGlobalData):
        * platform/ThreadGlobalData.h: Added.
        (WebCore::ThreadGlobalData::eventNames):
        (WebCore::ThreadGlobalData::emptyString):
        (WebCore::ThreadGlobalData::atomicStringTable):
        (WebCore::ThreadGlobalData::cachedConverterICU):
        (WebCore::ThreadGlobalData::cachedConverterTEC):
        * platform/text/AtomicString.cpp:
        (WebCore::stringTable):
        (WebCore::AtomicString::add):
        (WebCore::AtomicString::remove):
        (WebCore::AtomicString::find):
        (WebCore::AtomicString::init):
        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::empty):
        * platform/text/StringImpl.h:
        * platform/text/TextCodecICU.cpp:
        (WebCore::ICUConverterWrapper::~ICUConverterWrapper):
        (WebCore::cachedConverterICU):
        * platform/text/TextCodecICU.h:
        (WebCore::ICUConverterWrapper::ICUConverterWrapper):
        * platform/text/mac/TextCodecMac.cpp:
        (WebCore::cachedConverterTEC):
        * platform/text/mac/TextCodecMac.h:
        (WebCore::TECConverterWrapper::TECConverterWrapper):
        (WebCore::TECConverterWrapper::~TECConverterWrapper):

2008-12-23  Mark Rowe  <mrowe@apple.com>

        Build fix.

        * WebCore.xcodeproj/project.pbxproj: CSSPropertyNames.h is a generated file so it needs to be explicitly copied
        into the PrivateHeaders directory, rather than relying on the automatic copying of headers which runs before the
        derived sources are generated.

2008-12-23  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        https://bugs.webkit.org/show_bug.cgi?id=22941
        
        If the document element has opacity, we need to erase the view background to
        white before painting.
        
        Test: fast/backgrounds/opacity-on-document-element.html

        * rendering/RenderView.cpp:
        (WebCore::rendererObscuresBackground):

2008-12-23  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        https://bugs.webkit.org/show_bug.cgi?id=21910
        
        Fix SVGImage painting by ensuring that the SVGImage resizes its FrameView correctly.
        Otherwise the FrameView is left at 0x0, and nothing paints.
        
        * svg/graphics/SVGImage.cpp:
        (WebCore::SVGImage::draw):

2008-12-23  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - improve robustness of undo/redo in HTML editing to fix the following bugs
          <https://bugs.webkit.org/show_bug.cgi?id=19703> Crash in WebCore::InsertNodeBeforeCommand::doUnapply()
          <rdar://problem/4059423> DOM operations performed on editable HTML can cause a crash later during Undo

        Major categories of improvements:

            1) Added null checks.
            2) Eliminated type casts without corresponding type checks.
            3) Avoided possible infinite loops by building up lists of nodes to operate on
               before starting to make DOM changes.
            4) Use more RefPtr.

        No test at this time, but test cases should follow in separate patches.

        * WebCore.xcodeproj/project.pbxproj: Set the role of CSSPropertyNames.h to Private so it
        can be used in other Private headers, specifically editing ones.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::locateCousinList): Adopt parentElement.
        (WebCore::CSSStyleSelector::locateSharedStyle): Ditto.
        (WebCore::CSSStyleSelector::SelectorChecker::checkOneSelector): Ditto.

        * dom/Element.cpp: (WebCore::Element::cloneElement): Added.
        * dom/Element.h: Added cloneElement and an implementation of parentElement.
        * dom/Node.h: Moved parentElement from here to Element.h and changed its
        implementation so it will return 0 when the parent is not an element
        (document, document fragment, etc.).

        * editing/AppendNodeCommand.cpp:
        (WebCore::AppendNodeCommand::AppendNodeCommand): Made parent be an Element.
        Moved assertions from doApply in here.
        (WebCore::AppendNodeCommand::doApply): Simplified to just a single unchecked
        appendChild call.
        (WebCore::AppendNodeCommand::doUnapply): Simplified to just a single remove call.
        * editing/AppendNodeCommand.h: Updated.

        * editing/ApplyStyleCommand.cpp:
        (WebCore::createStyleSpanElement): Eliminate casting by creating an element in a more
        direct way with new instead of createElementNS.
        (WebCore::ApplyStyleCommand::ApplyStyleCommand): Use PassRefPtr.
        (WebCore::ApplyStyleCommand::removeCSSStyle): Use CSSPropertyID.
        (WebCore::ApplyStyleCommand::addInlineStyleIfNeeded): Use cloneElement.
        * editing/ApplyStyleCommand.h:

        * editing/BreakBlockquoteCommand.cpp:
        (WebCore::BreakBlockquoteCommand::doApply): Use Element* and cloneElement.

        * editing/CompositeEditCommand.cpp:
        (WebCore::CompositeEditCommand::applyStyledElement): Use PassRefPtr and unsigned.
        (WebCore::CompositeEditCommand::removeStyledElement): Ditto.
        (WebCore::CompositeEditCommand::insertNodeBefore): Ditto.
        (WebCore::CompositeEditCommand::insertNodeAfter): Ditto.
        (WebCore::CompositeEditCommand::insertNodeAt): Ditto.
        (WebCore::CompositeEditCommand::appendNode): Ditto.
        (WebCore::CompositeEditCommand::removeChildrenInRange): Ditto. Also use a vector to
        make the list of children in case removing them has side effects.
        (WebCore::CompositeEditCommand::removeNode): Ditto.
        (WebCore::CompositeEditCommand::removeNodePreservingChildren): Ditto.
        (WebCore::CompositeEditCommand::removeNodeAndPruneAncestors): Ditto.
        (WebCore::CompositeEditCommand::splitTextNode): Ditto.
        (WebCore::CompositeEditCommand::splitElement): Ditto.
        (WebCore::CompositeEditCommand::mergeIdenticalElements): Ditto.
        (WebCore::CompositeEditCommand::wrapContentsInDummySpan): Ditto.
        (WebCore::CompositeEditCommand::splitTextNodeContainingElement): Ditto.
        (WebCore::CompositeEditCommand::joinTextNodes): Ditto.
        (WebCore::CompositeEditCommand::inputText): Ditto.
        (WebCore::CompositeEditCommand::insertTextIntoNode): Ditto.
        (WebCore::CompositeEditCommand::deleteTextFromNode): Ditto.
        (WebCore::CompositeEditCommand::replaceTextInNode): Ditto.
        (WebCore::CompositeEditCommand::insertNodeAtTabSpanPosition): Ditto.
        (WebCore::CompositeEditCommand::removeCSSProperty): Ditto.
        (WebCore::CompositeEditCommand::removeNodeAttribute): Ditto. Implement by calling
        setNodeAttribute instead of with its own SimpleEditCommand.
        (WebCore::CompositeEditCommand::setNodeAttribute): Ditto.
        (WebCore::CompositeEditCommand::deleteInsignificantText): Ditto.
        (WebCore::CompositeEditCommand::appendBlockPlaceholder): Ditto.
        (WebCore::CompositeEditCommand::addBlockPlaceholderIfNeeded): Ditto.
        (WebCore::CompositeEditCommand::insertNewDefaultParagraphElementAt): Ditto. Don't
        bother using an undoable operation to put the break element into the paragraph
        element because there's no need to split them and redo this when doing undo/redo.
        (WebCore::CompositeEditCommand::moveParagraphs): Ditto.
        (WebCore::CompositeEditCommand::breakOutOfEmptyListItem): Ditto.
        * editing/CompositeEditCommand.h: Ditto.

        * editing/DeleteFromTextNodeCommand.cpp:
        (WebCore::DeleteFromTextNodeCommand::DeleteFromTextNodeCommand): Use unsigned.
        (WebCore::DeleteFromTextNodeCommand::doApply): Eliminated inappropriate assertions.
        (WebCore::DeleteFromTextNodeCommand::doUnapply): Ditto.
        * editing/DeleteFromTextNodeCommand.h:

        * editing/DeleteSelectionCommand.cpp:
        (WebCore::DeleteSelectionCommand::removeNode): Use PassRefPtr.
        (WebCore::DeleteSelectionCommand::deleteTextFromNode): Ditto.
        * editing/DeleteSelectionCommand.h:

        * editing/FormatBlockCommand.cpp:
        (WebCore::FormatBlockCommand::FormatBlockCommand): Use AtomicString.
        (WebCore::FormatBlockCommand::doApply): Use Element.
        * editing/FormatBlockCommand.h:

        * editing/IndentOutdentCommand.cpp:
        (WebCore::createIndentBlockquoteElement): Use new to create the element
        instead of calling a function so we have a more specific type.
        (WebCore::IndentOutdentCommand::prepareBlockquoteLevelForInsertion):
        Use RefPtr and Element.
        (WebCore::IndentOutdentCommand::indentRegion): Ditto.
        (WebCore::IndentOutdentCommand::outdentParagraph): Ditto.
        * editing/IndentOutdentCommand.h:

        * editing/InsertIntoTextNodeCommand.cpp:
        (WebCore::InsertIntoTextNodeCommand::InsertIntoTextNodeCommand):
        Use unsigned. Added an assertion.
        (WebCore::InsertIntoTextNodeCommand::doApply): Eliminated inappropriate assertions.
        (WebCore::InsertIntoTextNodeCommand::doUnapply): Ditto.
        * editing/InsertIntoTextNodeCommand.h:

        * editing/InsertLineBreakCommand.cpp:
        (WebCore::InsertLineBreakCommand::insertNodeAfterPosition): Use Element.
        (WebCore::InsertLineBreakCommand::insertNodeBeforePosition): Ditto.

        * editing/InsertListCommand.cpp:
        (WebCore::InsertListCommand::doApply): Use Element.

        * editing/InsertNodeBeforeCommand.cpp:
        (WebCore::InsertNodeBeforeCommand::InsertNodeBeforeCommand): Moved assertions
        here from doApply.
        (WebCore::InsertNodeBeforeCommand::doApply): Eliminated inappropriate assertions.
        Added a null check.
        (WebCore::InsertNodeBeforeCommand::doUnapply): Simplified to just a single remove call.

        * editing/InsertParagraphSeparatorCommand.cpp:
        (WebCore::InsertParagraphSeparatorCommand::doApply): Use Element and cloneElement.

        * editing/JoinTextNodesCommand.cpp:
        (WebCore::JoinTextNodesCommand::doApply): Eliminated inappropriate assertions.
        Added some runtime checks. Don't store anything in m_offset.
        (WebCore::JoinTextNodesCommand::doUnapply): Ditto.
        * editing/JoinTextNodesCommand.h:

        * editing/MergeIdenticalElementsCommand.cpp:
        (WebCore::MergeIdenticalElementsCommand::MergeIdenticalElementsCommand): Moved
        an assertion here from doApply.
        (WebCore::MergeIdenticalElementsCommand::doApply): Eliminated inappropriate assertions.
        Added a null check. Changed implementation to use remove to avoid null parent issue.
        Use a vector of nodes to avoid possible infinite loop if mutation happens while iterating.
        (WebCore::MergeIdenticalElementsCommand::doUnapply): Ditto.

        * editing/ModifySelectionListLevel.cpp:
        (WebCore::ModifySelectionListLevelCommand::appendSiblingNodeRange): Use Element*.
        (WebCore::IncreaseSelectionListLevelCommand::doApply): Ditto.
        * editing/ModifySelectionListLevel.h:

        * editing/RemoveCSSPropertyCommand.cpp:
        (WebCore::RemoveCSSPropertyCommand::RemoveCSSPropertyCommand): Use PassRefPtr and
        CSSPropertyID. Also renamed m_decl to m_style.
        (WebCore::RemoveCSSPropertyCommand::doApply): Eliminated inappropriate assertions.
        (WebCore::RemoveCSSPropertyCommand::doUnapply): Ditto.

        * editing/RemoveNodeAttributeCommand.cpp: Removed contents of this file. To be deleted.
        Use SetNodeAttributeCommand instead.
        * editing/RemoveNodeAttributeCommand.h: Ditto.

        * editing/RemoveNodeCommand.cpp:
        (WebCore::RemoveNodeCommand::RemoveNodeCommand): Moved assertions here from doApply.
        Don't initialize m_refChild here; rather do it in doApply.
        (WebCore::RemoveNodeCommand::doApply): Eliminated inappropriate assertions. Added
        checks and streamlined implementation.
        (WebCore::RemoveNodeCommand::doUnapply): Ditto.
        * editing/RemoveNodeCommand.h:

        * editing/RemoveNodePreservingChildrenCommand.cpp:
        (WebCore::RemoveNodePreservingChildrenCommand::doApply): Use a vector.

        * editing/ReplaceSelectionCommand.cpp:
        (WebCore::ReplacementFragment::insertFragmentForTestRendering): Removed now-unneeded cast.

        * editing/SetNodeAttributeCommand.cpp:
        (WebCore::SetNodeAttributeCommand::SetNodeAttributeCommand): Use AtomicString.
        Removed assertion that prevents us from using this to remove an attribute.
        (WebCore::SetNodeAttributeCommand::doApply): Eliminated inappropriate assertions.
        (WebCore::SetNodeAttributeCommand::doUnapply): Ditto.
        * editing/SetNodeAttributeCommand.h:

        * editing/SplitElementCommand.cpp:
        (WebCore::SplitElementCommand::SplitElementCommand): Moved assertion here from doApply.
        (WebCore::SplitElementCommand::doApply): Check some more invariants and use a vector
        to avoid possible infinite loops.
        (WebCore::SplitElementCommand::doUnapply): Ditto.

        * editing/SplitTextNodeCommand.cpp:
        (WebCore::SplitTextNodeCommand::SplitTextNodeCommand): Moved assertions and comment
        here from doApply.
        (WebCore::SplitTextNodeCommand::doApply): Check for null and failures when applying.
        (WebCore::SplitTextNodeCommand::doUnapply): Ditto.

        * editing/SplitTextNodeContainingElementCommand.cpp:
        (WebCore::SplitTextNodeContainingElementCommand::doApply): Use Element.

        * editing/WrapContentsInDummySpanCommand.cpp:
        (WebCore::WrapContentsInDummySpanCommand::doApply): Check for null and ignore failures.
        Don't reuse the dummy span. Simplified logic.
        (WebCore::WrapContentsInDummySpanCommand::doUnapply): Ditto.

        * editing/htmlediting.cpp:
        (WebCore::isBlock): Make sure this returns true only for elements.
        (WebCore::enclosingBlock): Return an Element*.
        (WebCore::enclosingTableCell): Ditto.
        (WebCore::enclosingList): Return an HTMLElement*.
        (WebCore::outermostEnclosingList): Return an HTMLElement*.
        (WebCore::createDefaultParagraphElement): Return an HTMLElement*.
        (WebCore::createBreakElement): Return an HTMLElement*.
        (WebCore::createOrderedListElement): Return an HTMLElement*.
        (WebCore::createUnorderedListElement): Return an HTMLElement*.
        (WebCore::createListItemElement): Return an HTMLElement*.
        (WebCore::createHTMLElement): Return an HTMLElement*.
        * editing/htmlediting.h:

        * editing/markup.cpp:
        (WebCore::createFragmentFromText): Use createBreakElement and use Element*.

        * page/MouseEventWithHitTestResults.cpp:
        (WebCore::MouseEventWithHitTestResults::targetNode): Use parentElement.

2008-12-23  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        * dom/Node.h: Tweak comments and order of bits that Sam moved
        here last night.
        * dom/Node.cpp: Ditto.

2008-12-22  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Darin Adler.

        Bug 11106: Some XMLHttpRequest URI resolving tests fail
        https://bugs.webkit.org/show_bug.cgi?id=11106

        Use the ScriptExecutionContext to resolve the URI when calling open in JavaScript.
        The previous code was using the containing DOMWindow to do so which would fail for
        XMLHttpRequest object being passed between iframe.

        Tests: http/tests/xmlhttprequest/uri-resolution-opera-open-004.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-005.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-006.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-007.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-008.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-009.html
               http/tests/xmlhttprequest/uri-resolution-opera-open-010.html

        * bindings/js/JSXMLHttpRequestCustom.cpp:
        (WebCore::JSXMLHttpRequest::open): Use the ScriptExecutionContext
        to resolve the URL.

        * dom/Document.cpp:
        (WebCore::Document::virtualCompleteURL): Virtual method added to
        avoid performance hit on completeURL call.

        * dom/Document.h:
        * dom/ScriptExecutionContext.h:
        (WebCore::ScriptExecutionContext::completeURL): Non-virtual method
        that wrap the call to the virtual call.
        * dom/WorkerContext.cpp:
        (WebCore::WorkerContext::virtualCompleteURL): Pure virtual method.
        * dom/WorkerContext.h:

2008-12-23  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        - https://bugs.webkit.org/show_bug.cgi?id=22978
          a couple tweaks to the new strokeBoundingRect functions

        * platform/graphics/cairo/PathCairo.cpp:
        (WebCore::Path::strokeBoundingRect): Only create a GraphicsContext
        if the applier is non-null.

        * platform/graphics/cg/PathCG.cpp:
        (WebCore::putBytesNowhere): Added.
        (WebCore::createScratchContext): Changed to use a "/dev/null" type
        function to discard bytes rather than using a data object. This
        eliminates the possibility that memory will be used if someone draws
        into the scratch context by accident. Also moved to the top of the
        file; it was in a slightly strange place before.
        (WebCore::Path::strokeBoundingRect): Only create a GraphicsContext
        if the applier is non-null. Simplify the empty path special case.

2008-12-22  Sam Weinig  <sam@webkit.org>

        Reviewed by Mark Rowe.

        Save a word in all Elements by moving the 5 loose bits to Node,
        where we had 16 spare.

        * dom/Element.cpp:
        (WebCore::Element::Element):
        * dom/Element.h:
        * dom/Node.cpp:
        (WebCore::Node::Node):
        * dom/Node.h:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22972

        Add WML <meta> element support. All needed functionality is present
        in Document::processHttpEquiv, already covered by tests.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * wml/WMLMetaElement.cpp: Added.
        (WebCore::WMLMetaElement::WMLMetaElement):
        (WebCore::WMLMetaElement::parseMappedAttribute):
        (WebCore::WMLMetaElement::insertedIntoDocument):
        * wml/WMLMetaElement.h: Added.
        * wml/WMLTagNames.in:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Rubber-stamped by Darin Adler.

        Don't reference specific layout tests in comments.

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::createFormData):

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22965

        Add WML <head> element support. Doesn't require a WMLHeadElement.
        No functional behaviour, as we already created a WMLElement for headTag, by default.
        It's just cleaner to list <head> in WMLTagNames, forwarding to a WMLElement constructor.

        * wml/WMLTagNames.in:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22971

        Fix regression caused by the HTMLFormElement refactorization.
        File form elements without a name have to be included in multipart/form-data
        submission. Cover this behaviour with a new test case.

        Test: http/tests/misc/empty-file-formdata.html

        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::createFormData):
        * wml/WMLTagNames.in:

2008-12-22  David Kilzer  <ddkilzer@apple.com>

        <rdar://problem/6438298> Bump schema version for app cache

        Reviewed by Alexey Proskuryakov.

        * loader/appcache/ApplicationCacheStorage.cpp: Increment
        SchemaVersion from 2 to 3.

2008-12-22  David Kilzer  <ddkilzer@apple.com>

        Use Deque in CSSStyleSheet::addSubresourceStyleURLs()

        Reviewed by Darin Adler.

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::addSubresourceStyleURLs): Replaced
        use of ListHashSet with more efficient Deque.

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Sam Weinig.

        Fix obvious crash fix for WML enabled builds.

        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::adjustRenderStyle):

2008-12-22  David Kilzer  <ddkilzer@apple.com>

        Bug 11850: Webarchive fails to save images referenced in CSS

        <https://bugs.webkit.org/show_bug.cgi?id=11850>

        Reviewed by Darin Adler.

        This entry contains two parts since the tests for adding a
        completeURL() method to StyleSheet and CSSStyleSheet (part 1) depend
        on Bug 11850 being fixed (part 2).

        --

        Tests: http/tests/webarchive/test-css-url-encoding-shift-jis.html
               http/tests/webarchive/test-css-url-encoding-utf-8.html
               http/tests/webarchive/test-css-url-encoding.html

        Added completeURL() methods to StyleSheet and CSSStyleSheet that
        match the behavior of Document::completeURL().  Most notably,
        CSSStyleSheet::completeURL() uses the charset of the stylesheet
        (if it exists) to construct URLs, just like Document::completeURL().

        * css/CSSParser.cpp:
        (WebCore::CSSParser::parseValue): Use CSSStyleSheet::completeURL().
        (WebCore::CSSParser::parseContent): Ditto.
        (WebCore::CSSParser::parseFillImage): Ditto.
        (WebCore::CSSParser::parseFontFaceSrc): Ditto.
        (WebCore::CSSParser::parseBorderImage): Ditto.

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::completeURL): Added.
        * css/CSSStyleSheet.h:
        (WebCore::CSSStyleSheet::completeURL): Added declaration.

        * css/StyleSheet.cpp:
        (WebCore::StyleSheet::completeURL): Added.
        * css/StyleSheet.h:
        (WebCore::StyleSheet::completeURL): Added declaration.

        * dom/Document.cpp:
        (WebCore::Document::completeURL): Added comment referring to the new
        completeURL() methods in StyleSheet and CSSStyleSheet.

        --

        Tests: webarchive/test-css-url-resources-in-stylesheets.html
               webarchive/test-css-url-resources-inline-styles.html

        Walk stylesheets and inline style attributes for url() references
        when building a list of URLs to include in a webarchive.  Note that
        not all URLs found this way will be included in the webarchive if
        they were not used (and thus not downloaded) when laying out the
        page.

        The key method for CSS stylesheets is
        CSSStyleSheet::addSubresourceStyleURLs() which iterates over all
        CSSStyleSheet objects recursively referenced from its own stylesheet
        through @import rules.  Starting with the CSSRule objects in each
        sheet and continuing down through the CSSMutableStyleDeclaration and
        CSSValue objects, addSubresourceStyleURLs() methods are called to
        gather URLs.

        For inline style attributes in HTML DOM elements,
        StyledElement::addSubresourceAttributeURLs() calls
        CSSMutableStyleDeclaration::addSubresourceStyleURLs() to gather URLs
        from each element, hence the need to call
        addSubresourceAttributeURLs() on superclasses when the method is
        implemented on the element class itself.

        * css/CSSBorderImageValue.cpp:
        (WebCore::CSSBorderImageValue::addSubresourceStyleURLs): Added.
        * css/CSSBorderImageValue.h:
        (WebCore::CSSBorderImageValue::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSFontFaceRule.cpp:
        (WebCore::CSSFontFaceRule::addSubresourceStyleURLs): Added.
        * css/CSSFontFaceRule.h:
        (WebCore::CSSFontFaceRule::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSFontFaceSrcValue.cpp:
        (WebCore::CSSFontFaceSrcValue::addSubresourceStyleURLs): Added.
        * css/CSSFontFaceSrcValue.h:
        (WebCore::CSSFontFaceSrcValue::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSImportRule.cpp:
        (WebCore::CSSImportRule::addSubresourceStyleURLs): Added.
        * css/CSSImportRule.h:
        (WebCore::CSSImportRule::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSMutableStyleDeclaration.cpp:
        (WebCore::CSSMutableStyleDeclaration::addSubresourceStyleURLs): Added.
        Iterates over m_properties vector of CSSProperty objects calling
        addSubresourceStyleURLs() on each property's CSSValue object.
        * css/CSSMutableStyleDeclaration.h:
        (WebCore::CSSMutableStyleDeclaration::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSPrimitiveValue.cpp:
        (WebCore::CSSPrimitiveValue::addSubresourceStyleURLs): Added.
        * css/CSSPrimitiveValue.h:
        (WebCore::CSSPrimitiveValue::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSReflectValue.cpp:
        (WebCore::CSSReflectValue::addSubresourceStyleURLs): Added.
        * css/CSSReflectValue.h:
        (WebCore::CSSReflectValue::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSRule.h:
        (WebCore::CSSRule::addSubresourceStyleURLs): Added.  Virtual
        method with empty implementation that's overridden by subclasses
        as needed.

        * css/CSSStyleRule.cpp:
        (WebCore::CSSStyleRule::addSubresourceStyleURLs): Added.
        * css/CSSStyleRule.h:
        (WebCore::CSSStyleRule::addSubresourceStyleURLs): Added
        declaration.

        * css/CSSStyleSheet.cpp:
        (WebCore::CSSStyleSheet::addSubresourceStyleURLs): Updated to
        call CSSRule::addSubresourceStyleURLs on each rule to extract
        URLs.  Removed unneeded baseURL parameter now that the
        completeURL() method exists.
        * css/CSSStyleSheet.h:
        (WebCore::CSSStyleSheet::addSubresourceStyleURLs): Updated
        declaration.

        * css/CSSValue.h:
        (WebCore::CSSValue::addSubresourceStyleURLs): Added.  Virtual
        method with empty implementation that's overridden by subclasses
        as needed.

        * css/CSSValueList.cpp:
        (WebCore::CSSValueList::addSubresourceStyleURLs): Added.
        Iterates over m_values vector of CSSValue objects calling
        addSubresourceStyleURLs() on each.
        * css/CSSValueList.h:
        (WebCore::CSSValueList::addSubresourceStyleURLs): Added
        declaration.

        * css/StyleSheet.h:
        (WebCore::StyleSheet::addSubresourceStyleURLs): Updated
        declaration to remove unneeded baseURL parameter.

        * dom/ProcessingInstruction.cpp:
        (WebCore::ProcessingInstruction::addSubresourceAttributeURLs):
        Fixed to use the StyleBase::baseURL() method to get the
        stylesheet's URL instead of calling Document::completeURL().

        * dom/StyledElement.cpp:
        (WebCore::StyledElement::addSubresourceAttributeURLs): Added method
        to extract URLs from inline style declarations.
        * dom/StyledElement.h:
        (WebCore::StyledElement::addSubresourceAttributeURLs): Added
        declaration.

        * html/HTMLBodyElement.cpp:
        (WebCore::HTMLBodyElement::addSubresourceAttributeURLs): Call
        addSubresourceAttributeURLs() in superclass to extract URLs
        from inline style declarations.
        * html/HTMLEmbedElement.cpp:
        (WebCore::HTMLEmbedElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLImageElement.cpp:
        (WebCore::HTMLImageElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLObjectElement.cpp:
        (WebCore::HTMLObjectElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLParamElement.cpp:
        (WebCore::HTMLParamElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLTableCellElement.cpp:
        (WebCore::HTMLTableCellElement::addSubresourceAttributeURLs): Ditto.
        * html/HTMLTableElement.cpp:
        (WebCore::HTMLTableElement::addSubresourceAttributeURLs): Ditto.
        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::addSubresourceAttributeURLs): Ditto.
        * svg/SVGFEImageElement.cpp:
        (WebCore::SVGFEImageElement::addSubresourceAttributeURLs): Ditto.
        * svg/SVGImageElement.cpp:
        (WebCore::SVGImageElement::addSubresourceAttributeURLs): Ditto.
        * svg/SVGScriptElement.cpp:
        (WebCore::SVGScriptElement::addSubresourceAttributeURLs): Ditto.

2008-12-22  Dhananjoy Chutia  <dhanrd@gmail.com>

        Reviewed by David Kilzer.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22959
        Memory leak fixes for WebKit+soup

        * platform/network/soup/ResourceHandleSoup.cpp:
        (WebCore::finishedCallback):

2008-12-22  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        <rdar://problem/6277060> ASSERTION FAILED: !m_cacheBeingUpdated if the manifest is not available

        Tests: http/tests/appcache/404-manifest.html
               http/tests/appcache/fail-on-update.html

        * loader/appcache/ApplicationCacheGroup.cpp: (WebCore::ApplicationCacheGroup::stopLoading):
        Removed the incorrect assertion.

        * loader/appcache/ApplicationCacheGroup.h: Added an explanation of somewhat nonintuitive
        m_currentHandle handling.

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Alexey Proskuryakov & George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22961

        Add WML <fieldset> element support.
        Unlike HTML's <fieldset> element, WML doesn't provide a <legend> child element
        to describe the <fieldset>. WML instead offers a 'title' attribute on the <fieldset>
        element. To integrate within the existing RenderFieldset code, we just create an
        internal <insertedLegend> element as first child for a WML <fieldset> element, containing
        the title attribute value.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * css/CSSStyleSelector.cpp:
        (WebCore::CSSStyleSelector::adjustRenderStyle):
        * css/wml.css:
        * rendering/RenderFieldset.cpp:
        (WebCore::RenderFieldset::RenderFieldset):
        (WebCore::RenderFieldset::findLegend):
        * rendering/RenderFieldset.h:
        * rendering/RenderLegend.cpp:
        (WebCore::RenderLegend::RenderLegend):
        * rendering/RenderLegend.h:
        * wml/WMLFieldSetElement.cpp: Added.
        (WebCore::WMLFieldSetElement::WMLFieldSetElement):
        (WebCore::WMLFieldSetElement::~WMLFieldSetElement):
        (WebCore::WMLFieldSetElement::parseMappedAttribute):
        (WebCore::WMLFieldSetElement::insertedIntoDocument):
        (WebCore::WMLFieldSetElement::removedFromDocument):
        (WebCore::WMLFieldSetElement::createRenderer):
        * wml/WMLFieldSetElement.h: Added.
        * wml/WMLInsertedLegendElement.cpp: Added.
        (WebCore::WMLInsertedLegendElement::WMLInsertedLegendElement):
        (WebCore::WMLInsertedLegendElement::~WMLInsertedLegendElement):
        (WebCore::WMLInsertedLegendElement::createRenderer):
        * wml/WMLInsertedLegendElement.h: Added.
        * wml/WMLTagNames.in:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Not reviewed. Try to fix clean Mac builds, set role=private for FormDataBuilder.h

        * WebCore.xcodeproj/project.pbxproj:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Rubber-stamped by George Staikos.

        Unify all TorchMobile copyright lines. Consolidate in a single line, as requested by Mark Rowe, some time ago.

        * css/CSSStyleSelector.cpp:
        * css/wml.css:
        * dom/DOMImplementation.cpp:
        * dom/Document.cpp:
        * dom/Document.h:
        * dom/XMLTokenizer.cpp:
        * dom/XMLTokenizerLibxml2.cpp:
        * dom/XMLTokenizerQt.cpp:
        * history/BackForwardList.cpp:
        * history/BackForwardList.h:
        * loader/FrameLoader.cpp:
        * loader/FrameLoader.h:
        * loader/MainResourceLoader.cpp:
        * page/Page.cpp:
        * page/Page.h:
        * platform/MIMETypeRegistry.cpp:
        * platform/network/FormDataBuilder.cpp:
        * platform/network/FormDataBuilder.h:
        * platform/qt/MIMETypeRegistryQt.cpp:
        * wml/WMLAElement.cpp:
        * wml/WMLAElement.h:
        * wml/WMLAccessElement.cpp:
        * wml/WMLAccessElement.h:
        * wml/WMLAnchorElement.cpp:
        * wml/WMLAnchorElement.h:
        * wml/WMLBRElement.cpp:
        * wml/WMLBRElement.h:
        * wml/WMLCardElement.cpp:
        * wml/WMLCardElement.h:
        * wml/WMLDoElement.cpp:
        * wml/WMLDoElement.h:
        * wml/WMLDocument.cpp:
        * wml/WMLDocument.h:
        * wml/WMLElement.cpp:
        * wml/WMLElement.h:
        * wml/WMLErrorHandling.cpp:
        * wml/WMLErrorHandling.h:
        * wml/WMLEventHandlingElement.cpp:
        * wml/WMLEventHandlingElement.h:
        * wml/WMLGoElement.cpp:
        * wml/WMLGoElement.h:
        * wml/WMLImageElement.cpp:
        * wml/WMLImageElement.h:
        * wml/WMLImageLoader.cpp:
        * wml/WMLImageLoader.h:
        * wml/WMLIntrinsicEvent.cpp:
        * wml/WMLIntrinsicEvent.h:
        * wml/WMLIntrinsicEventHandler.cpp:
        * wml/WMLIntrinsicEventHandler.h:
        * wml/WMLNoopElement.cpp:
        * wml/WMLNoopElement.h:
        * wml/WMLOnEventElement.cpp:
        * wml/WMLOnEventElement.h:
        * wml/WMLPElement.cpp:
        * wml/WMLPElement.h:
        * wml/WMLPageState.cpp:
        * wml/WMLPageState.h:
        * wml/WMLPostfieldElement.cpp:
        * wml/WMLPostfieldElement.h:
        * wml/WMLPrevElement.cpp:
        * wml/WMLPrevElement.h:
        * wml/WMLRefreshElement.cpp:
        * wml/WMLRefreshElement.h:
        * wml/WMLSetvarElement.cpp:
        * wml/WMLSetvarElement.h:
        * wml/WMLTableElement.cpp:
        * wml/WMLTableElement.h:
        * wml/WMLTaskElement.cpp:
        * wml/WMLTaskElement.h:
        * wml/WMLTemplateElement.cpp:
        * wml/WMLTemplateElement.h:
        * wml/WMLTimerElement.cpp:
        * wml/WMLTimerElement.h:
        * wml/WMLVariables.cpp:
        * wml/WMLVariables.h:

2008-12-22  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22638

        Add POST method support to WMLGoElement. GET & POST over HTTP
        covered by a new set of WML HTTP layout tests.

        Tests: http/tests/wml/go-task-get-method-accept-charset.html
               http/tests/wml/go-task-get-method.html
               http/tests/wml/go-task-post-method-accept-charset.html
               http/tests/wml/go-task-post-method.html

        * wml/WMLGoElement.cpp:
        (WebCore::WMLGoElement::WMLGoElement):
        (WebCore::WMLGoElement::registerPostfieldElement):
        (WebCore::WMLGoElement::parseMappedAttribute):
        (WebCore::WMLGoElement::executeTask):
        (WebCore::WMLGoElement::preparePOSTRequest):
        (WebCore::WMLGoElement::prepareGETRequest):
        (WebCore::WMLGoElement::createFormData):
        * wml/WMLGoElement.h:
        * wml/WMLPostfieldElement.cpp:
        (WebCore::encodedString):
        (WebCore::WMLPostfieldElement::encodeData):
        * wml/WMLPostfieldElement.h:

2008-12-21  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler and George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22949

        Refactor HTMLFormElement to share a maximum level of code between HTMLFormElement & WMLGoElement.
        Create a new helper class 'FormDataBuilder', which is hold as member variable in those classes.
        It encapsulates all functionality needed to generate a FormData object, usable for HTML/WML form
        submission, including boundary string generation, multi-part form handling etc.

        No functional changes, no test cases affected.
        WMLGoElement will be converted in a follow-up patch.

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * html/HTMLFormElement.cpp:
        (WebCore::HTMLFormElement::HTMLFormElement):
        (WebCore::HTMLFormElement::dataEncoding):
        (WebCore::HTMLFormElement::createFormData):
        (WebCore::HTMLFormElement::submit):
        (WebCore::HTMLFormElement::parseMappedAttribute):
        * html/HTMLFormElement.h:
        (WebCore::HTMLFormElement::enctype):
        (WebCore::HTMLFormElement::encoding):
        (WebCore::HTMLFormElement::setEncoding):
        (WebCore::HTMLFormElement::acceptCharset):
        * platform/network/FormDataBuilder.cpp: Added.
        (WebCore::FormDataBuilder::FormDataBuilder):
        (WebCore::FormDataBuilder::~FormDataBuilder):
        (WebCore::FormDataBuilder::parseEncodingType):
        (WebCore::FormDataBuilder::parseMethodType):
        (WebCore::FormDataBuilder::dataEncoding):
        (WebCore::appendString):
        (WebCore::FormDataBuilder::beginMultiPartHeader):
        (WebCore::FormDataBuilder::addBoundaryToMultiPartHeader):
        (WebCore::FormDataBuilder::addFileNameToMultiPartHeader):
        (WebCore::FormDataBuilder::addContentTypeToMultiPartHeader):
        (WebCore::FormDataBuilder::finishMultiPartHeader):
        (WebCore::FormDataBuilder::clear):
        (WebCore::FormDataBuilder::addKeyValuePairAsFormData):
        (WebCore::FormDataBuilder::encodeStringAsFormData):
        (WebCore::FormDataBuilder::generateUniqueBoundaryString):
        * platform/network/FormDataBuilder.h: Added.
        (WebCore::FormDataBuilder::isPostMethod):
        (WebCore::FormDataBuilder::setIsPostMethod):
        (WebCore::FormDataBuilder::isMultiPartForm):
        (WebCore::FormDataBuilder::setIsMultiPartForm):
        (WebCore::FormDataBuilder::encodingType):
        (WebCore::FormDataBuilder::setEncodingType):
        (WebCore::FormDataBuilder::acceptCharset):
        (WebCore::FormDataBuilder::setAcceptCharset):
        (WebCore::FormDataBuilder::encodedData):
        (WebCore::FormDataBuilder::multiPartData):

2008-12-21  Dirk Schulze  <krit@webkit.org>

        Reviewed by Darin Adler, Nikolas Zimmermann.

        Move the the platform dependent strokeBBox functionality out of RenderPath
        into Path with strokeBoundingRect.

        RenderPath clean-up for strokeBoundingBox
        [https://bugs.webkit.org/show_bug.cgi?id=22902]

        * GNUmakefile.am:
        * WebCore.xcodeproj/project.pbxproj:
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/Path.h:
        * platform/graphics/StrokeStyleApplier.h: Added.
        (WebCore::StrokeStyleApplier::~StrokeStyleApplier):
        * platform/graphics/cairo/PathCairo.cpp:
        (WebCore::Path::strokeBoundingRect):
        * platform/graphics/cg/PathCG.cpp:
        (WebCore::createScratchContext):
        (WebCore::scratchContext):
        (WebCore::Path::strokeBoundingRect):
        * platform/graphics/qt/GraphicsContextQt.cpp:
        (WebCore::GraphicsContext::pen):
        * platform/graphics/qt/PathQt.cpp:
        (WebCore::Path::strokeBoundingRect):
        * rendering/RenderPath.cpp:
        (WebCore::StrokeBoundingRectStyleApplier::StrokeBoundingRectStyleApplier):
        (WebCore::StrokeBoundingRectStyleApplier::strokeStyle):
        (WebCore::RenderPath::relativeBBox):
        * rendering/RenderPath.h:
        * svg/graphics/cairo/RenderPathCairo.cpp:
        * svg/graphics/cg/RenderPathCg.cpp:
        * svg/graphics/qt/RenderPathQt.cpp:

2008-12-20  David Kilzer  <ddkilzer@apple.com>

        Fix typo "CSSAferRuleValue" to "CSSAfterRuleValue"

        * html/PreloadScanner.cpp:
        (WebCore::PreloadScanner::tokenizeCSS):
        * html/PreloadScanner.h:
        (WebCore::PreloadScanner::CSSState):

2008-12-19  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Geoff Garen.

        <rdar://problem/6454076> Random crashes on JS raytracer

        No test, because the crash is not readily reproducible.

        * platform/text/StringImpl.cpp:
        (WebCore::StringImpl::empty):
        * platform/text/StringImpl.h:
        Made empty string per-thread.

2008-12-19  Anders Carlsson  <andersca@apple.com>

        Reviewed by Sam Weinig.

        Replace some uses of HardRetain etc with RetainPtr.

        * platform/mac/DragImageMac.mm:
        * platform/mac/SharedBufferMac.mm:
        (WebCore::SharedBuffer::createCFData):
        * rendering/RenderThemeMac.mm:
        * svg/graphics/cg/SVGResourceFilterCg.mm:
        (WebCore::SVGResourceFilter::prepareFilter):
        (WebCore::SVGResourceFilter::applyFilter):
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.h:
        * svg/graphics/mac/SVGResourceFilterPlatformDataMac.mm:
        (WebCore::SVGResourceFilterPlatformDataMac::SVGResourceFilterPlatformDataMac):

2008-12-19  miggilin  <mr.diggilin@gmail.com>

        Reviewed by Kevin Ollivier.

        Add Context Menu support to wx bindings.
        
        https://bugs.webkit.org/show_bug.cgi?id=22675

        * platform/ContextMenu.h:
        * platform/ContextMenuItem.h:
        (WebCore::PlatformMenuItemDescription::PlatformMenuItemDescription):
        * platform/wx/ContextMenuItemWx.cpp: Added.
        * platform/wx/ContextMenuWx.cpp: Added.
        * platform/wx/LocalizedStringsWx.cpp:
        * platform/wx/TemporaryLinkStubs.cpp:
        * webcore-wx.bkl:


2008-12-19  Beth Dakin  <bdakin@apple.com>

        Reviewed by Darin Adler.

        Temporary band-aide fix for <rdar://problem/6372481> In Gmail, a 
        crash occurs at 
        AccessibilityTable::isTableExposableThroughAccessibility() when 
        attempting to create a link in a rich text message

        We need to disable Accessibility Tables until we get this fixed for 
        real to prevent rampant crashing.

        * page/AccessibilityTable.cpp:
        (WebCore::AccessibilityTable::AccessibilityTable):

2008-12-19  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Darin Adler

        https://bugs.webkit.org/show_bug.cgi?id=22938
        
        When the document element is transformed, we need to paint
        the view background to avoid unpainted areas.
        
        Test: fast/transforms/transformed-document-element.html

        * rendering/RenderView.cpp:
        (WebCore::RenderView::paintBoxDecorations):

2008-12-19  Steve Falkenburg  <sfalken@apple.com>

        Fix build.

        * WebCore.vcproj/WebCore.vcproj:

2008-12-19  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fixes after recent changes.

        * WebCoreSources.bkl:
        * platform/graphics/wx/ImageSourceWx.cpp:
        (WebCore::ImageSource::clear):
        * webcore-base.bkl:

2008-12-19  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Sam Weinig.

        [GTK] Fix make distcheck again

        These files were moved to WebCore/platform/animation
        and WebCore/platform/graphics/transforms.

        * GNUmakefile.am:

2008-12-19  Gustavo Noronha Silva  <gns@gnome.org>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=22900

        Fix AtomicString usage, so that building works.

        * platform/network/soup/ResourceHandleSoup.cpp:

2008-12-19  Adam Roben  <aroben@apple.com>

        Windows build fix on older versions of CFNetwork after r39393

        * platform/network/cf/ResourceHandleCFNet.cpp:
        (WebCore::highestSupportedCFURLConnectionClientVersion): Changed
        preprocessor directives not to leave in unreachable code on old
        versions of CFNetwork.

2008-12-19  Antti Koivisto  <antti@apple.com>

        Comment fix.

        * platform/PurgeableBuffer.h:

2008-12-19  Holger Hans Peter Freyther  <zecke@selfish.org>

        [GTK] Build fix by adding the new files.

        * GNUmakefile.am:

2008-12-19  Jade Han <jade.han@nokia.com>

        Reviewed by Tor Arne Vestbø.

        [Qt] Allow conversion of JavaScript Number and Boolean types to Qt types

        https://bugs.webkit.org/show_bug.cgi?id=22880

        * bridge/qt/qt_runtime.cpp:
        (JSC::Bindings::convertValueToQVariant):

2008-12-19  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Holger Freyther.

        Implement ImageDecoder::filenameExtension() for Qt

        * platform/graphics/qt/ImageDecoderQt.cpp:
        (WebCore::ImageDecoderQt::filenameExtension):
        * platform/graphics/qt/ImageDecoderQt.h:
        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::ImageSource::filenameExtension):

2008-12-19  Adam Barth  <abarth@webkit.org>

        Reviewed by Darin Alder.

        Implement ImageSource::filenameExtension for Cario
          https://bugs.webkit.org/show_bug.cgi?id=22905

        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::ImageSource::filenameExtension):
        * platform/image-decoders/ImageDecoder.h:
        * platform/image-decoders/bmp/BMPImageDecoder.h:
        (WebCore::BMPImageDecoder::filenameExtension):
        * platform/image-decoders/gif/GIFImageDecoder.h:
        (WebCore::GIFImageDecoder::filenameExtension):
        * platform/image-decoders/ico/ICOImageDecoder.h:
        (WebCore::ICOImageDecoder::filenameExtension):
        * platform/image-decoders/jpeg/JPEGImageDecoder.h:
        (WebCore::JPEGImageDecoder::filenameExtension):
        * platform/image-decoders/png/PNGImageDecoder.h:
        (WebCore::PNGImageDecoder::filenameExtension):
        * platform/image-decoders/xbm/XBMImageDecoder.h:
        (WebCore::XBMImageDecoder::filenameExtension):

2008-12-18  Dan Bernstein  <mitz@apple.com>

        Reviewed by Sam Weinig.

        - avoid using the ResourceHandle-level credential storage, if any,
          unless the client opts to use it; when use of the credential
          storage is disallowed, all authentication challenges are sent to
          the client.
        - let the FrameLoaderClient decide whether to use the credential
          storage. 

        * loader/EmptyClients.h:
        (WebCore::EmptyFrameLoaderClient::shouldUseCredentialStorage): Added.
        Returns false.
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::shouldUseCredentialStorage): Added. Calls through
        to the FrameLoaderClient.
        * loader/FrameLoader.h: Declared shouldUseCredentialStorage().
        * loader/FrameLoaderClient.h: Declared shouldUseCredentialStorage().
        * loader/ResourceLoader.cpp: 
        (WebCore::ResourceLoader::shouldUseCredentialStorage): Added. Calls
        through to the FrameLoader.
        * loader/ResourceLoader.h:
        (WebCore::ResourceLoader::shouldUseCredentialStorage): Implemented this
        ResourceHandleClient method.
        * loader/SubresourceLoader.cpp:
        (WebCore::SubresourceLoader::shouldUseCredentialStorage): Added.
        Overrides the ResourceLoader implementation by letting the client
        supply the return value. If the client does not do this, continues
        with the ResourceLoader behavior of asking the FrameLoader.
        * loader/SubresourceLoader.h: Removed an unused #include and declared
        shouldUseCredentialStorage().
        * loader/SubresourceLoaderClient.h:
        (WebCore::SubresourceLoaderClient::getShouldUseCredentialStorage):
        Added a default implementation which returns false, meaning the client
        does not wish to decide whether the credential storage should be used.
        * platform/network/ResourceHandle.h: Removed unused forward declarations.
        Declared a new member function, shouldUseCredentialStorage(), on Mac and
        CFNetwork-using builds.
        * platform/network/ResourceHandleClient.h:
        (WebCore::ResourceHandleClient::shouldUseCredentialStorage): Added this
        default implementation that returns false.
        * platform/network/cf/ResourceHandleCFNet.cpp:
        (WebCore::findCFNetworkModule): Added. Returns a handle to the CFNetwork
        module.
        (WebCore::cfNetworkVersion): Added. Returns the high word of the
        CFNetwork library's product version.
        (WebCore::highestSupportedCFURLConnectionClientVersion): Added. Returns
        the highest version of the CFURLConnectionClient structure supported by
        the CFNetwork library. The only reason to check this at runtime is
        that WebKit may be linking at runtime against an older version of
        CFNetwork than the one it was built with, as is the case with nightly
        builds.
        (WebCore::shouldUseCredentialStorageCallback): Added this
        CFURLConnection callback which calls through to
        ResourceHandle::shouldUseCredentialStorage().
        (WebCore::ResourceHandle::start): Pass a version 3 CFURLConnectionClient
        including the shouldUseCredentialStorage callback. At runtime, clamp the
        client structure version down to the highest supported by CFNetwork.
        (WebCore::ResourceHandle::shouldUseCredentialStorage): Added. Calls through
        to the client if there is one. Otherwise returns false.
        * platform/network/mac/ResourceHandleMac.mm:
        (WebCore::ResourceHandle::shouldUseCredentialStorage): Ditto.
        (-[WebCoreResourceHandleAsDelegate connectionShouldUseCredentialStorage:]):
        Added this delegate method which callls through to
        ResourceHandle::shouldUseCredentialStorage().

2008-12-18  David Kilzer  <ddkilzer@apple.com>

        Reset role to "Private" on 6 header files to fix clean builds after r39378

        Reviewed by BUILD FIX.

        * WebCore.xcodeproj/project.pbxproj: Added back "Private" role
        that was lost on 6 headers when they were "moved":
        AffineTransform.h, Animation.h, AnimationList.h,
        TimingFunction.h, TransformOperation.h and
        TransformOperations.h.

2008-12-18  Pamela Greene  <pam@chromium.org>

        Reviewed by Dan Bernstein.

        Add initializer for m_textDirectionSubmenuInclusionBehavior.
        https://bugs.webkit.org/show_bug.cgi?id=22926

        * page/Settings.cpp:
        (WebCore::Settings::Settings): Initialize m_textDirectionSubmenuInclusionBehavior

2008-12-18  Sam Weinig  <sam@webkit.org>

        Reviewed by John Sullivan.

        Add new FrameLoaderClient method to indicate the first visually 
        non-empty layout based on an heuristic.  Right now that heuristic
        is the first layout after an image, text or plugin has been added
        to the render tree, but I can imagine it becoming much smarter.

        * loader/EmptyClients.h:
        (WebCore::EmptyFrameLoaderClient::dispatchDidFirstVisuallyNonEmptyLayout):
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::didFirstVisuallyNonEmptyLayout):
        * loader/FrameLoader.h:
        * loader/FrameLoaderClient.h:
        * page/FrameView.cpp:
        (WebCore::FrameViewPrivate::reset):
        (WebCore::FrameView::layout):
        (WebCore::FrameView::performPostLayoutTasks):
        (WebCore::FrameView::setIsVisuallyNonEmpty):
        * page/FrameView.h:
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::RenderImage):
        * rendering/RenderPartObject.cpp:
        (WebCore::RenderPartObject::RenderPartObject):
        * rendering/RenderText.cpp:
        (WebCore::RenderText::RenderText):

2008-12-18  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        - fix <rdar://problem/6449841> reduce memory use of ResourceResponseBase by removing two maps

        We were parsing the cache-control and pragma header field values into maps.
        I changed that so instead we only cache two bits with the data we were actually
        using. Later we might want to move this responsibility out of this class entirely;
        we can cache it at the higher level instead.

        * loader/CachedResource.cpp:
        (WebCore::CachedResource::mustRevalidate): Changed to call a specific API to get at
        the bits in quest instead of a general "cache control directives" API.

        * platform/network/ResourceResponseBase.cpp:
        (WebCore::ResourceResponseBase::setHTTPHeaderField): Remove the logic for the
        pragma header field since no one is using this for now.
        (WebCore::ResourceResponseBase::parseCacheControlDirectives): Eliminated the return
        value and made this function have side effects only. Changed it so it's the caller's
        responsibility to check m_haveParsedCacheControl. Set m_cacheControlContainsNoCache
        and m_cacheControlContainsMustRevalidate rather than keeping a map around.

        * platform/network/ResourceResponseBase.h:
        (WebCore::ResourceResponseBase::cacheControlContainsNoCache): Added.
        (WebCore::ResourceResponseBase::cacheControlContainsMustRevalidate): Added.
        (WebCore::ResourceResponseBase::ResourceResponseBase): Updated since I removed
        m_haveParsedCacheControl and renamed m_haveParsedCacheControlHeader to remove
        the imprecise use of the term "header".

2008-12-18  Steve Falkenburg  <sfalken@apple.com>

        Build fix.
        Delete 2nd copy of code in these files.

        * platform/animation/Animation.cpp:
        * platform/animation/Animation.h:
        * platform/animation/AnimationList.cpp:
        * platform/animation/AnimationList.h:
        * platform/animation/TimingFunction.h:
        * platform/graphics/transforms/AffineTransform.cpp:
        * platform/graphics/transforms/AffineTransform.h:
        * platform/graphics/transforms/IdentityTransformOperation.h:
        * platform/graphics/transforms/MatrixTransformOperation.cpp:
        * platform/graphics/transforms/MatrixTransformOperation.h:
        * platform/graphics/transforms/RotateTransformOperation.cpp:
        * platform/graphics/transforms/RotateTransformOperation.h:
        * platform/graphics/transforms/ScaleTransformOperation.cpp:
        * platform/graphics/transforms/ScaleTransformOperation.h:
        * platform/graphics/transforms/SkewTransformOperation.cpp:
        * platform/graphics/transforms/SkewTransformOperation.h:
        * platform/graphics/transforms/TransformOperation.h:
        * platform/graphics/transforms/TransformOperations.cpp:
        * platform/graphics/transforms/TransformOperations.h:
        * platform/graphics/transforms/TranslateTransformOperation.cpp:
        * platform/graphics/transforms/TranslateTransformOperation.h:

2008-12-18  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Geoffrey Garen.

        https://bugs.webkit.org/show_bug.cgi?id=22859
        Abstract away the use of JSDOMWindow in CachedPage and introduce
        ScriptCachedPageData abstraction.

        * GNUmakefile.am: Added ScriptCachedPageData to project.
        * WebCore.pro: Added ScriptCachedPageData to project.
        * WebCore.vcproj/WebCore.vcproj: Added ScriptCachedPageData to project.
        * WebCore.xcodeproj/project.pbxproj: Added ScriptCachedPageData to
            project.
        * bindings/js/ScriptCachedPageData.cpp: Added.
        (WebCore::ScriptCachedPageData::ScriptCachedPageData):
        (WebCore::ScriptCachedPageData::~ScriptCachedPageData):
        (WebCore::ScriptCachedPageData::restore):
        (WebCore::ScriptCachedPageData::clear):
        * bindings/js/ScriptCachedPageData.h: Added.
        * history/CachedPage.cpp: Replaced JSDOMWindow and ProtectedPtr with
            ScriptCachedPageData.
        (WebCore::CachedPage::CachedPage):
        (WebCore::CachedPage::domWindow):
        (WebCore::CachedPage::restore):
        (WebCore::CachedPage::clear):
        * history/CachedPage.h: Replaced JSDOMWindow and ProtectedPtr with
            ScriptCachedPageData.

2008-12-18  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22888

        To avoid future dependency issues, all the TransformOperations and Animation related files need to be moved to platform

        * WebCore.xcodeproj/project.pbxproj:
        * platform/animation: Added.
        * platform/animation/Animation.cpp: Copied from WebCore/rendering/style/Animation.cpp.
        * platform/animation/Animation.h: Copied from WebCore/rendering/style/Animation.h.
        * platform/animation/AnimationList.cpp: Copied from WebCore/rendering/style/AnimationList.cpp.
        * platform/animation/AnimationList.h: Copied from WebCore/rendering/style/AnimationList.h.
        * platform/animation/TimingFunction.h: Copied from WebCore/rendering/style/TimingFunction.h.
        * platform/graphics/AffineTransform.cpp: Removed.
        * platform/graphics/AffineTransform.h: Removed.
        * platform/graphics/transforms: Added.
        * platform/graphics/transforms/AffineTransform.cpp: Copied from WebCore/platform/graphics/AffineTransform.cpp.
        * platform/graphics/transforms/AffineTransform.h: Copied from WebCore/platform/graphics/AffineTransform.h.
        * platform/graphics/transforms/IdentityTransformOperation.h: Copied from WebCore/rendering/style/IdentityTransformOperation.h.
        * platform/graphics/transforms/MatrixTransformOperation.cpp: Copied from WebCore/rendering/style/MatrixTransformOperation.cpp.
        * platform/graphics/transforms/MatrixTransformOperation.h: Copied from WebCore/rendering/style/MatrixTransformOperation.h.
        * platform/graphics/transforms/RotateTransformOperation.cpp: Copied from WebCore/rendering/style/RotateTransformOperation.cpp.
        * platform/graphics/transforms/RotateTransformOperation.h: Copied from WebCore/rendering/style/RotateTransformOperation.h.
        * platform/graphics/transforms/ScaleTransformOperation.cpp: Copied from WebCore/rendering/style/ScaleTransformOperation.cpp.
        * platform/graphics/transforms/ScaleTransformOperation.h: Copied from WebCore/rendering/style/ScaleTransformOperation.h.
        * platform/graphics/transforms/SkewTransformOperation.cpp: Copied from WebCore/rendering/style/SkewTransformOperation.cpp.
        * platform/graphics/transforms/SkewTransformOperation.h: Copied from WebCore/rendering/style/SkewTransformOperation.h.
        * platform/graphics/transforms/TransformOperation.h: Copied from WebCore/rendering/style/TransformOperation.h.
        * platform/graphics/transforms/TransformOperations.cpp: Copied from WebCore/rendering/style/TransformOperations.cpp.
        * platform/graphics/transforms/TransformOperations.h: Copied from WebCore/rendering/style/TransformOperations.h.
        * platform/graphics/transforms/TranslateTransformOperation.cpp: Copied from WebCore/rendering/style/TranslateTransformOperation.cpp.
        * platform/graphics/transforms/TranslateTransformOperation.h: Copied from WebCore/rendering/style/TranslateTransformOperation.h.
        * rendering/style/Animation.cpp: Removed.
        * rendering/style/Animation.h: Removed.
        * rendering/style/AnimationList.cpp: Removed.
        * rendering/style/AnimationList.h: Removed.
        * rendering/style/IdentityTransformOperation.h: Removed.
        * rendering/style/MatrixTransformOperation.cpp: Removed.
        * rendering/style/MatrixTransformOperation.h: Removed.
        * rendering/style/RotateTransformOperation.cpp: Removed.
        * rendering/style/RotateTransformOperation.h: Removed.
        * rendering/style/ScaleTransformOperation.cpp: Removed.
        * rendering/style/ScaleTransformOperation.h: Removed.
        * rendering/style/SkewTransformOperation.cpp: Removed.
        * rendering/style/SkewTransformOperation.h: Removed.
        * rendering/style/TimingFunction.h: Removed.
        * rendering/style/TransformOperation.h: Removed.
        * rendering/style/TransformOperations.cpp: Removed.
        * rendering/style/TransformOperations.h: Removed.
        * rendering/style/TranslateTransformOperation.cpp: Removed.
        * rendering/style/TranslateTransformOperation.h: Removed.

2008-12-18  Cameron Zwarich  <zwarich@apple.com>

        Reviewed by Geoff Garen.

        Bug 21855: REGRESSION (r37323): Gmail complains about popup blocking when opening a link
        <https://bugs.webkit.org/show_bug.cgi?id=21855>
        <rdar://problem/6278244>

        If JavaScript is not currently executing, the handleEvent member function
        of JSAbstractEventListener should set the dynamic global object to the
        global object of the context in which the event occurred.
        
        If this is not set, then JavaScriptCore will simply take the global object
        of the context where the event handler function was created, which may be
        a different frame. This will cause the popup blocker to incorrectly block
        windows opened from onclick events inside of an iframe whose handler was
        created in the outer frame, as it will check the outer frame and see that
        it is not processing any events.

        * bindings/js/JSEventListener.cpp:
        (WebCore::JSAbstractEventListener::handleEvent):

2008-12-17  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dave Hyatt

        https://bugs.webkit.org/show_bug.cgi?id=22570
        
        Add the ability to compute clip rects independently from
        caching them on the RenderLayer. When painting reflections, use 
        such temporarily computed clipRects, otherwise the layer may cache
        clipRects which are invalid, since they have been computed with
        a rootLayer that is not the one usually used to paint.
        
        Test: fast/reflections/reflection-overflow-hidden.html

        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::paintLayer):
        (WebCore::RenderLayer::hitTestLayer):
        (WebCore::RenderLayer::updateClipRects):
        (WebCore::RenderLayer::calculateClipRects):
        (WebCore::RenderLayer::calculateRects):
        * rendering/RenderLayer.h:
        (WebCore::ClipRects::ClipRects):
        (WebCore::ClipRects::reset):
        (WebCore::ClipRects::overflowClipRect):
        (WebCore::ClipRects::setOverflowClipRect):
        (WebCore::ClipRects::fixedClipRect):
        (WebCore::ClipRects::setFixedClipRect):
        (WebCore::ClipRects::posClipRect):
        (WebCore::ClipRects::setPosClipRect):
        (WebCore::ClipRects::setFixed):
        (WebCore::ClipRects::operator==):
        (WebCore::ClipRects::operator=):
        * rendering/RenderReplica.cpp:
        (WebCore::RenderReplica::paint):

2008-12-17  Laszlo Gombos  <laszlo.1.gombos@nokia.com>

        Reviewed by Simon Hausmann.

        https://bugs.webkit.org/show_bug.cgi?id=22618

        Fix MinGW QtWebKit linking problems and also make the 
        QtWebKit build system more robust.

        * WebCore.pro:

2008-12-17  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Maciej Stachowiak.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22866

        wml.css is based on an older copy of html4.css. Synchronize them.
        Remove all entries, that are irrelevant for WML.

        Fix <do> appearance: should behave like HTMLs <button>.

        * css/wml.css:

2008-12-17  Yury Semikhatsky <yurys@google.com>

        Reviewed by Timothy Hatcher.
        Landed by Adam Barth.

        Added more checks that WebInspector.panels.{resources,scripts} are
        defined where they are accessed from other panels and WebInspector
        (some panels are not yet supported in Chrome).

        * inspector/front-end/Console.js:
        (WebInspector.Console.prototype.addMessage):
        (WebInspector.Console.prototype.clearMessages):
        (WebInspector.Console.prototype.completions):
        * inspector/front-end/ObjectPropertiesSection.js:
        (WebInspector.ObjectPropertyTreeElement.prototype.evaluateExpression):
        * inspector/front-end/ScriptsPanel.js:
        (WebInspector.ScriptsPanel.prototype.get searchableViews):
        (WebInspector.ScriptsPanel.prototype._sourceViewForScriptOrResource):
        (WebInspector.ScriptsPanel.prototype._sourceFrameForScriptOrResource):
        (WebInspector.ScriptsPanel.prototype._showScriptOrResource):
        * inspector/front-end/SourceView.js:
        (WebInspector.SourceView.prototype._addBreakpoint):
        * inspector/front-end/inspector.js:
        (WebInspector.addResource):
        (WebInspector.removeResource):
        (WebInspector.showResourceForURL):

2008-12-17  Cary Clark  < caryclark@google.com>

        Reviewed by Darin Adler.
        Landed by Adam Barth.

        Add ENABLE_TEXT_CARET to permit the ANDROID platform
        to invalidate and draw the caret in a separate thread.

        * page/Frame.cpp:
        (WebCore::Frame::clearCaretRectIfNeeded): Body of
        function does nothing if text caret is disabled.
        (WebCore::Frame::selectionLayoutChanged): Do nothing
        if text caret is disabled and the caret only blinked.
        (WebCore::Frame::caretBlinkTimerFired):
        (WebCore::Frame::paintCaret):
        (WebCore::Frame::paintDragCaret): Body of
        functions does nothing if text caret is disabled.

2008-12-16  Darin Adler  <darin@apple.com>

        Reviewed and landed by Cameron Zwarich.

        Change the style of AtomicString::add() to match Identifier:add().

        * platform/text/AtomicString.cpp:
        (WebCore::AtomicString::add):

2008-12-16  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=22827
        <rdar://problem/6247724> RenderThemeWin buttons have weird heavy text

        * rendering/RenderThemeWin.cpp:
        (WebCore::fillFontDescription): Add version that takes a font size.
        (WebCore::RenderThemeWin::systemFont): Use the default GUI font for control fonts, but specify the size.
        This will match Firefox.

2008-12-16  Stephanie Lewis  <slewis@apple.com>

        Another build fix.

        * platform/text/AtomicString.h:
        (WebCore::AtomicString::AtomicString):

2008-12-16  Stephanie Lewis  <slewis@apple.com>

        Windows Build Fix.

        * platform/text/AtomicString.h:
        (WebCore::AtomicString::AtomicString):
        (WebCore::AtomicString::createCFString):

2008-12-16  Peter Kasting  <pkasting@google.com>

        Reviewed by David Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22885
        Fix memory corruption in GIFImageDecoder.cpp with certain GIFs.

        * platform/image-decoders/gif/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::frameComplete):

2008-12-16  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Geoff Garen.

        Change HTTPHeaderMap to use an AtomicString as its key.  
        Shaves ~1MB off of the Mozilla Memory Test
        No functionality difference    

        * WebCore.xcodeproj/project.pbxproj:
        * inspector/InspectorController.cpp:
        (WebCore::addHeaders):
        * loader/appcache/ApplicationCacheStorage.cpp:
        (WebCore::parseHeader):
        * platform/network/HTTPHeaderMap.h:
        * platform/network/ResourceRequestBase.cpp:
        (WebCore::ResourceRequestBase::httpHeaderField):
        (WebCore::ResourceRequestBase::setHTTPHeaderField):
        (WebCore::ResourceRequestBase::addHTTPHeaderField):
        * platform/network/ResourceRequestBase.h:
        * platform/network/ResourceResponseBase.cpp:
        (WebCore::ResourceResponseBase::httpHeaderField):
        (WebCore::ResourceResponseBase::setHTTPHeaderField):
        * platform/network/ResourceResponseBase.h:
        * platform/text/StringHash.h:
        (WebCore::CaseFoldingHash::hash):
        (WebCore::CaseFoldingHash::equal):
        * xml/XMLHttpRequest.cpp:
        (WebCore::isSetCookieHeader):
        (WebCore::XMLHttpRequest::setRequestHeader):
        (WebCore::XMLHttpRequest::setRequestHeaderInternal):
        (WebCore::XMLHttpRequest::getRequestHeader):
        (WebCore::XMLHttpRequest::getResponseHeader):
        * xml/XMLHttpRequest.h:

2008-12-16  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Darin Adler.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22876

        Remove legacy randomNumber() functionality from HTMLFormElement, and use the new wtf/RandomNumber.h.
        Also remove an uneeded QFileInfo include while I'm at it - there is no Qt usage in this file.

        * ForwardingHeaders/wtf/RandomNumber.h: Added.
        * html/HTMLFormElement.cpp:
        (WebCore::getUniqueBoundaryString):

2008-12-16 Yael Aharon <yael.aharon@nokia.com>

        Reviewed by Tor Arne Vestbø.

        Qt/Win build fix

        * platform/win/SystemTimeWin.cpp:

2008-12-16  Kalle Vahlman  <kalle.vahlman@movial.com>

        Reviewed by Holger Freyther.

        [CURL] memory leak of ResouceHandles
        http://bugs.webkit.org/show_bug.cgi?id=20777

        Fix ResourceHandle ref management to be consistent and correct.
        Original patch from Marco Barisione.

        * platform/network/curl/ResourceHandleCurl.cpp:
        (WebCore::ResourceHandle::start):
        * platform/network/curl/ResourceHandleManager.cpp:
        (WebCore::ResourceHandleManager::removeFromCurl):
        (WebCore::ResourceHandleManager::add):
        (WebCore::ResourceHandleManager::removeScheduledJob):

2008-12-16  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Qt build.

        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::ImageSource::clear): Adjust to new signature.

2008-12-15  Mark Rowe  <mrowe@apple.com>

        Rubber-stamped by Cameron Zwarich.

        <rdar://problem/6289933> Change WebKit-related projects to build with GCC 4.2 on Leopard.

        * Configurations/Base.xcconfig:
        * Configurations/DebugRelease.xcconfig:

2008-12-15  Adele Peterson  <adele@apple.com>

        Reviewed by Darin Adler.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=22871
        <rdar://problem/6417316> RenderThemeWin buttons are too short/thin

        * rendering/RenderButton.cpp: (WebCore::RenderButton::setupInnerStyle): 
        Check if the button's style (not the new inner style) has appearance set to determine whether we should set padding on the inner style.

2008-12-15  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Oliver Hunt.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22865

        Add complete WML <table> / <tr> / <td> element support.
        Proper handling of all table related attributes, including tests.

        Tests: fast/wml/table-element-align-attribute-invalid.wml (variable reference in 'align' attribute, raises error)
               fast/wml/table-element-columns-attribute-invalid-number.wml (columns='0', raises error)
               fast/wml/table-element-columns-attribute-invalid.wml (non-numeric 'columns' attribute value, raises error)
               fast/wml/table-element-columns-attribute-missing.wml (missing 'columns')
               fast/wml/table-element-columns-attribute.wml (test 'columns' attribute and <td> count mismatches)

        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::offsetParent):
        * rendering/RenderTableRow.cpp:
        (WebCore::RenderTableRow::addChild):
        * wml/WMLTableElement.cpp: Added.
        (WebCore::WMLTableElement::WMLTableElement):
        (WebCore::WMLTableElement::~WMLTableElement):
        (WebCore::WMLTableElement::mapToEntry):
        (WebCore::WMLTableElement::parseMappedAttribute):
        (WebCore::WMLTableElement::finishParsingChildren):
        * wml/WMLTableElement.h: Added.
        * wml/WMLTagNames.in:

2008-12-15  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        - fix <rdar://problem/6427048> crash due to infinite recursion after setting window.__proto__ = window

        Test: fast/dom/Window/window-custom-prototype.html

        Replaced toGlobalObject with the more generally useful unwrappedObject.

        * bindings/js/JSDOMWindowShell.cpp:
        (WebCore::JSDOMWindowShell::unwrappedObject): Added.
        * bindings/js/JSDOMWindowShell.h: Declared unwrappedObject.
        * bindings/js/JSQuarantinedObjectWrapper.h:
        (WebCore::JSQuarantinedObjectWrapper::unwrappedObject): Ditto.

2008-12-15  Gustavo Noronha Silva  <kov@kov.eti.br>

        Reviewed by Mark Rowe.

        https://bugs.webkit.org/show_bug.cgi?id=22686

        GTK+ build fix.

        * GNUmakefile.am:

2008-12-15  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        Fix for https://bugs.webkit.org/show_bug.cgi?id=22847
        Geolocation PositionOptions cannot be an arbitrary object.

        Allow the PositionOptions to be a vanilla JS object and parse it
        appropriately.

        * DerivedSources.make: Remove PositionOptions.
        * GNUmakefile.am: Ditto.
        * WebCore.pro: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * WebCoreSources.bkl: Ditto.

        * bindings/js/JSGeolocationCustom.cpp:
        (WebCore::createPositionOptions): Added. Extracts the enableHighAccuracy
        and timeout fields from a vanilla JS object in order to create the 
        PositionOptions object, checking for exceptions as necessary.
        (WebCore::JSGeolocation::getCurrentPosition): Use createPositionOptions
        instead of toPositionOptions.
        (WebCore::JSGeolocation::watchPosition): Ditto.
        * page/PositionOptions.idl: Removed

2008-12-15  Peter Kasting  <pkasting@google.com>

        Reviewed by David Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22108
        Large animated GIFs weren't always animating.  The code that deleted
        the entire decoder after each frame of a large image was resulting in
        us forgetting the loop count, breaking animations intermittently.

        Instead of throwing the whole decoder away, we're more careful to just
        delete frames we don't care about.  This additionally addresses
        problems in the Cairo and Chromium ports with excessive peak memory
        use and CPU use when decoding large animated GIFs because it leads to
        much less redecoding (O(n) instead of O(n^2) CPU, and O(1) instead of
        O(n) memory).

        This change has less impact on the CG decoder, which seems to throw
        away frames automatically when their external references are dropped;
        this means the CG decoder didn't suffer from the peak memory usage
        issue before (and still doesn't), but it also still burns excessive
        CPU redecoding earlier frames, that in theory it wouldn't need to
        redecode if it would judiciously save the most recent frames.  At
        least this patch plumbs some useful info to the ImageSource so it can
        help guide the CG decoder heuristics in the future.

        * platform/graphics/BitmapImage.cpp:
        (WebCore::frameBytes):
        (WebCore::BitmapImage::destroyDecodedData):
        (WebCore::BitmapImage::destroyDecodedDataIfNecessary):
        (WebCore::BitmapImage::destroyMetadataAndNotify):
        (WebCore::BitmapImage::clearFrame):
        (WebCore::BitmapImage::cacheFrame):
        (WebCore::BitmapImage::dataChanged):
        (WebCore::BitmapImage::startAnimation):
        (WebCore::BitmapImage::resetAnimation):
        (WebCore::BitmapImage::internalAdvanceAnimation):
        * platform/graphics/BitmapImage.h:
        * platform/graphics/GeneratedImage.h:
        (WebCore::GeneratedImage::destroyDecodedData):
        * platform/graphics/Image.h:
        * platform/graphics/ImageSource.h:
        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::ImageSource::~ImageSource):
        (WebCore::ImageSource::clear):
        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::~ImageSource):
        (WebCore::ImageSource::clear):
        * platform/graphics/cg/PDFDocumentImage.h:
        (WebCore::PDFDocumentImage::destroyDecodedData):
        * platform/graphics/qt/StillImageQt.h:
        (WebCore::StillImage::destroyDecodedData):
        * platform/image-decoders/ImageDecoder.h:
        (WebCore::RGBA32Buffer::clear):
        (WebCore::ImageDecoder::clearFrameBufferCache):
        * platform/image-decoders/gif/GIFImageDecoder.cpp:
        (WebCore::GIFImageDecoder::repetitionCount):
        (WebCore::GIFImageDecoder::clearFrameBufferCache):
        (WebCore::GIFImageDecoder::initFrameBuffer):
        * platform/image-decoders/gif/GIFImageDecoder.h:
        * platform/image-decoders/gif/GIFImageReader.h:
        (GIFImageReader::GIFImageReader):
        * svg/graphics/SVGImage.h:
        (WebCore::SVGImage::destroyDecodedData):

2008-12-15  Cameron Zwarich  <zwarich@apple.com>

        Reviewed by Darin Adler.

        Bug 22562: REGRESSION (r37971): events not firing after going back in back/forward cache
        <https://bugs.webkit.org/show_bug.cgi?id=22562>
        <rdar://problem/6414593>

        Restore the Frame's DOMWindow to its previous value when going back in
        the back/forward cache. The fact that it was not getting set before may
        have always caused some subtle bugs with the back/forward cache, but
        after r37971, it causes no events to fire after restoring a page.

        Previously, ScriptController::clearScriptObjects() was calling
        clearPlatformScriptObjects(), which was not actually clearing any
        objects, only updating them to reflect some change in state. Since the
        window shell was not updated until after the call to clearScriptObjects(),
        this didn't actually make that much sense.

        We rename clearPlatformScriptObjects() to reflect its actual purpose and
        call it after the window shell has been updated rather than before.

        Unfortunately, there is no way to test this with a layout test because
        it involves the back/forward cache.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::updatePlatformScriptObjects): Renamed from
        clearPlatformScriptObjects(), because the only nonempty implementation
        doesn't actually clear any objects, it updates them. Also made public.
        (WebCore::ScriptController::clearScriptObjects): Remove the call to
        clearPlatformScriptObjects().
        * bindings/js/ScriptController.h:
        * bindings/js/ScriptControllerMac.mm:
        (WebCore::ScriptController::updatePlatformScriptObjects):
        * history/CachedPage.cpp:
        (WebCore::CachedPage::domWindow): Added.
        * history/CachedPage.h:
        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::cancelAndClear): Added call to updatePlatformScriptObjects().
        (WebCore::FrameLoader::begin): Added call to updatePlatformScriptObjects().
        (WebCore::FrameLoader::open): Added call to updatePlatformScriptObjects().
        * page/Frame.cpp:
        (WebCore::Frame::setDOMWindow): Added.
        (WebCore::Frame::pageDestroyed): Added call to updatePlatformScriptObjects().
        * page/Frame.h:

2008-12-15  Antti Koivisto  <antti@apple.com>

        Reviewed by Darin Adler.

        When a resource is cached locally, WebKit should follow RFC 2616 "Specific end-to-end revalidation" instead of "Unspecified end-to-end revalidation"
        https://bugs.webkit.org/show_bug.cgi?id=17998 
        
        - Enable conditional revalidation for reloads by default. 
        - Add a parameter to FrameLoader::reload() for forcing end-to-end reload.
        - To avoid duplicating state remove m_cachePolicy variables from FrameLoader and DocLoader. 
          Instead synthezise the policy on demand.
        
        This speeds up reloads and makes them use way less bandwidth.

        * WebCore.base.exp:
        * loader/CachePolicy.h: Rename CachePolicyRefresh to CachePolicyRevalidate.
        (WebCore::):
        * loader/DocLoader.cpp:
        (WebCore::DocLoader::DocLoader):
        (WebCore::DocLoader::checkForReload): Support CachePolicyRevalidate.
        (WebCore::DocLoader::requestResource):
        (WebCore::DocLoader::cachePolicy):
        * loader/DocLoader.h: Get rid of m_cachePolicy member. 
        * loader/FrameLoader.cpp:
        (WebCore::ScheduledRedirection::ScheduledRedirection): 
            Add parameter to differentiate refresh from other types of redirects. 
            m_cachePolicy was used for signaling this before.
        (WebCore::isBackForwardLoadType):
        (WebCore::FrameLoader::FrameLoader):
        (WebCore::FrameLoader::changeLocation):
        (WebCore::FrameLoader::stopLoading):
        (WebCore::FrameLoader::receivedFirstData):
        (WebCore::FrameLoader::write):
        (WebCore::FrameLoader::startIconLoader):
        (WebCore::FrameLoader::restoreDocumentState):
        (WebCore::FrameLoader::scheduleHTTPRedirection):
        (WebCore::FrameLoader::scheduleLocationChange):
        (WebCore::FrameLoader::scheduleRefresh):
        (WebCore::FrameLoader::redirectionTimerFired):
        (WebCore::FrameLoader::canCachePage):
        (WebCore::FrameLoader::loadURL):
        (WebCore::FrameLoader::reload): 
            Differentiate between revalidation and reload.
            No need to use setHTTPHeaderField here, addExtraFieldsToRequest will set the headers.
        (WebCore::FrameLoader::transitionToCommitted):
        (WebCore::FrameLoader::cachePolicy): Determine the cache policy based on current load type. 
        (WebCore::FrameLoader::checkLoadCompleteForThisFrame):
        (WebCore::FrameLoader::addExtraFieldsToRequest): Set Cache-control: no-cache for FrameLoadTypeReloadFromOrigin
        (WebCore::FrameLoader::shouldScrollToAnchor):
        (WebCore::FrameLoader::loadItem):
        (WebCore::FrameLoader::updateHistoryForReload):
        (WebCore::FrameLoader::updateHistoryForCommit):
        (WebCore::FrameLoader::switchOutLowBandwidthDisplayIfReady):
        * loader/FrameLoader.h:
        * loader/FrameLoaderTypes.h: Add FrameLoadTypeReloadFromOrigin
        (WebCore::):
        * loader/NavigationAction.cpp: 
        (WebCore::navigationType):  Support FrameLoadTypeReloadFromOrigin
        * loader/loader.cpp:
        (WebCore::Loader::Host::servePendingRequests):

2008-12-15  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        Add null checks to PlatformScreenQt

        The other ports do the null checks and JSDOMWindowBase is
        at least one caller that is passing 0.

        * platform/qt/PlatformScreenQt.cpp:
        (WebCore::screenDepth):
        (WebCore::screenDepthPerComponent):
        (WebCore::screenIsMonochrome):
        (WebCore::screenRect):
        (WebCore::screenAvailableRect):

2008-12-15  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Oliver Hunt.

        <rdar://problem/6444455> Worker Thread crash running multiple workers for a moderate amount of time

        * dom/WorkerThread.cpp: (WebCore::WorkerThread::workerThread):
        Detach the thread. Without this, one page of its stack was never unmmaped, and fragmentation
        made RegisterFile allocaiton fail after a while.

2008-12-13  Darin Adler  <darin@apple.com>

        Reviewed by Sam Weinig.

        - half of https://bugs.webkit.org/show_bug.cgi?id=17425
          eliminate DeprecatedPtrList

        * dom/Document.cpp:
        (WebCore::Document::removeImage): Change to set slots in the vector
        to 0 rather than removing items from a list.
        (WebCore::Document::dispatchImageLoadEventsNow): Rewrite to process
        the list. Since we now use a "set to zero" design, we don't need to
        be careful about where the iterator points while iterating the list,
        instead we just have to skip zeros.

        * dom/Document.h: Use Vector instead of DeprecatedPtrList.

        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::dispatchGenericEvent): Use a Vector instead
        of a DeprecatedPtrList for the list of nodes to handle. Also streamlined
        the logic a bit and used goto in a couple key places.

        * dom/Node.cpp:
        (WebCore::Node::eventParentNode): Moved this function into this file
        because it's a virtual function so already can't be inlined. Also updated
        to return a ContainerNode, so it needs to be in a place where the
        definition of ContainerNode is visible, not the header file.

        * dom/Node.h: Changed return type of eventParentNode to ContainerNode
        and moved its definition into the cpp file.

        * dom/XMLTokenizerLibxml2.cpp:
        (WebCore::PendingCallbacks::~PendingCallbacks): Added a call to
        deleteAllValues here instead of setAutoDelete in the constructor, since
        we're using Deque instead of DeprecatedPtrList.
        (WebCore::PendingCallbacks::callAndRemoveFirstCallback): Changed the
        code to use an OwnPtr since the deque won't delete the callback object.

        * editing/ApplyStyleCommand.cpp:
        (WebCore::ApplyStyleCommand::applyRelativeFontStyleChange): Use a
        Vector instead of a DeprecatedPtrList.

        * svg/SVGElement.cpp:
        (WebCore::SVGElement::eventParentNode): Moved this function into this file
        because it's a virtual function so already can't be inlined. Also updated
        to return a ContainerNode.

        * svg/SVGElement.h: Changed setShadowParentNode to take a ContainerNode*,
        made eventParentNode return a ContainerNode*, and made m_shadowParent a
        ContainerNode*.

2008-12-14  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22857

        Jumps within a WML deck using <go> task elements fail. Manual reloading
        is necessary to display the page - fix cache-policy in WMLGoElement::executeTask
        to prevent the problem.

        Refactor setActiveCardInDocument in two new functions: findNamedCardInDocument
        and determineActiveCard, to fix a side-effect of executing a <go> task:
        when switching cards within a deck the active card was changed before the load
        was fired which resulted in a flash effect on the screen, and doing unnecessary work.

        Test: wml/go-task-animation.html

        * wml/WMLCardElement.cpp:
        (WebCore::WMLCardElement::findNamedCardInDocument):
        (WebCore::WMLCardElement::determineActiveCard):
        * wml/WMLCardElement.h:
        * wml/WMLDocument.cpp:
        (WebCore::WMLDocument::finishedParsing):
        * wml/WMLGoElement.cpp:
        (WebCore::WMLGoElement::executeTask):
        (WebCore::WMLGoElement::prepareGETRequest):
        * wml/WMLGoElement.h:

2008-12-14  Dirk Schulze  <krit@webkit.org>

        Reviewed by Oliver Hunt.

        Fixes an issue in cairo. A fully transparent color can cause wrong
        drawings on canvas' composite.

        https://bugs.webkit.org/show_bug.cgi?id=22846
        [CAIRO] Canvas: transparent color and composite

        Test: fast/canvas/canvas-transparency-and-composite.html

        * platform/graphics/cairo/GraphicsContextCairo.cpp:
        (WebCore::GraphicsContext::fillPath):
        (WebCore::GraphicsContext::strokePath):

2008-12-13  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Darin Adler.

        Bug 22665: Remove setCreatedByParser(bool) from the few elements that use it
        https://bugs.webkit.org/show_bug.cgi?id=22665

        Remove setCreatedByParser from frame and iframe.

        * html/HTMLElementFactory.cpp:
        (WebCore::frameConstructor):
        (WebCore::iframeConstructor):
        (WebCore::objectConstructor):
        * html/HTMLFrameElement.cpp:
        (WebCore::HTMLFrameElement::HTMLFrameElement):
        * html/HTMLFrameElement.h:
        * html/HTMLFrameElementBase.cpp:
        (WebCore::HTMLFrameElementBase::HTMLFrameElementBase):
        * html/HTMLFrameElementBase.h:
        * html/HTMLFrameOwnerElement.cpp:
        (WebCore::HTMLFrameOwnerElement::HTMLFrameOwnerElement):
        * html/HTMLFrameOwnerElement.h:
        (WebCore::HTMLFrameOwnerElement::createdByParser):
        * html/HTMLIFrameElement.cpp:
        (WebCore::HTMLIFrameElement::HTMLIFrameElement):
        * html/HTMLIFrameElement.h:
        * html/HTMLPlugInElement.cpp:
        (WebCore::HTMLPlugInElement::HTMLPlugInElement):
        * html/HTMLTagNames.in:

2008-12-13  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22843
        Auto-generate JSWorkerContext

        * bindings/scripts/CodeGeneratorJS.pm:
        * dom/WorkerContext.idl: Added.
        * page/DOMWindow.idl:
        Added ExtendsDOMGlobalObject, a new attribute for behaviors common to DOMWindow and
        WorkerContext.

        * bindings/js/WorkerScriptController.cpp:
        (WebCore::WorkerScriptController::initScript):
        Made JSWorkerContext creation look more like JSDOMWindow creation, to work with generated code.

        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.scons:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * bindings/js/JSWorkerContext.cpp: Removed.
        * bindings/js/JSWorkerContext.h: Removed.
        * bindings/js/JSWorkerContextBase.cpp: Copied from WebCore/bindings/js/JSWorkerContext.cpp.
        (WebCore::JSWorkerContextBase::JSWorkerContextBase):
        (WebCore::JSWorkerContextBase::~JSWorkerContextBase):
        (WebCore::JSWorkerContextBase::scriptExecutionContext):
        (WebCore::getJSWorkerContextBaseTable):
        (WebCore::):
        (WebCore::JSWorkerContextBase::put):
        * bindings/js/JSWorkerContextBase.h: Copied from WebCore/bindings/js/JSWorkerContext.h.
        * bindings/js/JSWorkerContextCustom.cpp: Added.
        (WebCore::JSWorkerContext::customGetOwnPropertySlot):
        (WebCore::JSWorkerContext::mark):
        (WebCore::JSWorkerContext::self):
        (WebCore::JSWorkerContext::setSelf):
        (WebCore::JSWorkerContext::addEventListener):
        (WebCore::JSWorkerContext::removeEventListener):
        Moved code around. Note that currently, JSWorkerContextBase lookup table is empty, but we'll
        need to add some global objects to it in the future, as it is done in JSDOMWindowBase.

        * page/WorkerNavigator.cpp:
        * page/WorkerNavigator.h:
        Added ENABLE(WORKERS) ifdefs.

2008-12-13  Darin Adler  <darin@apple.com>

        - fix Release build

        * dom/Node.cpp:
        (WebCore::Node::rareData): Remove inappropriate inline directive.

2008-12-13  Darin Adler  <darin@apple.com>

        Reviewed by Dan Bernstein.

        - fix https://bugs.webkit.org/show_bug.cgi?id=18734
          REGRESSION (r31081): Focus problems in Gmail 2/Plain text message text
          <rdar://problem/5892415>

        Test: fast/forms/textarea-selection-preservation.html

        The regression reported was caused by the fact that the renderer code had
        a bug where it would constantly think the newline at the end of text was
        missing, and so it would replace all the text even though it wasn't changing,
        which would destroy the selection.

        When writing the regression test I discovered another problem: The value
        property in HTMLTextAreaElement was intentionally changing the selection
        to the end of the textarea, but doing that even when the value wasn't changing.

        This patch fixes both and the test checks both.

        * html/HTMLTextAreaElement.cpp:
        (WebCore::HTMLTextAreaElement::setValue): Exit early if the value is
        not changing.

        * rendering/RenderTextControl.cpp:
        (WebCore::RenderTextControl::text): Add a newline character for each <br>
        element encountered in the control

2008-12-13  Darin Adler  <darin@apple.com>

        - file deletion part of https://bugs.webkit.org/show_bug.cgi?id=17497
          eliminate DeprecatedValueList

        * GNUmakefile.am: Removed references to deleted files.
        * WebCore.pro: Ditto.
        * WebCore.scons: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCore.xcodeproj/project.pbxproj: Ditto.
        * WebCoreSources.bkl: Ditto.

        * platform/DeprecatedPtrQueue.h: Removed.
        * platform/DeprecatedValueList.h: Removed.
        * platform/DeprecatedValueListImpl.cpp: Removed.
        * platform/DeprecatedValueListImpl.h: Removed.

2008-12-13  Darin Adler  <darin@apple.com>

        Reviewed by Anders Carlsson.

        - https://bugs.webkit.org/show_bug.cgi?id=17497
          eliminate DeprecatedValueList

        * css/CSSStyleDeclaration.cpp: Removed unneeded include.

        * dom/Document.cpp:
        (WebCore::Document::removeAllEventListenersFromAllNodes):
        Set the removed flag on the window event listeners in case we
        are in the middle of dispatching events on this window.
        (WebCore::Document::clear): Ditto.
        (WebCore::Document::handleWindowEvent): Changed to use a vector
        instead of a DeprecatedPtrList.
        (WebCore::Document::windowInlineEventListenerForType): Ditto.
        (WebCore::Document::removeWindowInlineEventListenerForType): Ditto.
        Also added a call to setRemoved, which is needed here just as in
        other functions that remove.
        (WebCore::Document::removeWindowEventListener): Ditto.
        (WebCore::Document::hasWindowEventListener): Ditto.

        * dom/Document.h: Changed RegisteredEventListenerList to
        RegisteredEventListeners.

        * dom/Element.cpp:
        (WebCore::Element::attach): Use a function to access rare data instead
        of getting directly at the data field.
        (WebCore::Element::focus): Ditto.
        (WebCore::Element::cancelFocusAppearanceUpdate): Ditto.

        * dom/ElementRareData.h: Use "using" to make things that are protected
        in NodeRareData be public here.

        * dom/EventTarget.h: Removed include of DeprecatedValueList and
        related declearations that weren't needed. Tweaked the definitions
        of the forbidEventDispatch functions too.

        * dom/EventTargetNode.cpp:
        (WebCore::EventTargetNode::EventTargetNode): Eliminated code that
        was used to initialized m_regdListeners.
        (WebCore::EventTargetNode::~EventTargetNode): Elminated delete of
        m_regdListeners. Changed code to use eventListeners() instead of
        m_regdListeners.
        (WebCore::EventTargetNode::eventListeners): Added.
        (WebCore::EventTargetNode::insertedIntoDocument): Use eventListeners.
        (WebCore::EventTargetNode::removedFromDocument): Ditto.
        (WebCore::EventTargetNode::willMoveToNewOwnerDocument): Ditto.
        (WebCore::EventTargetNode::didMoveToNewOwnerDocument): Ditto.
        (WebCore::EventTargetNode::addEventListener): Ditto.
        (WebCore::EventTargetNode::removeEventListener): Ditto.
        (WebCore::EventTargetNode::removeAllEventListeners): Ditto.
        Also added code to call setRemoved on all the listeners.
        (WebCore::EventTargetNode::handleLocalEvents): Ditto.
        (WebCore::EventTargetNode::dispatchGenericEvent): Fixed indentation.
        (WebCore::EventTargetNode::removeInlineEventListenerForType): Use
        the new event listeners vector. Also added missing call to setRemoved.
        (WebCore::EventTargetNode::inlineEventListenerForType): Ditto.

        * dom/EventTargetNode.h: Added a new RegisteredEventListenerVector
        type and replaced the old localEventListeners function with a new
        eventListeners function. Removed m_regdListeners.

        * dom/Node.cpp:
        (WebCore::Node::childNodes): Removed unneeded std prefix.
        (WebCore::Node::setFocus): Use function instead of going directly
        at rare data.
        (WebCore::Node::rareDataFocused): Ditto.
        (WebCore::Node::registerDynamicNodeList): Removed unneeded std prefix.
        (WebCore::Node::getElementsByName): Ditto.
        (WebCore::Node::getElementsByClassName): Ditto.
        (WebCore::Node::compareDocumentPosition): Ditto.

        * dom/Node.h: Removed unneeded forward declaration of
        RegisteredEventListener. This is now in EventTargetNode.

        * dom/NodeRareData.h: Renamed m_focused to m_isFocused and made it
        private. Made m_needsFocusAppearanceUpdateSoonAfterAttach private.
        Added listeners and ensureListeners functions as well as isFocused,
        setFocused, and focus-appearance functions. Made all data members private.

        * dom/RegisteredEventListener.cpp: Removed operator ==.
        * dom/RegisteredEventListener.h: Removed operator == and !=.

        * svg/SVGElement.cpp:
        (WebCore::hasLoadListener): Rewrote to work with the vector.
        * svg/SVGUseElement.cpp:
        (WebCore::SVGUseElement::transferEventListenersToShadowTree): Ditto.

2008-12-13  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Dan Bernstein.

        https://bugs.webkit.org/show_bug.cgi?id=22824

        Change ENABLE(FONT_FAST_PATH) to USE(FONT_FAST_PATH). With r39206
        floatWidth always used the complex path causing a regression
        in the pixel tests.

        * platform/graphics/Font.cpp:
        (WebCore::Font::floatWidth): Use the fast path again

2008-12-13  Dirk Schulze  <krit@webkit.org>

        Reviewed by Darin Adler.

        Fixes behavior of gradients on empty path in canvas/Cg

        https://bugs.webkit.org/show_bug.cgi?id=22844
        [Cg] Canvas fill() draws gradients even without a path

        Test: fast/canvas/canvas-gradient-without-path.html

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::fill):
        (WebCore::CanvasRenderingContext2D::stroke):

2008-12-13  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix.

        * platform/graphics/wx/ImageSourceWx.cpp:
        (WebCore::ImageSource::filenameExtension):

2008-12-12  Brent Fulgham  <bfulgham@gmail.com>

        Reviewed by Oliver Hunt.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22805

        Provides implementation of image dragging logic for Windows Cairo
        back-end.

        * platform/win/DragImageCGWin.cpp:
        (WebCore::deallocContext): Add a generic CGContextRef destructor.
        * platform/win/DragImageCairoWin.cpp:
        (WebCore::deallocContext): Add a generic cairo_* destructor. 
        (WebCore::allocImage):  New implementation to allocate a Cairo
        surface of a specified size.
        (WebCore::createCairoContextFromBitmap): New implementation to
        create a Cairo surface from a Windows BITMAP.
        (WebCore::scaleDragImage): Replace stub with implementation to
        actually create a scaled image.
        (WebCore::createDragImageFromImage): Replace stub with implementation
        to actually create an image.

2008-12-12  Dean Jackson  <dino@apple.com>

        Reviewed by Darin Adler.

        Expose WebKitAnimationEvent, WebKitTransitionEvent,
        WebKitCSSTransformValue, WebKitCSSKeyframeRule and
        WebKitCSSKeyframesRule to Window object.
        This required generating constructors for the event
        interfaces.
        
        https://bugs.webkit.org/show_bug.cgi?id=20560

        * dom/WebKitAnimationEvent.idl:
        * dom/WebKitTransitionEvent.idl:
        * page/DOMWindow.idl:

2008-12-12  Dave Moore  <davemoore@google.com>

        Reviewed by Eric Seidel.

        Fixed https://bugs.webkit.org/show_bug.cgi?id=22798

        In Font::drawTextUsingSVGFont() a variable of type SVGTextRunWalkerDrawTextData
        is created on the stack (called data). One of its fields, charsConsumed, is
        unitialized, leading to random values after calling walk() on the
        SVGTextRunWalker created with it. I now initialize the variable

        This bug was revealed in our Purify run. I don't know of any specific incorrect
        behavior caused by it but it would lead to the charsConsumed field having a
        a wrong value.

        * svg/SVGFont.cpp:
        (WebCore::Font::drawTextUsingSVGFont):

2008-12-12  Beth Dakin  <bdakin@apple.com>

        Rubber Stamped by Steve Falkenburg.

        Build fix.

        * platform/KURL.h:

2008-12-12  Brett Wilson  <brettw@chromium.org>

        Reviewed by Darin Adler.

        Add the ability so that Google-URL can optionally be used in a build
        of WebKit without changing the shared header. The guts of KURL are
        optionally ifdefed out, and the replacement code goes in a different
        header to avoid polluting KURL.h

        * platform/KURL.cpp:
        * platform/KURL.h:
        (WebCore::KURL::string):
        (WebCore::KURL::operator const String&):
        (WebCore::KURL::operator JSC::UString):
        (WebCore::KURL::operator NSString*):
        (WebCore::KURL::parsed):
        (WebCore::KURL::utf8String):
        (WebCore::KURL::isNull):
        (WebCore::KURL::isEmpty):
        (WebCore::KURL::isValid):
        (WebCore::KURL::hostStart):
        (WebCore::KURL::hostEnd):
        (WebCore::KURL::pathStart):
        (WebCore::KURL::pathEnd):
        (WebCore::KURL::pathAfterLastSlash):

2008-12-11  Steve Falkenburg  <sfalken@apple.com>

        Delete the previous timer-queue timer in the main thread, just prior to scheduling a new timer.
        The code previously called DeleteTimerQueueTimer in the timer callback proc.
        
        The new technique simplifies the code, since we now create and delete timers on the
        same thread, and don't access the timer queue or timer handles in the callback.
        This allows us to remove some mutex use, and more importantly, it solves a race
        condition that was occuring between ChangeTimerQueueTimer and DeleteTimerQueueTimer.
        
        Since the timer callback isn't passed the timer handle, we were retrieving that handle
        via a global. If the timer callback code was entered, but then a new timer was immediately
        scheduled (prior to the callback acquiring the mutex and calling DeleteTimerQueueTimer),
        there was a small window where the timer could be re-scheduled via ChangeTimerQueueTimer
        and then immediately deleted once the already running callback acquired the mutex and
        then called DeleteTimerQueueTimer. This resulted in the newly scheduled timer never firing.
        
        Reviewed by Oliver Hunt.

        * platform/win/SharedTimerWin.cpp:
        (WebCore::queueTimerProc): Don't delete the timer in the callback.
        (WebCore::setSharedTimerFireTime): Always delete and create the timer instead of using ChangeTimerQueueTimer.
        (WebCore::stopSharedTimer): Call DeleteTimerQueueTimer directly.

2008-12-12  Kai Brüning  <kai@granus.net>

        Reviewed and tweaked by Darin Adler.

        - fix https://bugs.webkit.org/show_bug.cgi?id=18205
          DOMNode objects are garbage collected although there are strong references
          <rdar://problem/6441200>

        Fixes resurrection bug for wrapper objects by using an NSMapTable with zeroing weak
        memory for the wrapper reference for DOMWrapperCache (DOMInternal.mm),
        JSWrapperCache (WebScriptObject.mm) and wrapperCache (DOMRGBColor.mm).
        BUILDING_ON_TIGER is used to create a Leopard-only NSMapTable or an old-style
        procedural map table for Tiger systems.

        No regression tests yet since we don't currently run any tests in GC mode.

        * bindings/objc/DOMInternal.h: added WebCore::createWrapperCache for use by all three caches
        * bindings/objc/DOMInternal.mm:
        (WebCore::createWrapperCache): Contains the compile-time check for map table creation
        (WebCore::getDOMWrapper): HashMap -> NSMapTable
        (WebCore::addDOMWrapper): ditto
        (WebCore::removeDOMWrapper): ditto
        * bindings/objc/DOMObject.mm: removed [DOMObject finalize]
        * bindings/objc/DOMRGBColor.mm: removed [DOMRGBColor finalize]
        (WebCore::getWrapperForRGB): CFMutableDictionaryRef -> NSMapTable
        (WebCore::setWrapperForRGB): ditto
        (WebCore::removeWrapperForRGB): ditto
        * bindings/objc/WebScriptObject.mm:
        (WebCore::getJSWrapper): HashMap -> NSMapTable
        (WebCore::addJSWrapper): ditto
        (WebCore::removeJSWrapper): ditto
        (-[WebScriptObject finalize]): removed call of removeJSWrapper()

2008-12-12  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=22813
        Remove unused references to JSDOMBinding, CallFrame, and JSLock.

        * dom/Node.cpp: Removed CallFrame and JSLock header includes.
        * loader/FrameLoader.cpp: Removed JSDOMBinding header include.

2008-12-12  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        Update the WebKit.qrc and add a script to automatically generate the file.

        With the way rcc and qmake work this can not be done at build time
        as the WebKit.qrc must sit inside the directory that contains the files
        and at build time we may not change the content of the source directory.

        * inspector/front-end/WebKit.qrc: Updated with new script

2008-12-12  Oliver Hunt  <oliver@apple.com>

        Reviewed by Alexey Proskuryakov.

        REGRESSION: Canvas is broken in high dpi mode
        <rdar://problem/6432739> <https://bugs.webkit.org/show_bug.cgi?id=22823>

        Simply made sure that we correctly scale the graphics context to
        account for the difference between logical and buffer resolution.

        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::createImageBuffer):
        (WebCore::HTMLCanvasElement::baseTransform):

2008-12-12  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Rubber-stamped by Oliver Hunt.

        Share PluginView::paintMissingPluginIcon() between ports

        Also, enable this feature for Qt/X11, Qt/Mac and GTK

        * plugins/PluginView.cpp:
        (WebCore::PluginView::paintMissingPluginIcon):
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::paint):
        * plugins/mac/PluginViewMac.cpp:
        (WebCore::PluginView::paint):
        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::paint):
        * plugins/win/PluginViewWin.cpp:

2008-12-12  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        [Qt/Mac] Implement PluginView::updatePluginWidget()

        We should update the window and clip rect regardless of whether or
        not the plugin has been loaded, for example to ensure that the
        missing plugin image is placed correctly.

        * plugins/mac/PluginViewMac.cpp:
        (WebCore::PluginView::setNPWindowIfNeeded):
        (WebCore::PluginView::updatePluginWidget):

2008-12-12  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Rubber-stamped by Oliver Hunt.

        Make PluginView::updatePluginWidget() non-const

        We can do this now since frameRectsChanged() is no longer const. This
        also allows us to get rid of the mutables in the PluginView.

        * platform/qt/TemporaryLinkStubs.cpp:
        (PluginView::updatePluginWidget):
        * plugins/PluginView.h:
        * plugins/gtk/PluginViewGtk.cpp:
        (WebCore::PluginView::updatePluginWidget):
        * plugins/mac/PluginViewMac.cpp:
        (WebCore::PluginView::updatePluginWidget):
        * plugins/qt/PluginViewQt.cpp:
        (WebCore::PluginView::updatePluginWidget):
        * plugins/win/PluginViewWin.cpp:
        (WebCore::PluginView::updatePluginWidget):
        * plugins/wx/PluginViewWx.cpp:
        (WebCore::PluginView::updatePluginWidget):

2008-12-12  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Simon Hausmann.

        Implement ImageSource::filenameExtension() for the Qt port
        
        We're using QImageReader::imageFormat().toLower() to check
        that the image format is supported, and if it is we store
        the resulting extension when creating the ImageDecoderQt.

        * platform/graphics/qt/ImageDecoderQt.cpp:
        (WebCore::ImageDecoderQt::create):
        (WebCore::ImageDecoderQt::ImageDecoderQt):
        (WebCore::ImageDecoderQt::imageFormat):
        * platform/graphics/qt/ImageDecoderQt.h:
        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::ImageSource::setData):
        (WebCore::ImageSource::filenameExtension):

2008-12-11  Stephanie Lewis  <slewis@apple.com>

        Reviewed by Geoff Garen

        Account for the size of the response and request headers as well as other overhead
        when calculating the size a resource takes up in the cache.  Halts unbounded 
        growth in the cache.  Reduced stress test memory high water marks by > 50%.

        Uses estimates gathered from the stress test to set the overhead size.  
        A version of the patch was created that calculated most of the sizes, but it was 
        decided that the patch was still at a basic level an estimate.  What gains it made
        in accuracy was offset by the complexity involved in creating and updating the
        estimate.

        * loader/Cache.cpp:
        (WebCore::Cache::resourceAccessed):
        (WebCore::Cache::TypeStatistic::addResource):
        (WebCore::Cache::dumpLRULists):
        * loader/CachedResource.cpp:
        (WebCore::CachedResource::overheadSize):
        * loader/CachedResource.h:
        (WebCore::CachedResource::size):

2008-12-11  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Holger Freyther.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22814

        Add <wml> image element support. Based on HTML/SVGImage{Element/Loader}, with
        the only difference that WML defines a second source attribute 'localsrc', that
        takes precedence over the 'src' attribute. If loading the 'localsrc' attribute
        fails, the user agent should try loading the 'src' attribute. If both fail the
        'alt' fallback content will be used - just like in HTML.

        Fixes: fast/wml/img-localsrc.wml (<img> and 'localsrc' attribute)
               fast/wml/img-src-localsrc-alt.wml ('localsrc'/'src' fallback handling)
               fast/wml/img-src.wml (<img> and 'src' attribute)

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * rendering/HitTestResult.cpp:
        (WebCore::HitTestResult::altDisplayString):
        (WebCore::HitTestResult::absoluteImageURL):
        * rendering/RenderImage.cpp:
        (WebCore::RenderImage::updateAltText):
        * wml/WMLImageElement.cpp: Added.
        (WebCore::WMLImageElement::WMLImageElement):
        (WebCore::WMLImageElement::~WMLImageElement):
        (WebCore::WMLImageElement::mapToEntry):
        (WebCore::WMLImageElement::parseMappedAttribute):
        (WebCore::WMLImageElement::attach):
        (WebCore::WMLImageElement::createRenderer):
        (WebCore::WMLImageElement::insertedIntoDocument):
        (WebCore::WMLImageElement::isURLAttribute):
        (WebCore::WMLImageElement::imageSourceAttributeName):
        (WebCore::WMLImageElement::altText):
        * wml/WMLImageElement.h: Added.
        (WebCore::WMLImageElement::useFallbackAttribute):
        (WebCore::WMLImageElement::setUseFallbackAttribute):
        * wml/WMLImageLoader.cpp: Added.
        (WebCore::WMLImageLoader::WMLImageLoader):
        (WebCore::WMLImageLoader::~WMLImageLoader):
        (WebCore::WMLImageLoader::dispatchLoadEvent):
        (WebCore::WMLImageLoader::sourceURI):
        (WebCore::WMLImageLoader::notifyFinished):
        * wml/WMLImageLoader.h: Added.
        * wml/WMLTagNames.in:

2008-12-11  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22043

        Do not run into the WebCore::DocumentLoader::updateLoading
        ASSERT on Gtk+/CURL when trying to load tests from our LayoutTests.

        Do not call setPrimaryLoadComplete when the
        activeDocumentLoader has already been replaced. This can happen
        when a script executed from within FramerLoader::didFinishLoading will
        navigate to another URL.

        The assertion is caused by existing tests (e.g.
        fast/history/clicked-link-is-visited.html) reproducing this with
        network backends not equal to curl is tough or maybe not
        even possible.

        * loader/DocumentLoader.cpp:
        (WebCore::DocumentLoader::setPrimaryLoadComplete):

2008-12-11  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Eric Seidel.

        - Remove some dead, commented-out code from WMLAElement.
        - Add missing virtual destructor for <noop>, as suggested by Alexey.
        - Refactor addHTMLAlignment in a static helper function to share with WML.

        * html/HTMLElement.cpp:
        (WebCore::HTMLElement::addHTMLAlignment):
        (WebCore::HTMLElement::addHTMLAlignmentToStyledElement):
        * html/HTMLElement.h:
        * wml/WMLAElement.cpp:
        (WebCore::WMLAElement::defaultEventHandler):
        * wml/WMLNoopElement.cpp:
        (WebCore::WMLNoopElement::~WMLNoopElement):
        * wml/WMLNoopElement.h:

2008-12-10  Oliver Hunt  <oliver@apple.com>

        Reviewed by Adele Peterson.

        <rdar://problem/6302405> Crash (null-deref) when using :before pseudoselector with content CSS rule in SVG
        <https://bugs.webkit.org/show_bug.cgi?id=22804>

        This issue was caused by css generated content resulting in non-svg flowboxes
        being injected into SVG content.  As SVG spec does not describe behaviour in
        this case, and neither Opera nor Firefox displays such generated content, so
        now we make svg text layout and rendering just ignore any such content.

        Test: svg/css/crash-css-generated-content.xhtml

        * rendering/SVGRootInlineBox.cpp:
        (WebCore::SVGRootInlineBox::buildLayoutInformation):
        (WebCore::SVGRootInlineBox::layoutInlineBoxes):
        (WebCore::SVGRootInlineBox::buildTextChunks):

2008-12-11  Cameron Zwarich  <zwarich@apple.com>

        Reviewed by Dave Hyatt.

        Bug 21256: REGRESSION (r36906): horizontally repeating image leaves ghosts when vertical scrolling
        <https://bugs.webkit.org/show_bug.cgi?id=21256>
        <rdar://problem/6362978>

        The ScrollView refactoring in r36906 caused the ScrollView and the
        platform widget to disagree about whether optimizing scrolling via
        blitting is allowed. The easiest way to fix this is to make ScrollView
        simply ask the platform widget whether this is safe on platforms that
        are affected.

        It is not possible to write a layout test for this bug because it
        involves the back/forward cache.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::ScrollView):
        (WebCore::ScrollView::setCanBlitOnScroll):
        (WebCore::ScrollView::canBlitOnScroll):
        (WebCore::ScrollView::platformSetCanBlitOnScroll):
        (WebCore::ScrollView::platformCanBlitOnScroll):
        * platform/ScrollView.h:
        * platform/mac/ScrollViewMac.mm:
        (WebCore::ScrollView::platformSetCanBlitOnScroll):
        (WebCore::ScrollView::platformCanBlitOnScroll):
        * platform/wx/ScrollViewWx.cpp:
        (WebCore::ScrollView::platformSetCanBlitOnScroll):
        (WebCore::ScrollView::platformCanBlitOnScroll):

2008-12-11  Brent Fulgham  <bfulgham@gmail.com>

        Reviewed by Adam Roben.

        https://bugs.webkit.org/show_bug.cgi?id=22808

        Correct build break due to malformed XML in Visual Studio project
        following @r39205 change.

        * WebCore.vcproj/WebCore.vcproj: Correct file entry so project loads.

2008-12-10  Chris Marrin  <cmarrin@apple.com>

        Reviewed by Dave Hyatt.

        Fixed https://bugs.webkit.org/show_bug.cgi?id=22738

        This gets rid of the per-animation timers which were used when an animation
        started, ended and looped. Their job is now done by the main AnimationController's
        timer. It is now set to fire as needed. For instance, if there is a delay, it will
        fire after the delay time and then every 30ms to run the animation. The start, loop
        and end events are generated as needed during the firing of this timer.

        I had to add one more bit of code. When animation timers used to fire the animation events.
        This would always happen from the RunLoop, so any style changes that happened in the
        event handler would get picked up on the next updateRendering() call. But now the start
        event is generated during the styleIsAvailable() call, which is in the middle of the 
        updateRendering() cycle. And calling an event handler in the middle of updateRendering()
        is not allowed and causes style changes to get missed. We already have a mechanism in
        AnimationController to defer updateRendering() calls. So I added logic to defer all
        event handling to there. Now, I put any request for event handling into a list and ask
        for a deferred updateRendering() call. When that deferred timer fires, I go through that
        list, send all the events and then call updateRendering().

        * page/animation/AnimationBase.cpp:
        (WebCore::AnimationBase::AnimationBase):
        (WebCore::AnimationBase::updateStateMachine):
        (WebCore::AnimationBase::fireAnimationEventsIfNeeded):
        (WebCore::AnimationBase::willNeedService):
        (WebCore::AnimationBase::goIntoEndingOrLoopingState):
        * page/animation/AnimationBase.h:
        * page/animation/AnimationController.cpp:
        (WebCore::AnimationControllerPrivate::updateAnimationTimer):
        (WebCore::AnimationControllerPrivate::updateRenderingDispatcherFired):
        (WebCore::AnimationControllerPrivate::addEventToDispatch):
        (WebCore::AnimationControllerPrivate::animationTimerFired):
        (WebCore::AnimationController::addEventToDispatch):
        * page/animation/AnimationController.h:
        * page/animation/CompositeAnimation.cpp:
        (WebCore::CompositeAnimationPrivate::updateTransitions):
        (WebCore::CompositeAnimationPrivate::willNeedService):
        (WebCore::CompositeAnimationPrivate::getAnimationForProperty):
        (WebCore::CompositeAnimation::willNeedService):
        (WebCore::CompositeAnimation::getAnimationForProperty):
        * page/animation/CompositeAnimation.h:
        * page/animation/ImplicitAnimation.cpp:
        (WebCore::ImplicitAnimation::animate):
        (WebCore::ImplicitAnimation::onAnimationEnd):
        (WebCore::ImplicitAnimation::sendTransitionEvent):
        * page/animation/ImplicitAnimation.h:
        * page/animation/KeyframeAnimation.cpp:
        (WebCore::KeyframeAnimation::animate):
        (WebCore::KeyframeAnimation::sendAnimationEvent):
        * page/animation/KeyframeAnimation.h:
        (WebCore::KeyframeAnimation::setUnanimatedStyle):

2008-12-11  Simon Hausmann  <simon.hausmann@nokia.com>

        Fix the Qt build with an empty filenameExtension() implementation.

        * platform/graphics/qt/ImageSourceQt.cpp:
        (WebCore::ImageSource::filenameExtension):

2008-12-11  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        Fix crash in the cairo implementation of the SVGPaintServer

        For SVGFonts the RenderObject can be zero. The existing SVGFont
        test cases is exposing this bug. Qt and other ports have fixed
        this issue by adding null checks as well.

        * svg/graphics/cairo/SVGPaintServerCairo.cpp:
        (WebCore::SVGPaintServer::renderPath):

2008-12-11  Holger Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        https://bugs.webkit.org/show_bug.cgi?id=20953

        Make the Qt port follow the Win, Mac, Gtk+ port in regard to Font
        handling. FontQt.cpp from now on is only implementing the complex path. Create
        FontFallbackListQt.cpp and FontPlatformDataQt.cpp to work within
        the framework set by the Font code.

        Sharing the Font.cpp implementation allows the Qt port to support
        the CSS font faces and SVG fonts.

        Split out the Qt4.3 Font handling into FonQt43.cpp to allow to more
        easily deprecate it.

        This commit is removing a lot of #ifdefs from Font.h as the Qt Font
        implementation is now in line with the rest of WebCore.

        * WebCore.pro:
        * platform/graphics/Font.h: Remove #ifdefs
        (WebCore::Font::letterSpacing):
        (WebCore::Font::setLetterSpacing):
        (WebCore::Font::isPlatformFont):
        * platform/graphics/FontFallbackList.h:
        * platform/graphics/SimpleFontData.cpp:
        (WebCore::SimpleFontData::SimpleFontData):
        (WebCore::SimpleFontData::platformGlyphInit): There is no GlyphCache
        on Qt, move the initialisation over.
        (WebCore::SimpleFontData::~SimpleFontData):
        * platform/graphics/SimpleFontData.h:
        (WebCore::SimpleFontData::getQtFont):
        * platform/graphics/qt/FontCacheQt.cpp:
        (WebCore::FontCache::getCachedFontPlatformData): Remove unused parameter
        (WebCore::FontCache::releaseFontData): Add to build
        * platform/graphics/qt/FontCustomPlatformData.cpp:
        (WebCore::FontCustomPlatformData::~FontCustomPlatformData):
        (WebCore::FontCustomPlatformData::fontPlatformData):
        (WebCore::createFontCustomPlatformData):
        * platform/graphics/qt/FontCustomPlatformData.h:
        * platform/graphics/qt/FontFallbackListQt.cpp: Added.
        (WebCore::FontFallbackList::FontFallbackList):
        (WebCore::FontFallbackList::invalidate):
        (WebCore::FontFallbackList::releaseFontData):
        (WebCore::FontFallbackList::determinePitch):
        (WebCore::FontFallbackList::fontDataAt):
        (WebCore::FontFallbackList::fontDataForCharacters):
        (WebCore::FontFallbackList::setPlatformFont):
        * platform/graphics/qt/FontPlatformData.h:
        (WebCore::FontPlatformData::font):
        (WebCore::FontPlatformData::size):
        * platform/graphics/qt/FontPlatformDataQt.cpp: Added.
        (WebCore::FontPlatformData::FontPlatformData):
        * platform/graphics/qt/FontQt.cpp:
        (WebCore::Font::drawComplexText):
        (WebCore::Font::floatWidthForComplexText):
        (WebCore::Font::offsetForPositionForComplexText):
        (WebCore::Font::selectionRectForComplexText):
        (WebCore::Font::font):
        * platform/graphics/qt/FontQt43.cpp: Added. Moved Qt4.3 code from FontQt.cpp
        (WebCore::Font::drawComplexText):
        (WebCore::Font::floatWidthForComplexText):
        (WebCore::Font::offsetForPositionForComplexText):
        (WebCore::Font::selectionRectForComplexText):
        * platform/graphics/qt/GlyphPageTreeNodeQt.cpp:
        (WebCore::GlyphPageTreeNode::pruneTreeCustomFontData):
        (WebCore::GlyphPageTreeNode::pruneTreeFontData):
        * platform/graphics/qt/SimpleFontDataQt.cpp:
        (WebCore::SimpleFontData::determinePitch):
        (WebCore::SimpleFontData::containsCharacters):
        (WebCore::SimpleFontData::platformInit):
        (WebCore::SimpleFontData::platformGlyphInit):
        (WebCore::SimpleFontData::platformDestroy):
        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::adjustButtonStyle): Avoid crashes.

2008-12-11  Holger Freyther  <zecke@selfish.org>

        Reviewed by Simon Hausmann.

        https://bugs.webkit.org/show_bug.cgi?id=20953

        For Qt it is not pratical to have a FontCache and GlyphPageTreeNode
        implementation. This is one of the reasons why the Qt port is currently not
        using WebCore/platform/graphics/Font.cpp. By allowing to not use
        the simple/fast-path the Qt port will be able to use it.

        Introduce USE(FONT_FAST_PATH) and define it for every port but the
        Qt one.

        * platform/graphics/Font.cpp:
        (WebCore::Font::drawText):
        (WebCore::Font::floatWidth):
        (WebCore::Font::selectionRectForText):
        (WebCore::Font::offsetForPosition):
        * platform/graphics/Font.h:

2008-12-11  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=20953

        Split out the font fast path from Fast.cpp into FontFastPath.cpp. This
        will allow the Qt port to share most of WebCore::Font
        implementation but the fast path. Qt does not provide the API to get
        individual Glyphs making the fast path hard to support.


        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * WebCoreSources.bkl:
        * platform/graphics/Font.cpp:
        * platform/graphics/FontFastPath.cpp: Added.
        (WebCore::Font::glyphDataForCharacter):

2008-12-11  Robert Carr  <racarr@svn.gnome.org>

        Reviewed by Holger Freyther.

        https://bugs.webkit.org/show_bug.cgi?id=22560

        Code in PlatformScreenGtk for screenDepth and screenRect can not
        assume that the platformWindow for the widget has a valid "window"
        member. For example in the case of, a new browser view opening as a
        child of a GtkNotebook, but never being switched to, or manually
        realized. Solve by using the toplevel window of the widget, rather
        than the widget itself.

        * platform/gtk/PlatformScreenGtk.cpp:
        (WebCore::screenDepth):
        (WebCore::screenRect):

2008-12-08  Tor Arne Vestbø  <tavestbo@trolltech.com>

        Reviewed by Darin Adler and Holger Freyther.

        Make Widget::frameRectsChanged() and overrides non-const

        This will hopefully allow us to get rid of some of the mutables in
        the classes that react to the callback by changing their own state.

        * platform/ScrollView.cpp:
        (WebCore::ScrollView::frameRectsChanged):
        * platform/ScrollView.h:
        * platform/Widget.h:
        (WebCore::Widget::frameRectsChanged):
        * platform/gtk/ScrollbarGtk.cpp: Remove non-const version since
        this was more complex and did the same thing, changed const of
        the leftover frameRectsChanged() method.
        (ScrollbarGtk::frameRectsChanged):
        * platform/gtk/ScrollbarGtk.h:
        * plugins/PluginView.cpp:
        (WebCore::PluginView::frameRectsChanged):
        * plugins/PluginView.h:

2008-12-11  Holger Hans Peter Freyther  <zecke@selfish.org>

        Reviewed and implemented with Tor Arne Vestbø.

        Reimplement RenderTheme::caretBlinkInterval for Qt.

        The QApplication::cursorFlashTime is in milliseconds and describes
        the whole cycle while WebCore expects half a cycle.

        * platform/qt/RenderThemeQt.cpp:
        (WebCore::RenderThemeQt::caretBlinkInterval):
        * platform/qt/RenderThemeQt.h:

2008-12-09  Trenton Schulz <trenton.schulz@nokia.com>

        Reviewed by Tor Arne Vestbø.

        [Qt/Mac] Don't call HIGetScaleFactor() if we're not on Tiger or better

        * plugins/mac/PluginViewMac.cpp:
        (WebCore::tigerOrBetter):
        (WebCore::PluginView::globalMousePosForPlugin):

2008-12-10  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Eric Seidel and George Staikos.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22799

        Add WML <template> support. The <template> element is specified at deck-level
        and declares a template for all <card> elements in the document.

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * editing/htmlediting.cpp:
        (WebCore::canHaveChildrenForEditing): Treat <do> just like a <button>.
        * wml/WMLCardElement.cpp:
        (WebCore::WMLCardElement::WMLCardElement):
        (WebCore::WMLCardElement::setTemplateElement):
        (WebCore::WMLCardElement::handleIntrinsicEventIfNeeded):
        (WebCore::WMLCardElement::handleDeckLevelTaskOverridesIfNeeded):
        * wml/WMLCardElement.h:
        (WebCore::WMLCardElement::templateElement):
        * wml/WMLDoElement.cpp:
        (WebCore::WMLDoElement::insertedIntoDocument):
        * wml/WMLDocument.cpp:
        (WebCore::WMLDocument::finishedParsing):
        * wml/WMLErrorHandling.cpp:
        (WebCore::errorMessageForErrorCode):
        * wml/WMLErrorHandling.h:
        (WebCore::):
        * wml/WMLEventHandlingElement.cpp:
        (WebCore::WMLEventHandlingElement::~WMLEventHandlingElement):
        * wml/WMLEventHandlingElement.h:
        (WebCore::WMLEventHandlingElement::doElements):
        * wml/WMLTagNames.in:
        * wml/WMLTemplateElement.cpp: Added.
        (WebCore::WMLTemplateElement::WMLTemplateElement):
        (WebCore::WMLTemplateElement::~WMLTemplateElement):
        (WebCore::WMLTemplateElement::parseMappedAttribute):
        (WebCore::WMLTemplateElement::registerTemplatesInDocument):
        * wml/WMLTemplateElement.h: Added.
        * wml/WMLTimerElement.cpp:
        (WebCore::WMLTimerElement::timerFired):

2008-12-09  Dmitry Titov  <dimich@chromium.org>

        Reviewed by Darin Adler.

        Fix memory leak - need to call stopActiveDOMObjects
        when cached pages get destroyed.
        https://bugs.webkit.org/show_bug.cgi?id=22753

        * dom/Document.cpp:
        (WebCore::Document::detach):

2008-12-10  Alice Liu  <alice.liu@apple.com>

        Manual test for https://bugs.webkit.org/show_bug.cgi?id=20685

        Reviewed by Darin Adler.

        * manual-tests/drag-image-to-desktop.html: Added.

2008-12-10  Alice Liu  <alice.liu@apple.com>

        fixed https://bugs.webkit.org/show_bug.cgi?id=20685

        Reviewed by Darin Adler.

        Manual test case is manual-tests/drag-image-to-desktop.html

        Added new files to projects
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:

        * page/DragController.cpp:
        (WebCore::DragController::startDrag):
        * platform/MIMETypeRegistry.cpp:
        (WebCore::initializeSupportedImageMIMETypes):
        (WebCore::initializeSupportedImageMIMETypesForEncoding):

        These changes add a method to obtain the extension for an image
        * platform/graphics/BitmapImage.cpp:
        (WebCore::BitmapImage::filenameExtension):
        * platform/graphics/BitmapImage.h:
        * platform/graphics/Image.h:
        (WebCore::Image::filenameExtension):
        * platform/graphics/ImageSource.h:
        * platform/graphics/cairo/ImageSourceCairo.cpp:
        (WebCore::ImageSource::filenameExtension):
        * platform/graphics/cg/ImageSourceCG.cpp:
        (WebCore::ImageSource::filenameExtension):

        These changes added a utility that returns the preferred extension for a UTI
        * platform/graphics/cg/ImageSourceCG.h: Added.
        * platform/graphics/cg/ImageSourceCGMac.mm: Added.
        (WebCore::MIMETypeForImageSourceType):
        (WebCore::preferredExtensionForImageSourceType):
        * platform/graphics/cg/ImageSourceCGWin.cpp: Added.
        (WebCore::MIMETypeForImageSourceType):
        (WebCore::preferredExtensionForImageSourceType):

        * platform/mac/MIMETypeRegistryMac.mm:
        moved getMIMETypeForUTI to ImageSourceCGMac.mm

        Ask image for its file extension instead of relying on MIME type and file path
        * platform/win/ClipboardWin.cpp:
        (WebCore::createGlobalImageFileDescriptor):

        Remove extraneous code from getPreferredExtensionForMIMEType.
        Also moved getMIMETypeForUTI to ImageSourceCGWin.cpp
        * platform/win/MIMETypeRegistryWin.cpp:
        (WebCore::MIMETypeRegistry::getPreferredExtensionForMIMEType):

2008-12-10  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Antti Koivisto

        <rdar://problem/6431224>
        
        When updating the value of a slider, don't mark the parents
        as needing layout, because the size of the slider can never
        change. This fixes full-page repaints in some cases.

        * rendering/RenderSlider.cpp:
        (WebCore::RenderSlider::updateFromElement):

2008-12-10  Simon Fraser  <simon.fraser@apple.com>

        Potential build fix. The forward declaration of FloatPoint should
        be inside the WebCore namespace.
        
        * platform/graphics/FloatPoint3D.h:

2008-12-10  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Sam Weinig.

        https://bugs.webkit.org/show_bug.cgi?id=22793

        Cleanup FloatPoint3D: inline the getters and setters,
        fix a potential divide-by-zero in normalize(), and add
        a FloatPoint constructor.
        
        * platform/graphics/FloatPoint3D.cpp:
        (WebCore::FloatPoint3D::FloatPoint3D):
        (WebCore::FloatPoint3D::normalize):
        * platform/graphics/FloatPoint3D.h:
        (WebCore::FloatPoint3D::x):
        (WebCore::FloatPoint3D::setX):
        (WebCore::FloatPoint3D::y):
        (WebCore::FloatPoint3D::setY):
        (WebCore::FloatPoint3D::z):
        (WebCore::FloatPoint3D::setZ):

2008-12-09  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Eric Seidel.

        Bug 22665: Remove setCreatedByParser(bool) from the few elements that use it
        https://bugs.webkit.org/show_bug.cgi?id=22665

        - Removed setCreatedByParser from style and link elements.

        - Removed XMLTokenizer::eventuallyMarkAsCreatedByParser.

        * dom/XMLTokenizer.cpp:
        * dom/XMLTokenizer.h:
        * dom/XMLTokenizerLibxml2.cpp:
        (WebCore::XMLTokenizer::startElementNs):
        * dom/XMLTokenizerQt.cpp:
        (WebCore::XMLTokenizer::parseStartElement):
        * html/HTMLElementFactory.cpp:
        (WebCore::linkConstructor):
        (WebCore::styleConstructor):
        * html/HTMLLinkElement.cpp:
        (WebCore::HTMLLinkElement::HTMLLinkElement):
        * html/HTMLLinkElement.h:
        * html/HTMLStyleElement.cpp:
        (WebCore::HTMLStyleElement::HTMLStyleElement):
        * html/HTMLStyleElement.h:
        * html/HTMLTagNames.in:
        * svg/SVGStyleElement.cpp:
        (WebCore::SVGStyleElement::SVGStyleElement):
        * svg/SVGStyleElement.h:
        * svg/svgtags.in:

2008-12-10  Brady Eidson  <beidson@apple.com>

        Reviewed by Darin

        https://bugs.webkit.org/show_bug.cgi?id=22194 and <rdar://problem/6388378> -
        Dialog when going back to a page from whence you submitted a form

        http://trac.webkit.org/changeset/37317 changed the manner in which headers are added to
        http requests, which caused the networking layer to have an incomplete set of headers
        just before consulting the Policy Delegate.  This caused a cache miss and incorrectly made
        us believe we'd be resubmitting the form.

        * loader/FrameLoader.cpp:
        (WebCore::FrameLoader::loadItem):  Being careful to maintain the new behavior required by
          the Origin header mechanism as discussed in bug 22194, restore the previous behavior of
          setting all the headers before the networking layer is asked about the cache lookup.

2008-12-10  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Timothy Hatcher.

        Add back ability to end all profiling via console by invoking profileEnd
        with no arguments.

        * page/Console.cpp:
        (WebCore::Console::profileEnd): Removed title null-checking and
            subsequent early exit.

2008-12-10  Pierre-Olivier Latour  <pol@apple.com>

        Reviewed by Darin Adler.

        KeyframeAnimation::animate() needs to compute the elapsed animation time
        properly taking into account its paused state.

        https://bugs.webkit.org/show_bug.cgi?id=22773

        Test: animations/animation-drt-api-multiple-keyframes.html

        * page/animation/KeyframeAnimation.cpp:
        (WebCore::KeyframeAnimation::animate):

2008-12-10  Simon Fraser  <simon.fraser@apple.com>

        Reviewed by Dan Bernstein

        Part of
        https://bugs.webkit.org/show_bug.cgi?id=22570
        
        Rename methods on RenderLayer for clarity:
            clearClipRects -> clearClipRectsIncludingDescendants
            clearClipRect  -> clearClipRects

        * rendering/RenderBox.cpp:
        (WebCore::RenderBox::destroy):
        * rendering/RenderLayer.cpp:
        (WebCore::RenderLayer::updateLayerPosition):
        (WebCore::RenderLayer::removeOnlyThisLayer):
        (WebCore::RenderLayer::insertOnlyThisLayer):
        (WebCore::RenderLayer::clearClipRectsIncludingDescendants):
        (WebCore::RenderLayer::clearClipRects):
        * rendering/RenderLayer.h:
        * rendering/RenderObject.cpp:
        (WebCore::RenderObject::styleWillChange):
        * rendering/RenderWidget.cpp:
        (WebCore::RenderWidget::destroy):

2008-12-10  Kevin Ollivier  <kevino@theolliviers.com>

        wx build fix after the script call stack/frame additions.
        
        * WebCoreSources.bkl:

2008-12-10   Srinivasa Rao M. Hamse  <msrinirao@gmail.com>

        Reviewed by Holger Freyther.

        F1-F12 key mappings for WebKit Gtk Port

        * platform/gtk/KeyEventGtk.cpp:
        (WebCore::windowsKeyCodeForKeyEvent):

2008-12-10  Enrico Ros  <enrico.ros@m31.com>

        Reviewed by Simon Hausmann.

        Fix the Qt build when SVG is disabled. A broken dependancy caused
        unnecessary rebuilds even with no changes.

        * WebCore.pro: fix a broken build dependancy

2008-12-10  Hironori Bono  <hbono@chromium.org>

        Reviewed by Alexey Proskuryakov.

        Bug 21820: Unable to enter the Tamil UNICODE Characters via Thamizha Phonetic IME
        https://bugs.webkit.org/show_bug.cgi?id=21820

        <rdar://problem/5683248> Typing backspace to delete a diacritical mark also deletes the character before (Arabic)
        <rdar://problem/5702038> Backspace removes Thai Character in wrong sequence

        Tests: editing/deleting/delete-ligature-001.html
               editing/deleting/delete-ligature-002.html
               editing/deleting/delete-ligature-003.html

        * editing/TypingCommand.cpp:
        (WebCore::TypingCommand::deleteKeyPressed): Delete only the last character
        of a ligature which consists of multiple Unicode characters when deleting it with
        a backspace key.

2008-12-10  David Levin  <levin@chromium.org>

        Reviewed by Alexey Proskuryakov.

        https://bugs.webkit.org/show_bug.cgi?id=22177
        Fix the windows build by removing calls to notifyFormStateChanged
        where they didn't appear in the original reviewed patch.

        * html/HTMLInputElement.cpp:
        (WebCore::HTMLInputElement::type):
        (WebCore::HTMLInputElement::attach):

2008-12-09  Adam Barth  <abarth@webkit.org>

        Reviewed by Sam Weinig.

        Add ScriptController::updateSecurityOrigin to notify the bindings
        that a document's securityOrigin has been updated.  This is used by
        V8 to update its security context.

        * bindings/js/ScriptController.cpp:
        (WebCore::ScriptController::updateSecurityOrigin):
        * bindings/js/ScriptController.h:
        * dom/Document.cpp:
        (WebCore::Document::setDomain):

2008-12-09  Eric Seidel  <eric@webkit.org>

        No review, build fix only.

        Fix a few config issues to let the Chromium Windows WebCore build get further.

        * WebCore.scons:

2008-12-09  Brett Wilson  <brettw@chromium.org>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22177

        Add a callback on ChromeClient that the state of form elements on
        the page has changed. This is to allow clients implementing session
        saving to know when the current state is dirty.

        * html/HTMLInputElement.cpp:
        (WebCore::notifyFormStateChanged):
        (WebCore::HTMLInputElement::setInputType):
        (WebCore::HTMLInputElement::type):
        (WebCore::HTMLInputElement::attach):
        (WebCore::HTMLInputElement::setValue):
        (WebCore::HTMLInputElement::setValueFromRenderer):
        (WebCore::HTMLInputElement::setFileListFromRenderer):
        * html/HTMLSelectElement.cpp:
        (WebCore::HTMLSelectElement::setSelectedIndex):
        * html/HTMLTextAreaElement.cpp:
        (WebCore::notifyFormStateChanged):
        (WebCore::HTMLTextAreaElement::HTMLTextAreaElement):
        (WebCore::HTMLTextAreaElement::updateValue):
        (WebCore::HTMLTextAreaElement::setValue):
        * loader/EmptyClients.h:
        (WebCore::EmptyChromeClient::formStateDidChange):
        * page/ChromeClient.h:

2008-12-09  Sam Weinig  <sam@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=19762

        Fix intermittent crash in buildbot. The CSSCursorImageValues and
        SVGCursorElements held onto raw SVGElement pointers without any
        guarantee that the element is still around.

        We did not fix the design that resulted in this issue, we just fixed
        the pointer lifetimes.

        * css/CSSCursorImageValue.cpp:
        (WebCore::CSSCursorImageValue::~CSSCursorImageValue): Zero out the back pointers.
        (WebCore::CSSCursorImageValue::updateIfSVGCursorIsUsed): Set up a back pointer.
        (WebCore::CSSCursorImageValue::removeReferencedElement): Added. Used when the element
        is destroyed.
        * css/CSSCursorImageValue.h: Added removeReferencedElement.

        * svg/SVGCursorElement.cpp:
        (WebCore::SVGCursorElement::~SVGCursorElement): Zero out the back pointers.
        (WebCore::SVGCursorElement::addClient): Set up a back pointer.
        (WebCore::SVGCursorElement::removeClient): Zero out the back pointer.

        * svg/SVGElement.cpp:
        (WebCore::SVGElement::SVGElement): Initialize back pointers to zero.
        (WebCore::SVGElement::~SVGElement): Call both the element and cursor image value
        to remove the element from their sets.
        * svg/SVGElement.h:
        (WebCore::SVGElement::setCursorElement): Added.
        (WebCore::SVGElement::setCursorImageValue): Added.

2008-12-09  David Hyatt  <hyatt@apple.com>

        Add code that will create custom CSS scrollbars from the <body>, the document element (<html>) and the owning
        frame/iframe.  If any of them set a custom style, it will be used.  The scrollbars do not update dynamically
        yet as you switch from page to page (until they are destroyed and recreated).

        Reviewed by Adele

        * page/FrameView.cpp:
        (WebCore::FrameView::createScrollbar):

2008-12-09  Ojan Vafai  <ojan@chromium.org>

        Reviewed by Dave Hyatt.

        https://bugs.webkit.org/show_bug.cgi?id=22689
        Match Firefox button metrics on Windows.

        * rendering/RenderButton.cpp:
        (WebCore::RenderButton::addChild):
        (WebCore::RenderButton::styleDidChange):
        (WebCore::RenderButton::setupInnerStyle):
        * rendering/RenderButton.h:
        * rendering/RenderTheme.cpp:
        (WebCore::RenderTheme::adjustButtonInnerStyle):
        * rendering/RenderTheme.h:
        * rendering/RenderThemeWin.cpp:
        (WebCore::RenderThemeWin::adjustSliderThumbSize):
        (WebCore::RenderThemeWin::adjustButtonInnerStyle):
        * rendering/RenderThemeWin.h:

2008-12-09  Darin Fisher  <darin@chromium.org>

        Fixes bustages.

        https://bugs.webkit.org/show_bug.cgi?id=22631
        Adding missing files from previous commit.

        * bindings/js/ScriptCallFrame.cpp: Added.
        (WebCore::ScriptCallFrame::ScriptCallFrame):
        (WebCore::ScriptCallFrame::~ScriptCallFrame):
        (WebCore::ScriptCallFrame::argumentAt):
        * bindings/js/ScriptCallFrame.h: Added.
        (WebCore::ScriptCallFrame::functionName):
        (WebCore::ScriptCallFrame::sourceURL):
        (WebCore::ScriptCallFrame::lineNumber):
        (WebCore::ScriptCallFrame::argumentCount):
        * bindings/js/ScriptCallStack.cpp: Added.
        (WebCore::ScriptCallStack::ScriptCallStack):
        (WebCore::ScriptCallStack::~ScriptCallStack):
        (WebCore::ScriptCallStack::at):
        (WebCore::ScriptCallStack::size):
        (WebCore::ScriptCallStack::initialize):
        * bindings/js/ScriptCallStack.h: Added.
        (WebCore::ScriptCallStack::state):

2008-12-09  Dimitri Glazkov  <dglazkov@chromium.org>

        Reviewed by Timothy Hatcher.

        https://bugs.webkit.org/show_bug.cgi?id=22631
        Streamline Console.cpp, abstract out the use of JSC::ExecState and
        JSC::ArgList by introducing ScriptCallFrame and ScriptCallStack
        abstractions.

        * GNUmakefile.am: Added ScriptCallFrame and ScriptCallStack to build
        * WebCore.pro:  Added ScriptCallFrame and ScriptCallStack to build
        * WebCore.vcproj/WebCore.vcproj: Added ScriptCallFrame and
        ScriptCallStack to project
        * WebCore.xcodeproj/project.pbxproj: Added ScriptCallFrame and
        ScriptCallStack to project
        * bindings/js/JSConsoleCustom.cpp: Remove custom bindings.
        * bindings/js/ScriptCallFrame.cpp: Added.
        (WebCore::ScriptCallFrame::ScriptCallFrame):
        (WebCore::ScriptCallFrame::~ScriptCallFrame):
        (WebCore::ScriptCallFrame::argumentAt):
        * bindings/js/ScriptCallFrame.h: Added.
        (WebCore::ScriptCallFrame::functionName):
        (WebCore::ScriptCallFrame::sourceURL):
        (WebCore::ScriptCallFrame::lineNumber):
        (WebCore::ScriptCallFrame::argumentCount):
        * bindings/js/ScriptCallStack.cpp: Added.
        (WebCore::ScriptCallStack::ScriptCallStack):
        (WebCore::ScriptCallStack::~ScriptCallStack):
        (WebCore::ScriptCallStack::at):
        (WebCore::ScriptCallStack::size):
        (WebCore::ScriptCallStack::initialize):
        * bindings/js/ScriptCallStack.h: Added.
        (WebCore::ScriptCallStack::ScriptCallStack):
        (WebCore::ScriptCallStack::~ScriptCallStack):
        (WebCore::ScriptCallStack::state):
        (WebCore::ScriptCallStack::at):
        (WebCore::ScriptCallStack::size):
        (WebCore::ScriptCallStack::initialize):
        * bindings/js/ScriptString.h: Added missing PlatformString include.
        (WebCore::ScriptString::ScriptString): Added default constructor.
        (WebCore::ScriptString::operator==): Added equality operator.
        (WebCore::ScriptString::operator!=):
        * bindings/js/ScriptValue.cpp: Added isNull and isUndefined.
        (WebCore::ScriptValue::isNull):
        (WebCore::ScriptValue::isUndefined):
        * bindings/js/ScriptValue.h: Added isNull and isUndefined
        * bindings/scripts/CodeGeneratorJS.pm: Add handling for
        CustomArgumentHandling attribute.
        * inspector/InspectorController.cpp: Refactored to use 
        ScriptCallFrame and ScriptCallStack.
        (WebCore::ConsoleMessage::ConsoleMessage):
        (WebCore::InspectorController::addMessageToConsole):
        (WebCore::InspectorController::startGroup):
        (WebCore::InspectorController::addScriptConsoleMessage):
        (WebCore::InspectorController::count):
        (WebCore::InspectorController::startTiming):
        (WebCore::InspectorController::stopTiming):
        * inspector/InspectorController.h: Refactored to use ScriptCallFrame and
        ScriptCallStack.
        * inspector/front-end/Console.js: Modified to use argument value itself
        rather than f.name for stack trace.
        * page/Console.cpp: Refactored to use ScriptCallFrame and
        ScriptCallStack.
        (WebCore::getFirstArgumentAsString):
        (WebCore::Console::addMessage):
        (WebCore::Console::debug):
        (WebCore::Console::error):
        (WebCore::Console::info):
        (WebCore::Console::log):
        (WebCore::Console::dir):
        (WebCore::Console::dirxml):
        (WebCore::Console::trace):
        (WebCore::Console::assertCondition):
        (WebCore::Console::count):
        (WebCore::Console::profile):
        (WebCore::Console::profileEnd):
        (WebCore::Console::time):
        (WebCore::Console::timeEnd):
        (WebCore::Console::group):
        (WebCore::Console::warn):
        * page/Console.h:
        * page/Console.idl: Removed Custom attributes, added
        CustomArgumentHandling attributes, and tweaked argument defs.

2008-12-09  Darin Adler  <darin@apple.com>

        Try to fix non-Mac builds.

        * GNUmakefile.am: Added NavigatorBase.
        * WebCore.pro: Ditto.
        * WebCore.scons: Ditto.
        * WebCore.vcproj/WebCore.vcproj: Ditto.
        * WebCoreSources.bkl: Ditto.

        Unrelated tweak sitting in my tree.

        * bindings/objc/DOMAbstractView.mm: Remove pointless override of finalize method.

2008-12-09  Darin Adler  <darin@apple.com>

        Try to fix Tiger build.

        * platform/network/mac/NetworkStateNotifierMac.cpp: Declare CFRunLoopGetMain.

2008-12-09  Alexey Proskuryakov  <ap@webkit.org>

        Reviewed by Darin Adler.

        https://bugs.webkit.org/show_bug.cgi?id=22719
        Implement Navigator object in Workers

        Test: fast/workers/worker-navigator.html

        * DerivedSources.make:
        * GNUmakefile.am:
        * WebCore.pro:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        Added WorkerNavigator sources.

        * bindings/js/JSWorkerContext.cpp: (WebCore::jsWorkerContextNavigator):
        Worker.navigator returns a WoerkerNavigator object (it is named just Navigator in the spec,
        but it is not the same interface that is available on Windows).

        * dom/Worker.cpp:
        (WebCore::Worker::notifyFinished):
        * dom/WorkerContext.cpp:
        (WebCore::WorkerContext::WorkerContext):
        (WebCore::WorkerContext::navigator):
        * dom/WorkerContext.h:
        (WebCore::WorkerContext::create):
        * dom/WorkerThread.cpp:
        (WebCore::WorkerThread::create):
        (WebCore::WorkerThread::WorkerThread):
        (WebCore::WorkerThread::workerThread):
        * dom/WorkerThread.h:
        Pass a pre-computed user agent string into worker, because it cannot call a client method
        directly, and pre-computing is easier than sending a synchronous message to the main thread.

        * page/Navigator.cpp:
        * page/Navigator.h:
        * page/NavigatorBase.cpp: Added.
        * page/NavigatorBase.h: Added.
        Factor out common (and uncommon, but very similar) functionality into a base class.

        * page/WorkerNavigator.cpp: Added.
        * page/WorkerNavigator.h: Added.
        * page/WorkerNavigator.idl: Added.
        Per Web Workers and HTML5, implement a small subset of what we currently have in Window.Navigator.

        * platform/network/NetworkStateNotifier.cpp: (WebCore::networkStateNotifier):
        Make networkStateNotifier() static constructor thread safe. The object is created on the
        thread it is first called from, while callbacks are registered on the main thread. Calls to
        onLine() from other threads are safe, because it is just loading a boolean.

        * platform/network/mac/NetworkStateNotifierMac.cpp: (WebCore::NetworkStateNotifier::NetworkStateNotifier):
        Schedule notifications on main event loop, not the current one.

2008-12-09  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Rubber-stamped by Alexey Proskuryakov.

        Forgot to update Qt/WML build - add some new files to the build.

        * WebCore.pro:

2008-12-09  Nikolas Zimmermann  <nikolas.zimmermann@torchmobile.com>

        Reviewed by Alexey Proskuryakov.

        Fixes: https://bugs.webkit.org/show_bug.cgi?id=22637

        Implement the GET method for WMLGoElement, and some test covering it's behaviour.
        Update all build systems supporting WML that haven't been updated since a while.

        Add WMLPostField stub implementation, needed for implementing POST method.

        Tests: wml/go-task-get-method-external-deck-with-href.html
               wml/go-task-get-method-external-deck.html
               wml/go-task-get-method-same-deck.html

        * GNUmakefile.am:
        * WebCore.vcproj/WebCore.vcproj:
        * WebCore.xcodeproj/project.pbxproj:
        * dom/Document.cpp:
        (WebCore::Document::resetWMLPageState):
        * wml/WMLCardElement.cpp:
        * wml/WMLCardElement.h:
        * wml/WMLEventHandlingElement.cpp:
        (WebCore::WMLCardElement::registerDoElement):
        * wml/WMLEventHandlingElement.h:
        * wml/WMLGoElement.cpp:
        (WebCore::WMLGoElement::WMLGoElement):
        (WebCore::WMLGoElement::registerPostfieldElement):
        (WebCore::WMLGoElement::parseMappedAttribute):
        (WebCore::WMLGoElement::executeTask):
        (WebCore::WMLGoElement::parseContentType):
        (WebCore::WMLGoElement::preparePOSTRequest):
        (WebCore::WMLGoElement::prepareGETRequest):
        * wml/WMLGoElement.h:
        * wml/WMLPostfieldElement.cpp: Added.
        (WebCore::WMLPostfieldElement::WMLPostfieldElement):
        (WebCore::WMLPostfieldElement::parseMappedAttribute):
        (WebCore::WMLPostfieldElement::insertedIntoDocument):
        * wml/WMLPostfieldElement.h: Added.
        (WebCore::WMLPostfieldElement::name):
        (WebCore::WMLPostfieldElement::value):
        * wml/WMLTagNames.in:

2008-12-08  Peter Kasting  <pkasting@google.com>

        Reviewed by Anders Carlsson.

        https://bugs.webkit.org/show_bug.cgi?id=16814
        Allow ports to disable ActiveX->NPAPI conversion for Media Player.
        Improve handling of miscellaneous ActiveX objects.

        * rendering/RenderPartObject.cpp:
        (WebCore::mapClassIdToServiceType):
        (WebCore::shouldUseChildEmbedOfObject):
        (WebCore::RenderPartObject::updateWidget):

2008-12-08  Darin Adler  <darin@apple.com>

        Reviewed by John Sullivan.

        - fix https://bugs.webkit.org/show_bug.cgi?id=22409
          REGRESSION: cmd-shift-left/right don't switch tabs, instead select text

        Tests: editing/execCommand/enabling-and-selection-2.html
               editing/execCommand/enabling-and-selection.html

        * editing/EditorCommand.cpp: Updated table to use these functions by their new names.
        (WebCore::enabledVisibleSelection): Renamed this to reflect its new algorithm.
        An invisible selection with a position that selects no characters doesn't count
        as a visible selection.
        (WebCore::enabledVisibleSelectionAndMark): Ditto.

2008-12-08  David Kilzer  <ddkilzer@apple.com>

        Remove duplicate entries from WebCore project.

        Reviewed by Eric Seidel.

        Bug 22555: Sort "children" sections in Xcode project files.
        <https://bugs.webkit.org/show_bug.cgi?id=22555>

        Recipe for removing duplicates:
        $ ./WebKitTools/Scripts/sort-Xcode-project-file project.pbxproj
        $ uniq < project.pbxproj | diff -u project.pbxproj - | patch -p0 project.pbxproj

        * WebCore.xcodeproj/project.pbxproj: Removed duplicates.

2008-12-08  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Darin Adler.

        Bug 22665: Remove setCreatedByParser(bool) from the few elements that use it
        https://bugs.webkit.org/show_bug.cgi?id=22665

        Remove setCreatedByParser from the script elements (HTML and SVG).

        * dom/XMLTokenizer.cpp:
        (WebCore::XMLTokenizer::eventuallyMarkAsParserCreated): Removed
        call to setCreatedByParser for the 2 elements.

        * dom/make_names.pl: Modified to call the constructor with
        the createByParser parameter if 'constructorNeedsCreatedByParser'
        is set.

        * html/HTMLElementFactory.cpp:
        (WebCore::scriptConstructor):
        * html/HTMLScriptElement.cpp:
        (WebCore::HTMLScriptElement::HTMLScriptElement):
        * html/HTMLScriptElement.h:
        * html/HTMLTagNames.in: Added constructorNeedsCreatedByParser
        to script.
        * svg/SVGScriptElement.cpp:
        (WebCore::SVGScriptElement::SVGScriptElement):
        * svg/SVGScriptElement.h:
        * svg/svgtags.in: Added constructorNeedsCreatedByParser
        to script.

2008-12-08  David Kilzer  <ddkilzer@apple.com>

        Bug 22555: Sort "children" sections in Xcode project files

        <https://bugs.webkit.org/show_bug.cgi?id=22555>

        Reviewed by Eric Seidel.

        * WebCore.xcodeproj/project.pbxproj: Sorted.
        * manual-tests/NPN_Invoke/NPN_Invoke.xcodeproj/project.pbxproj: Sorted.

2008-12-08  Tony Chang  <tony@chromium.org>

        Reviewed by Eric Seidel.

        Add a bool to GraphicsContext so that shadows can ignore
        transformations.  This is needed by HTML canvas element
        where the spec says shadows are applied w/o transformations.
        https://bugs.webkit.org/show_bug.cgi?id=22580

        No functional changes, thus no tests.

        * html/CanvasRenderingContext2D.cpp:
        (WebCore::CanvasRenderingContext2D::setShadow):
        (WebCore::CanvasRenderingContext2D::applyShadow):
        * html/HTMLCanvasElement.cpp:
        (WebCore::HTMLCanvasElement::createImageBuffer):
        * platform/graphics/GraphicsContext.cpp:
        (WebCore::GraphicsContext::setShadowsIgnoreTransforms):
        * platform/graphics/GraphicsContext.h:
        * platform/graphics/GraphicsContextPrivate.h:
        (WebCore::GraphicsContextState::GraphicsContextState):
        * platform/graphics/cg/GraphicsContextCG.cpp:
        (WebCore::GraphicsContext::setPlatformShadow):

2008-12-08  Julien Chaffraix  <jchaffraix@webkit.org>

        Reviewed by Darin Adler.

        Bug 17897: Not Rendering Images Imported from XHTML Document
        <rdar://problem/5827614>

        When we were loading document with XMLHttpRequest that contained images, the images
        would not be fetched as they would not be displayed. However if we inserted such
        an image element into a rendered document, we would not fetch the image and thus never
        display it.

        Now we check if the image has been loaded when we insert an HTMLImageElement into a
        document.
        To enable this, the image loader has an error flag. To avoid doing several attempts
        when we know that the image is in error, we store the failed URL.
